2008-08-10  Dan Bernstein  <mitz@apple.com>

        Reviewed by Eric Seidel.

        - fix https://bugs.webkit.org/show_bug.cgi?id=20339
          REGRESSION (r35531-r35615): Acid3 crashes on Windows in CachedFont::getSVGFontById

        * dom/make_names.pl: Removed "using namespace WebCore::*Names"
        from *ElementFactory.cpp files.        

2008-08-10  Mark Rowe  <mrowe@apple.com>

        Reviewed by Cameron Zwarich.

        Fix crash in Acid3 in Windows and Gtk ports, introduced in r35590.

        * bindings/js/ScriptControllerGtk.cpp: Fix the logic.
        * bindings/js/ScriptControllerWin.cpp: Ditto.
        * bindings/js/ScriptControllerQt.cpp: Switch to isPluginView for consistency with Gtk and Windows.

2008-08-10  Dan Bernstein  <mitz@apple.com>

        Reviewed by Darin Adler.

        - fix <rdar://problem/6074587> REGRESSION (34722): Unable to view AT&T wireless bill - window title contains markup, window is empty

        Test: fast/tokenizer/ampersand-in-special-tag.html

        * html/HTMLTokenizer.cpp:
        (WebCore::HTMLTokenizer::parseSpecial): Changed to only advance
        lastDecodedEntityPosition if an entity was found and decoded.

2008-08-10  Jan Michael Alonzo  <jmalonzo@webkit.org>

        Reviewed (and updated) by Alp Toker.

        https://bugs.webkit.org/show_bug.cgi?id=16620
        [GTK] Autotools make dist and make check support

        Get make dist working.

        Note that not all possible configurations have been tested yet.

        * GNUmakefile.am:

2008-08-08  Beth Dakin  <bdakin@apple.com>

        Reviewed by Darin.

        This patch makes the findString and markAllMatchesForText functions 
        work with disconnected frames that are contained within 
        overflow:hidden blocks.

        * editing/Editor.cpp:
        (WebCore::Editor::rangeVisibility):
        (WebCore::Editor::firstVisibleRange):
        (WebCore::Editor::lastVisibleRange):
        * editing/Editor.h:
        (WebCore::Editor::):
        * page/Frame.cpp:
        (WebCore::Frame::findString):
        (WebCore::Frame::markAllMatchesForText):

2008-08-08  Maxime Britto  <britto@apple.com>

        Reviewed by Adele.

        Test: fast/events/scroll-to-anchor-in-overflow-hidden.html
        https://bugs.webkit.org/show_bug.cgi?id=20270
        Jump to an anchor wasn't working when the overflow:hidden CSS attribute was set on the page.

        * WebCore.base.exp:
        * dom/Element.cpp:
        (WebCore::Element::scrollIntoView):
        (WebCore::Element::scrollIntoViewIfNeeded):
        * loader/FrameLoader.cpp:
        (WebCore::FrameLoader::gotoAnchor):
        * page/EventHandler.cpp:
        (WebCore::EventHandler::handleMousePressEvent):
        (WebCore::EventHandler::handleMouseDraggedEvent):
        * page/Frame.cpp:
        (WebCore::Frame::revealSelection):
        (WebCore::Frame::revealCaret):
        * rendering/RenderLayer.cpp:
        (WebCore::RenderLayer::scrollRectToVisible): Takes a new parameter "scrollToAnchor" since it's a special case of scroll. It passes this new bool to canBeProgrammaticallyScrolled. 
        (WebCore::RenderLayer::autoscroll):
        * rendering/RenderLayer.h:
        * rendering/RenderListBox.h:
        (WebCore::RenderListBox::canBeProgramaticallyScrolled):
        * rendering/RenderObject.cpp:
        (WebCore::RenderObject::canBeProgramaticallyScrolled): If the call is coming from a scrollToAnchor we don't need scrollBars to accept.
        * rendering/RenderObject.h:
        * rendering/RenderTextControl.h:
        (WebCore::RenderTextControl::canBeProgramaticallyScrolled):

2008-08-08  Maxime Britto  <britto@apple.com>

        Reviewed by Adele.

        <rdar://problem/6137022>
        <https://bugs.webkit.org/show_bug.cgi?id=20331>
        REGRESSION(r35177-r35203): Scrolling slowly over a scrollable field scrolls the page instead of the field (20331)

        * page/EventHandler.cpp:
        (WebCore::scrollAndAcceptEvent): fixed the wrong cast for the wheel delta which was truncated to 0 on slow wheel scrolls.

2008-08-08  Dean Jackson  <dino@apple.com>

        Execute CSS Animations using new AnimationController
        https://bugs.webkit.org/show_bug.cgi?id=20119

        I still need to file some follow-on bugs that EricS noticed.

        Reviewed by Dave Hyatt

        Some new tests:
        * manual-tests/animate-duration.html: Added.
        * manual-tests/animate-left.html: Added.
        * manual-tests/animate-none.html: Added.

        * css/CSSStyleSelector.cpp:
        * dom/Document.cpp:
            - don't redo style when page is place into cache
        * page/AnimationController.cpp:
        * page/AnimationController.h:
            - execute the animations
        * rendering/RenderObject.cpp:
        * rendering/style/RenderStyle.h:
            - make border radii const (for blending)

2008-08-08  Kevin McCullough  <kmccullough@apple.com>

        Reviewed by Tim.

        <rdar://problem/6136326> JSProfiler: Start/stop profiling button in the
        Web Inspector does not match the menu.

        * page/InspectorController.cpp:
        (WebCore::InspectorController::toggleRecordButton): Toggle the record
        button in the webInspector.
        (WebCore::InspectorController::startUserInitiatedProfiling):
        (WebCore::InspectorController::stopUserInitiatedProfiling):
        * page/InspectorController.h: 
        * page/inspector/ProfilesPanel.js: Move the UI part of the record button
        into its funtion so that it can be called from the Inspector controller.
        * page/inspector/inspector.js:

2008-08-08  Kevin McCullough  <kmccullough@apple.com>

        Reviewed by Tim.

        <rdar://problem/6131187> Profiles don't show up immediately when run
        with the UI.

        * page/InspectorController.cpp:
        (WebCore::startProfiling): Added so that the inspector's JS code could
        call through to the same function used by the Develop menu.  This way
        both can call didFinishAllExecution() which puts the profile in the
        Web Inspector.
        (WebCore::stopProfiling): Ditto
        (WebCore::InspectorController::windowScriptObjectAvailable):
        (WebCore::InspectorController::stopUserInitiatedProfiling): Now calls
        didFinishAllExecution() to put the profile in the Web Inspector.  This
        should be safe since the UIs shouldn't work if JS is still running.
        * page/inspector/ProfilesPanel.js: Use the new functions.

2008-08-08  Dan Bernstein  <mitz@apple.com>

        Reviewed by Darin Adler.

        - fix <rdar://problem/5961260> GDI text: transparent fill color text does not render if it it has a stroke or shadow

        * platform/graphics/win/FontCGWin.cpp:
        (WebCore::Font::drawGlyphs):

2008-08-08  Adam Treat  <treat@kde.org>

        Reviewed by Simon.

        Return the canonical file path in Qt's listDirectory as WebCore::PluginDatabase
        uses this method to retrieve a list of possible plugins.  Many linux systems
        have nested symbolic links scattered throughout the plugin directories which
        resulted in the PluginDatabase loading the same plugin N times depending on
        the number of symbolic links.

        * platform/qt/FileSystemQt.cpp:
        (WebCore::listDirectory):

2008-08-07  Anthony Ricaud  <rik24d@gmail.com>

        Change highlight time from 300ms to 500ms and fade effect from 1s to 2s

        https://bugs.webkit.org/show_bug.cgi?id=20055

        Reviewed by Timothy Hatcher.

        * page/inspector/SourceFrame.js:

2008-08-07  Anthony Ricaud  <rik24d@gmail.com>

        The search is only performed if the field contains more than 3
        letters or if Enter is pressed.

        Search is now performed through a keyup event.

        Added a WebInspector.lastQuery to remember the last query and not
        perform it again (eg. the user hits a modifier key).

        https://bugs.webkit.org/show_bug.cgi?id=18548

        Reviewed by Timothy Hatcher.

        * page/inspector/inspector.html: Removed the onsearch and incremental
        attributes
        * page/inspector/inspector.js:

2008-08-07  Steve Falkenburg  <sfalken@apple.com>

        Compile derived sources through an all-in-one cpp file.
        Fixes Windows release build on non-x64 systems by reducing the size of WebCore.lib from 1.5GB to 1GB.
        
        Reviewed by Mark Rowe.

        * DerivedSources.cpp: Added.
        * WebCore.vcproj/WebCore.vcproj:

2008-08-07  Kevin McCullough  <kmccullough@apple.com>

        Reviewed by Adam.

        <rdar://problem/5712917> Confusing console error message clear
        behavior (16791)
        https://bugs.webkit.org/show_bug.cgi?id=16791
        <rdar://problem/5831899> The Web Inspector does not correctly clear the
        console messages

        * page/InspectorController.cpp: Clear the message so they don't show up
        in the inspector after it has cleared them.
        (WebCore::clearMessages):
        (WebCore::InspectorController::clearConsoleMessages):
        (WebCore::InspectorController::windowScriptObjectAvailable):
        * page/InspectorController.h:
        * page/inspector/Console.js: Tell the InspectorController to clear the
        messages it's holding onto.

2008-08-07  Simon Fraser  <simon.fraser@apple.com>

        Reviewed by Sam Weinig

        Rename Marquee to RenderMarquee and move to its own file.
        https://bugs.webkit.org/show_bug.cgi?id=20319

        * GNUmakefile.am:
        * WebCore.pro:
        * WebCore.vcproj/WebCore.vcproj:
        * WebCore.xcodeproj/project.pbxproj:
        * WebCoreSources.bkl:
        * html/HTMLMarqueeElement.cpp:
        * rendering/RenderBlock.cpp:
        * rendering/RenderLayer.cpp:
        (WebCore::RenderLayer::styleChanged):
        * rendering/RenderLayer.h:
        * rendering/RenderMarquee.cpp: Added.
        (WebCore::RenderMarquee::RenderMarquee):
        (WebCore::RenderMarquee::marqueeSpeed):
        (WebCore::RenderMarquee::direction):
        (WebCore::RenderMarquee::isHorizontal):
        (WebCore::RenderMarquee::computePosition):
        (WebCore::RenderMarquee::start):
        (WebCore::RenderMarquee::suspend):
        (WebCore::RenderMarquee::stop):
        (WebCore::RenderMarquee::updateMarqueePosition):
        (WebCore::RenderMarquee::updateMarqueeStyle):
        (WebCore::RenderMarquee::timerFired):
        * rendering/RenderMarquee.h: Added.
        (WebCore::RenderMarquee::speed):
        (WebCore::RenderMarquee::reverseDirection):
        (WebCore::RenderMarquee::setEnd):

2008-08-07  Dan Bernstein  <mitz@apple.com>

        Reviewed by Dave Hyatt.

        - fix <rdar://problem/6118816> Initial empty page or bookmarks view window has white strip where vertical scrollbar would be (which vanishes on resize)

        * page/Frame.cpp:
        (WebCore::Frame::setZoomFactor): If the view has never had a layout with
        the old zoom factor, then there is no need to explicitly call layout()
        here.

2008-08-07  Kevin McCullough  <kmccullough@apple.com>

        Reviewed by Geoff.

        <rdar://problem/6115981> Start the profiler in Heavy view

        * page/inspector/ProfileView.js:

2008-08-07  Alp Toker  <alp@nuanti.com>

        Reviewed by Eric Seidel.

        https://bugs.webkit.org/show_bug.cgi?id=20313
        Add null check in String::fromUTF8()

        Make String::fromUTF8() consistent with other constructors by
        returning a null String when the input is null instead of crashing.

        * platform/text/String.cpp:
        (WebCore::String::fromUTF8):

2008-08-06  Kevin Ollivier  <kevino@theolliviers.com>

        wx build fix after Frame -> ScriptController moves.

        * platform/wx/TemporaryLinkStubs.cpp:

2008-08-06  Kevin McCullough  <kmccullough@apple.com>

        Reviewed by Tim.

        - Make XHR console message clearer.

        * xml/XMLHttpRequest.cpp:
        (WebCore::XMLHttpRequest::didFinishLoading):

2008-08-06  Kevin McCullough  <kmccullough@apple.com>

        Reviewed by Tim.

        - Created a new function to create DOM links from text without
        converting back and forth from HTML and messing with escaping special
        characters.

        * page/inspector/Console.js:
        * page/inspector/inspector.js:
        * page/inspector/utilities.js:

2008-08-06  Eric Seidel  <eric@webkit.org>

        Reviewed by hyatt.

        Fix a large animation leak found on the buildbot
        (m_animations and m_transitions were never deleted)
        Drag RenderStyle (kicking and screaming) into the 21st century
        of memory management with a little application of OwnPtr.

        * rendering/style/RenderStyle.cpp:
        (WebCore::FillLayer::cullEmptyLayers):
        (WebCore::RenderStyle::diff):
        (WebCore::RenderStyle::contentDataEquivalent):
        (WebCore::RenderStyle::setContent):
        (WebCore::BindingURI::BindingURI):
        (WebCore::RenderStyle::setBoxShadow):
        (WebCore::ShadowData::ShadowData):
        (WebCore::RenderStyle::counterDirectives):
        (WebCore::RenderStyle::accessCounterDirectives):
        (WebCore::RenderStyle::adjustAnimations):
        (WebCore::RenderStyle::adjustTransitions):
        (WebCore::RenderStyle::accessAnimations):
        (WebCore::RenderStyle::accessTransitions):
        * rendering/style/RenderStyle.h:
        (WebCore::RenderStyle::clearAnimations):
        (WebCore::RenderStyle::clearTransitions):

2008-08-06  Brady Eidson  <beidson@apple.com>

        Reviewed by MitzPettel

        <rdar://problem/6078543> - Many LocalStorageThreads may be started

        The original decision to key LocalStorage sets to PageGroups was a poor one.

        It seems a much better solution is to key them to the actual path of on-disk storage,
        which also solves all of the avenues that could lead to a boundless number of threads.

        In this patch, I am not attempting to completely sever the attachment of LocalStorage
        to PageGroups as that would require a more substantial re-working of the lifetime
        between pages, groups, and local storage threads.

        * page/PageGroup.cpp:
        (WebCore::PageGroup::addPage):

        * storage/LocalStorage.cpp:
        (WebCore::localStorageMap):  Map paths to LocalStorage objects here.
        (WebCore::LocalStorage::localStorage): Return the shared LocalStorage object for this path,
          or create a new one if it doesn't yet exist.
        (WebCore::LocalStorage::LocalStorage):
        (WebCore::LocalStorage::~LocalStorage):  Add to remove the path->LocalStorage mapping
        * storage/LocalStorage.h:

2008-08-06  Beth Dakin  <bdakin@apple.com>

        Reviewed by Adele.

        Fix for <rdar://problem/6130724>

        Disconnected frames should not be allowed to resize the window.

        * page/DOMWindow.cpp:
        (WebCore::DOMWindow::resizeBy):
        (WebCore::DOMWindow::resizeTo):

2008-08-05  David D. Kilzer  <ddkilzer@apple.com>

        Bug 20038: REGRESSION (r35151): Can't post comments on flickr.com

        <https://bugs.webkit.org/show_bug.cgi?id=20038>
        <rdar://problem/6092270>

        Reviewed by Eric Seidel.

        Test: fast/forms/submit-to-url-fragment.html

        The problem was that isFormSubmission was not being set to true in
        FrameLoader::loadWithDocumentLoader() when we were actually
        submitting a form, causing the page to scroll instead of the form to
        be submitted.

        The isFormSubmission variable wasn't set to true because a FormState
        object was not being created in
        FrameLoader::loadFrameRequestWithFormAndValues().

        The FormState object was not being created because
        HTMLFormElement::submit(Event*, bool activateSubmitButton) would
        only set FrameLoader::m_formAboutToBeSubmitted to the current form
        if there was a "text field" element in the form (type = text,
        password, search or isindex).

        Thus when FrameLoader::submitForm(const FrameLoadRequest&, Event*)
        called FrameLoader::loadFrameRequestWithFormAndValues(), a null
        HTMLFormElement pointer would be sent and cause the above failures.

        * html/HTMLFormElement.cpp:
        (WebCore::HTMLFormElement::submit): Call new
        FrameLoader::setFormAboutToBeSubmitted() method outside the for
        loop so we always set FrameLoader::m_formAboutToBeSubmitted exactly
        once for any form submission.  The FrameLoader::recordFormValue()
        method is only called with the name/value pair of each text field.

        * loader/FrameLoader.cpp:
        (WebCore::FrameLoader::setFormAboutToBeSubmitted): Added method that
        only sets m_formAboutToBeSubmitted.
        (WebCore::FrameLoader::recordFormValue): Removed
        PassRefPtr<HTMLFormElement> argument since this method only sets
        name/value pairs on m_formValuesAboutToBeSubmitted now.
        (WebCore::FrameLoader::loadFrameRequestWithFormAndValues): Create a
        FormState object as long as submitForm is not null so that other
        FrameLoader methods know when a form is being submitted.
        * loader/FrameLoader.h:

2008-08-06  David D. Kilzer  <ddkilzer@apple.com>

        BUILD FIX: Add HTMLPlugInImageElement.cpp to all other build systems

        * GNUmakefile.am:
        * WebCore.pro:
        * WebCoreSources.bkl:

2008-08-06  Dan Bernstein  <mitz@apple.com>

        - Windows build fix

        * WebCore.vcproj/WebCore.vcproj: Added PlugInImageElement.*

2008-08-06  Kevin McCullough  <kmccullough@apple.com>

        Reviewed by Tim and Darin.

        <rdar://problem/6126160> URLs in the console should be clickable.
        - Implemented and now use linkifyString() to parse console messages for
        URLs.

        * page/inspector/Console.js:
        * page/inspector/inspector.js:
        * page/inspector/utilities.js:

2008-07-02  David Kilzer  <ddkilzer@apple.com>

        Images using QT plugin do not display correctly

        <https://bugs.webkit.org/show_bug.cgi?id=9214>
        <rdar://problem/5683413>

        Reviewed by Darin.

        Tests: fast/images/embed-image.html
               fast/images/object-image.html

        Use RenderImage instead of RenderPartObject for a renderer when
        the <embed> tag references an image.  Extract common code from
        HTMLEmbedElement and HTMLObjectElement into HTMLPlugInImageElement.

        * WebCore.xcodeproj/project.pbxproj: Added new source files.

        * html/HTMLEmbedElement.cpp: Cleaned up #include statements.
        (WebCore::HTMLEmbedElement::HTMLEmbedElement): Extend
        HTMLPlugInImageElement which extends HTMLPlugInElement.
        (WebCore::HTMLEmbedElement::parseMappedAttribute): Split codeAttr
        and srcAttr cases.  Create or clear HTMLImageLoader as needed for
        srcAttr.
        (WebCore::HTMLEmbedElement::rendererIsNeeded): Use
        HTMLPlugInElement::rendererIsNeeded() for images.
        (WebCore::HTMLEmbedElement::createRenderer): Create a
        RenderImage instead of a RenderPartObject for images.
        (WebCore::HTMLEmbedElement::attach): Create HTMLImageLoader,
        load image and populate RenderImage for images.
        (WebCore::HTMLEmbedElement::updateWidget): Don't call
        RenderPartObject::updateWidget() for images.
        (WebCore::HTMLEmbedElement::imageSourceAttributeName): Added.
        * html/HTMLEmbedElement.h: Removed unneeded namespace and class
        declarations.  Extend HTMLPlugInImageElement which extends
        HTMLPlugInElement.
        (WebCore::HTMLEmbedElement::imageSourceAttributeName): Added.
        (WebCore::HTMLEmbedElement::serviceType): Moved to
        HTMLPlugInImageElement.
        (WebCore::HTMLEmbedElement::url): Ditto.

        * html/HTMLObjectElement.cpp: Cleaned up #include statements.
        (WebCore::HTMLObjectElement::attach): Removed local variable.
        (WebCore::HTMLObjectElement::isImageType): Moved to
        HTMLPlugInImageElement.
        * html/HTMLObjectElement.h: Extend HTMLPlugInImageElement which
        extends HTMLPlugInElement.
        (WebCore::HTMLObjectElement::isImageType): Moved to
        HTMLPlugInImageElement.
        (WebCore::HTMLObjectElement::serviceType): Ditto.
        (WebCore::HTMLObjectElement::url): Ditto.

        * html/HTMLPlugInImageElement.cpp: Added.
        (WebCore::HTMLPlugInImageElement::HTMLPlugInImageElement): Added.
        (WebCore::HTMLPlugInImageElement::~HTMLPlugInImageElement): Added.
        (WebCore::HTMLPlugInImageElement::isImageType): Moved from
        HTMLObjectElement.
        * html/HTMLPlugInImageElement.h: Added.
        (WebCore::HTMLPlugInImageElement::isImageType): Added from 
        HTMLObjectElement.
        (WebCore::HTMLPlugInImageElement::serviceType): Ditto.
        (WebCore::HTMLPlugInImageElement::url): Ditto.

        * rendering/HitTestResult.cpp:
        (WebCore::HitTestResult::absoluteImageURL): Return urlString
        for embed elements with images.

2008-08-06  Marco Barisione  <marco.barisione@collabora.co.uk>

        Reviewed by Eric Seidel.

        http://bugs.webkit.org/show_bug.cgi?id=20295
        RegularExpression::match should not crash when a null string is passed

        RegularExpression::match used to pass null subject strings to
        jsRegExpExecute causing an ASSERT failure and then a crash.
        There is no need to fix also RegularExpression:search and
        RegularExpression::searchRev as they just call
        RegularExpression::match.

        * platform/text/RegularExpression.cpp:
        (WebCore::RegularExpression::match): Return -1 if the string is null.

2008-08-06  Jan Michael Alonzo  <jmalonzo@webkit.org>

        Gtk build fix only

        * bindings/js/ScriptControllerGtk.cpp:
        * plugins/gtk/PluginViewGtk.cpp:
        (WebCore::PluginView::getValue):
        (WebCore::PluginView::~PluginView):

2008-08-06  Ariya Hidayat  <ariya.hidayat@trolltech.com>

        Fix the Qt build due to recent ScriptController refactoring.

        * plugins/qt/PluginViewQt.cpp:
        (WebCore::PluginView::getValue):
        (WebCore::PluginView::~PluginView):

2008-08-06  Eric Seidel  <eric@webkit.org>

        Reviewed by Cameron Zwarich.

        Fix warnings and errors seen on Qt bot.
        Including one correctness fix for ThreadingQt.
        According to the Qt 4.4 docs, we were always passing
        seconds to "wait()" when we should have been passing
        milliseconds.
        
        Lots of float <-> int conversion warnings.

        * css/CSSCursorImageValue.cpp:
        (WebCore::CSSCursorImageValue::updateIfSVGCursorIsUsed):
        * dom/Element.cpp:
        (WebCore::adjustForLocalZoom):
        (WebCore::adjustForAbsoluteZoom):
        (WebCore::Element::setScrollLeft):
        (WebCore::Element::setScrollTop):
        * dom/EventTargetNode.cpp:
        (WebCore::EventTargetNode::dispatchMouseEvent):
        * loader/CachedImage.cpp:
        (WebCore::CachedImage::imageRect):
        * page/DOMWindow.cpp:
        (WebCore::DOMWindow::innerHeight):
        (WebCore::DOMWindow::innerWidth):
        (WebCore::DOMWindow::scrollX):
        (WebCore::DOMWindow::scrollY):
        (WebCore::DOMWindow::scrollTo):
        * page/EventHandler.cpp:
        (WebCore::scrollAndAcceptEvent):
        * plugins/npapi.cpp:
        * plugins/qt/PluginViewQt.cpp:
        (WebCore::PluginView::getValue):
        (WebCore::PluginView::~PluginView):
        * rendering/RenderReplaced.cpp:
        (WebCore::RenderReplaced::intrinsicSizeChanged):

2008-08-06  Eric Seidel  <eric@webkit.org>

        Build fix only, no review.

        Attempt to fix the Windows and Qt builds.

        * bindings/js/ScriptControllerWin.cpp: add runtime.h include
        * bindings/js/ScriptControllerQt.cpp: add QWidget include
        * page/win/FrameWin.cpp: remove bogus using namespace
        * plugins/PluginView.cpp:
        (WebCore::PluginView::bindingInstance): use script()
        * plugins/win/PluginViewWin.cpp:
        (WebCore::PluginView::getValue): use script()
        (WebCore::PluginView::~PluginView): use script()

  2008-08-06  Eric Seidel  <eric@webkit.org>

        Build fix only, no review.

        Attempt to fix the Linux and --no-svg builds.

        * bindings/js/ScriptController.h: wrap RetainPtr include in PLATFORM(MAC)
        * css/CSSComputedStyleDeclaration.cpp:
        (WebCore::CSSComputedStyleDeclaration::getPropertyCSSValue): add missing CSSProperties to switch

2008-08-06  Eric Seidel  <eric@webkit.org>

        Reviewed by Cameron Zwarich.

        Move more methods from Frame into ScriptController
        https://bugs.webkit.org/show_bug.cgi?id=20294
        
        Finally finish more of the work which Darin started long ago
        Move a few more Frame methods into ScriptController.
        I also took this opportunity to clean up some of the plugin
        code as well, and moved some of that into ScriptController.

        I removed Frame::clearScriptController() and ScriptController::clear() is now clearWindowShell()

        No functional changes, thus no test cases.

        * GNUmakefile.am:
        * WebCore.NPAPI.exp:
        * WebCore.base.exp:
        * WebCore.pro:
        * WebCore.vcproj/WebCore.vcproj:
        * WebCore.xcodeproj/project.pbxproj:
        * bindings/js/ScriptController.cpp:
        (WebCore::ScriptController::ScriptController):
        (WebCore::ScriptController::~ScriptController):
        (WebCore::ScriptController::bindingRootObject):
        (WebCore::ScriptController::createRootObject):
        (WebCore::ScriptController::windowScriptNPObject):
        (WebCore::ScriptController::createScriptObjectForPluginElement): New method.
        (WebCore::ScriptController::clearPlatformScriptObjects):
        (WebCore::ScriptController::disconnectPlatformScriptObjects):
        (WebCore::ScriptController::cleanupScriptObjectsForPlugin):
        (WebCore::ScriptController::clearScriptObjects):
        * bindings/js/ScriptController.h:
        (WebCore::ScriptController::sourceURL):
        (WebCore::ScriptController::clearFormerWindow):
        * bindings/js/ScriptControllerGtk.cpp: Copied from WebCore/page/gtk/FrameGtk.cpp.
        (WebCore::Frame::createScriptInstanceForWidget):
        * bindings/js/ScriptControllerMac.mm: Added.
        (WebCore::ScriptController::createScriptInstanceForWidget):
        (WebCore::ScriptController::windowScriptObject):
        (WebCore::ScriptController::clearPlatformScriptObjects):
        (WebCore::ScriptController::disconnectPlatformScriptObjects):
        (WebCore::updateRenderingForBindings):
        (WebCore::ScriptController::initJavaJSBindings):
        * bindings/js/ScriptControllerQt.cpp: Copied from WebCore/page/gtk/FrameGtk.cpp.
        (WebCore::ScriptController::createScriptInstanceForWidget):
        * bindings/js/ScriptControllerWin.cpp: Copied from WebCore/svg/graphics/cg/SVGResourceMaskerCg.cpp.
        (WebCore::ScriptController::createScriptInstanceForWidget):
        * bindings/objc/DOM.mm:
        (-[DOMNode KJS::Bindings::]):
        * bindings/objc/DOMInternal.mm:
        (-[WebScriptObject _initializeScriptDOMNodeImp]):
        * bridge/jni/jni_jsobject.mm:
        (createRootObject):
        * html/HTMLAppletElement.cpp:
        (WebCore::HTMLAppletElement::renderWidgetForJSBindings):
        * html/HTMLAppletElement.h:
        * html/HTMLEmbedElement.cpp:
        (WebCore::findWidgetRenderer):
        (WebCore::HTMLEmbedElement::renderWidgetForJSBindings):
        * html/HTMLEmbedElement.h:
        * html/HTMLObjectElement.cpp:
        (WebCore::HTMLObjectElement::~HTMLObjectElement):
        (WebCore::HTMLObjectElement::renderWidgetForJSBindings):
        (WebCore::HTMLObjectElement::detach):
        * html/HTMLObjectElement.h:
        * html/HTMLPlugInElement.cpp:
        (WebCore::HTMLPlugInElement::~HTMLPlugInElement):
        (WebCore::HTMLPlugInElement::detach):
        (WebCore::HTMLPlugInElement::getInstance):
        (WebCore::HTMLPlugInElement::parseMappedAttribute):
        (WebCore::HTMLPlugInElement::getNPObject):
        * html/HTMLPlugInElement.h:
        * loader/FrameLoader.cpp:
        (WebCore::FrameLoader::clear):
        * page/Frame.cpp:
        (WebCore::Frame::Frame):
        (WebCore::Frame::~Frame):
        (WebCore::Frame::pageDestroyed):
        (WebCore::FramePrivate::FramePrivate):
        * page/Frame.h:
        * page/FramePrivate.h:
        * page/gtk/FrameGtk.cpp:
        * page/mac/FrameMac.mm:
        * page/qt/FrameQt.cpp:
        * page/win/FrameWin.cpp:
        (WebCore::computePageRectsForFrame):

2008-08-05  Steve Falkenburg  <sfalken@apple.com>

        Fix last timer fix.
        Add null check, clear timer using InterlockedExchange.
        
        Reviewed by Alice Liu.

        * platform/win/SharedTimerWin.cpp:
        (WebCore::clearTimer):
        (WebCore::queueTimerProc):
        (WebCore::stopSharedTimer):

2008-08-05  Steve Falkenburg  <sfalken@apple.com>

        Fix timer leak, flag.
        
        Timers need to be deleted explicitly, even if they fire.
        Also added WT_EXECUTEONLYONCE flag, since this is not a repeating timer.
        
        Reviewed by Ada Chan.

        * platform/win/SharedTimerWin.cpp:
        (WebCore::queueTimerProc):

2008-08-05  Anders Carlsson  <andersca@apple.com>

        Reviewed by Darin.

        <rdar://problem/6037398>
        ER: Deallocate WebKit objects on the main thread, even if released on secondary thread
        
        Add calls to WebCoreObjCScheduleDeallocateOnMainThread in dealloc methods of objects we expose.
        
        * bindings/objc/DOMRGBColor.mm:
        (-[DOMRGBColor dealloc]):
        * bindings/objc/WebScriptObject.mm:
        (-[WebScriptObject dealloc]):
        * platform/mac/SharedBufferMac.mm:
        (-[WebCoreSharedBufferData dealloc]):

2008-08-05  Anders Carlsson  <andersca@apple.com>

        Reviewed by Darin.

        Move the main thread deallocator here from WebKit.
        
        * WebCore.base.exp:
        * WebCore.xcodeproj/project.pbxproj:
        * platform/mac/WebCoreObjCExtras.c:
        (method_getImplementation):
        (deallocCallback):
        (WebCoreObjCScheduleDeallocateOnMainThread):
        * platform/mac/WebCoreObjCExtras.h:

2008-08-05  Dean Jackson  <dino@apple.com>

        Parse CSS Animations, including the new
        -webkit-animation properties and the @-webkit-keyframes rule.
        Adds some new interfaces for the style rules.
        
        https://bugs.webkit.org/show_bug.cgi?id=20088

        Reviewed by David Hyatt.

        * GNUmakefile.am:
        * WebCore.pro:
        * WebCore.vcproj/WebCore.vcproj:
        * WebCore.xcodeproj/project.pbxproj:
        * WebCoreSources.bkl:
            build config for new files
        * css/tokenizer.flex:
        * css/CSSGrammar.y:
        * css/CSSParser.cpp:
        * css/CSSParser.h:
            new @-webkit-keyframes parsing
        * css/CSSPropertyNames.in:
            -webkit-animation properties
        * css/CSSRule.h:
        * css/CSSStyleSelector.cpp:
        * css/CSSStyleSelector.h:
        * css/CSSValueKeywords.in:
        * css/StyleBase.h:
        * css/WebKitCSSKeyframeRule.cpp: Added.
        * css/WebKitCSSKeyframeRule.h: Added.
        * css/WebKitCSSKeyframesRule.cpp: Added.
        * css/WebKitCSSKeyframesRule.h: Added.

2008-08-05  Kevin McCullough  <kmccullough@apple.com>

        Reviewed by Tim.

        - LayoutTests fix.  Log only to the Inspector because other listeners may not want
        XHR notifications, including DRT and the numerous tests that don't expect them.

        * xml/XMLHttpRequest.cpp:
        (WebCore::XMLHttpRequest::didFinishLoading):

2008-08-05  Timothy Hatcher  <timothy@apple.com>

        Makes DOM attribute editing start on double-click to match the styles
        pane. Links in attributes are now triggered with a single click again.

        https://bugs.webkit.org/show_bug.cgi?id=20281

        Reviewed by Adam Roben.

        * English.lproj/localizedStrings.js: Removed some strings.
        * page/inspector/ElementsPanel.js:
        (WebInspector.DOMNodeTreeElement.prototype.onattach): Call
        _preventFollowingLinksOnDoubleClick.
        (WebInspector.DOMNodeTreeElement.prototype._preventFollowingLinksOnDoubleClick):
        Renamed from _makeURLsActivateOnModifiedClick. Simply sets the
        preventFollowOnDoubleClick property on all links.
        (WebInspector.DOMNodeTreeElement.prototype.onselect): Removed
        _selectedByCurrentMouseDown.
        (WebInspector.DOMNodeTreeElement.prototype.onmousedown): Moved
        editing code to ondblclick.
        (WebInspector.DOMNodeTreeElement.prototype.ondblclick): Calls
        _startEditing. Removed URL check.
        (WebInspector.DOMNodeTreeElement.prototype._updateTitle): Calls
        _preventFollowingLinksOnDoubleClick.
        * page/inspector/inspector.css:
        (.editing): Removed the text-decoration property.
        (.editing, .editing *): Added the text-decoration property here
        so it removes underlines on child elements.
        * page/inspector/inspector.js:
        (WebInspector.documentClick): Removed the followOnAltClick code.
        Added support for preventFollowOnDoubleClick, which sets a timeout
        on the first click where future clicks will cancel it (double click).
        If the timeout isn't canceled, the link is followed.

2008-08-05  Antti Koivisto  <antti@apple.com>

        Reviewed by Sam Weinig.

        <rdar://problem/6112219> Video in standalone media document flashes when navigating away

        When navigating out from a page, MediaPlayer was set invisible and then immediately 
        made visible again causing flicker in some cases.
        
        The document is not yet marked being in page cache when willSaveToCache() is called.

        * html/HTMLMediaElement.cpp:
        (WebCore::HTMLMediaElement::willSaveToCache):
        * rendering/RenderVideo.cpp:
        (WebCore::RenderVideo::updatePlayer):

2008-08-05  Dan Bernstein  <mitz@apple.com>

        - fix typo

        * page/mac/FrameMac.mm:

2008-08-05  Dan Bernstein  <mitz@apple.com>

        - try to fix the 64-bit build

        * page/mac/FrameMac.mm:

2008-08-05  Alp Toker  <alp@nuanti.com>

        Remove leftover mark pragma from r35568 to fix compiler warning spew.

        * rendering/style/RenderStyle.h:

2008-08-05  Kevin McCullough  <kmccullough@apple.com>

        - Added a test that checks for several edge cases (see description in
        test.

        * manual-tests/inspector/profiler-test-start-but-dont-stop-profiling.html: Added.

2008-08-05  Dean Jackson  <dino@apple.com>

        Reviewed by Dave Hyatt

        Add support for CSS Animation properties to RenderStyle
        https://bugs.webkit.org/show_bug.cgi?id=20068

        (also fix some minor whitespace issues and remove debugging code)

        * css/CSSComputedStyleDeclaration.cpp:
        * css/CSSStyleSelector.cpp:
        * page/AnimationController.cpp:
        * rendering/style/RenderStyle.cpp:
        * rendering/style/RenderStyle.h:

2008-08-05  Kevin McCullough  <kmccullough@apple.com>

        - Updated a manual test to be an accurate description of what it is
        actually testing.

        * manual-tests/inspector/profiler-test-stop-profiling-after-setTimeout.html:

2008-08-05  Kevin McCullough  <kmccullough@apple.com>

        Reviewed by Tim.

        <rdar://problem/5732836> XMLHttpRequest: Inspector should show network
        activity/XHR in Console (17233)

        * xml/XMLHttpRequest.cpp:
        (WebCore::XMLHttpRequest::didFinishLoading):

2008-08-05  Dean Jackson  <dino@apple.com>

        Fix the ChangeLog that was corrupted by r34545.

2008-08-04  Timothy Hatcher  <timothy@apple.com>

        Makes the selection surround just the name or value that was
        double clicked when editing CSS properties. This regressed when
        the Inspector started using focus/blur events, since a focus on
        a content editable region changes the selection.

        https://bugs.webkit.org/show_bug.cgi?id=20280

        Reviewed by Adam Roben.

        * page/inspector/StylesSidebarPane.js:
        (WebInspector.StylePropertyTreeElement.prototype.startEditing):
        Change the selection after calling WebInspector.startEditing,
        since WebInspector.startEditing will set an initial selection
        due to a focus event.

2008-08-04  Timothy Hatcher  <timothy@apple.com>

        Changes the editing behavior in the Inspector to commit changes
        when focus is lost, instead of reverting the changes.

        https://bugs.webkit.org/show_bug.cgi?id=20279

        Reviewed by Adam Roben.

        * page/inspector/inspector.js:
        (WebInspector.startEditing): Call editingCommitted in blurEventListener
        instead of editingCancelled.

2008-08-04  Timothy Hatcher  <timothy@apple.com>

        Adds the ability to increment/decrement numbers in editable style
        properties with the arrow and page keys.

        Reviewed by Adam Roben.

        https://bugs.webkit.org/show_bug.cgi?id=20273

        * page/inspector/StylesSidebarPane.js:
        (WebInspector.StylePropertyTreeElement.prototype.updateAll):
        Updates all properties in the current section, or all sections
        depending in the argument passed.
        (WebInspector.StylePropertyTreeElement.prototype.toggleEnabled):
        Call updateAll instead of having duplicate code.
        (WebInspector.StylePropertyTreeElement.prototype.startEditing):
        Assign the list element's handleKeyEvent to editingKeyDown.
        (WebInspector.StylePropertyTreeElement.prototype.editingKeyDown):
        Handles the Up and Down arrows keys. Finds the word based on the
        selection and extracts the number, prefix and suffix. Increments
        or decrements the number based on the key and modifiers. Replaces
        the original word with the new value and selects it. Also applies
        the style so the page reflects the changes live.
        (WebInspector.StylePropertyTreeElement.prototype.editingEnded):
        Delete the handleKeyEvent and originalCSSText properties.
        (WebInspector.StylePropertyTreeElement.prototype.editingCancelled):
        If originalCSSText exists, set the cssText to that value and call
        updateAll. Otherwise just call updateTitle like before.
        (WebInspector.StylePropertyTreeElement.prototype.editingCommitted):
        Factored out the style applying code to applyStyleText.
        (WebInspector.StylePropertyTreeElement.prototype.applyStyleText):
        Factored out from editingCommitted. Takes an argument that specifies
        if the interface should be updated when the style is applied.
        * page/inspector/inspector.js:
        (WebInspector.startEditing): Call the original key handler, if one
        existed before interrupting key events.
        * page/inspector/utilities.js:
        (getStyleTextWithShorthands): Helper to return CSS text that preserves
        shorthand values, since the cssText property only outputs longhands.

2008-08-04  Timothy Hatcher  <timothy@apple.com>

        Factors out the TextPrompt.scanBackwards function into a generic
        helper function on the Node prototype, named rangeOfWord.

        Reviewed by Adam Roben.

        * page/inspector/Console.js:
        (WebInspector.Console.prototype.completions): Use rangeOfWord.
        * page/inspector/TextPrompt.js:
        (WebInspector.TextPrompt.prototype.complete): Ditto.
        (WebInspector.TextPrompt.prototype.scanBackwards): Removed.
        * page/inspector/utilities.js:
        (Node.prototype.rangeOfWord): Added. Copied from TextPrompt.scanBackwards,
        and added a direction argument allowing scanning forward, backward or
        both directions from the offset.

2008-08-04  Timothy Hatcher  <timothy@apple.com>

        Fixes a bug where the property toggle button would not be hidden
        during editing.

        Reviewed by Adam Roben.

        * page/inspector/inspector.css:
        (li.editing .swatch, li.editing .enabled-button):
        Make the display !important, since a more specific rule for 
        .enabledbutton overrides display.

2008-08-05  Dan Bernstein  <mitz@apple.com>

        Reviewed by Geoffrey Garen.

        - remove redundant #imports from FrameMac.mm

        * page/mac/FrameMac.mm:

2008-08-04  Bernhard Kruepl  <kruepl@dbai.tuwien.ac.at>

        Reviewed by Dave Hyatt.

        Fix for https://bugs.webkit.org/show_bug.cgi?id=19094
        Corrected offsetTop for table cells by subtracting borderTopExtra

        * rendering/RenderObject.cpp:
        (WebCore::RenderObject::offsetTop):

2008-08-04  Dean Jackson  <dino@apple.com>

        Reviewed by Dave Hyatt.

        Improve AnimationController
        https://bugs.webkit.org/show_bug.cgi?id=19938

        - Transition class is now called Animation
        - new state-based AnimationController that can support CSS Animations
        - add support for -webkit-transition-delay
        - remove -webkit-transition-repeat-count (since it never existed officially)
        - updates the -webkit-transition shorthand to reflect removing repeat count
        - updates the Transition class so that properties can be shared with animations
        - adds a "now" keyword for -webkit-transition-delay
        - adds a new change type for style (changed by animation)
        - adds new event names (although they are not dispatched yet)
        - makes text stroke and text fill colors returned by RenderStyle const

        Tests:
        - manual-tests/transition-left.html
        - manual-tests/transition-delay.html
        - manual-tests/transition-timing-functions.html

        * css/CSSComputedStyleDeclaration.cpp:
        * css/CSSParser.cpp:
        * css/CSSParser.h:
        * css/CSSPropertyNames.in:
        * css/CSSStyleSelector.cpp:
        * css/CSSStyleSelector.h:
        * css/CSSTimingFunctionValue.h:
        * css/CSSValue.h:
        * css/CSSValueKeywords.in:
        * css/WebKitCSSTransformValue.cpp:
        * dom/Document.cpp:
        * dom/Document.h:
        * dom/Element.cpp:
        * dom/EventNames.h:
        * dom/Node.cpp:
        * dom/Node.h:
        * history/CachedPage.cpp:
        * page/AnimationController.cpp:
        * page/AnimationController.h:
        * page/Frame.cpp:
        * rendering/RenderObject.cpp:
        * rendering/RenderWidget.cpp:
        * rendering/style/RenderStyle.cpp:
        * rendering/style/RenderStyle.h:

2008-08-04  Mike Belshe  <mike@belshe.com>

        Reviewed by Antti.
        
        Currently we create two copies of script in the HTMLTokenizer.
        One copy gets passed into the javascript engine, the other gets
        stored in the DOM.  Modify the HTMLParser so that it does not
        chunk the string into it's normal 64K chunks for script code,
        and modify the HTMLTokenizer to pass that same string into the
        JS engine.  On some sites (e.g. GMail), which have hundreds of
        KB of inline JS, this saves more than a MB of RAM to run the page.
        (Strings use 16bit strings, so 600KB of JS code == 1.2MB of memory)

        * html\HTMLParser.cpp
        * html\HTMLTokenizer.cpp

2008-08-04  Sam Weinig  <sam@webkit.org>

        Reviewed by Mark Rowe.

        Remove extra braces left in from JSLock removal.

        * xml/XMLHttpRequest.cpp:
        (WebCore::XMLHttpRequest::dropProtection):

2008-08-02  Sam Weinig  <sam@webkit.org>

        Reviewed by Dan Bernstein.

        Implement the Access-control for Cross Site requests
        preflight cache.

        Tests: http/tests/xmlhttprequest/access-control-basic-allow-preflight-cache-invalidation-by-header.html
               http/tests/xmlhttprequest/access-control-basic-allow-preflight-cache-invalidation-by-method.html
               http/tests/xmlhttprequest/access-control-basic-allow-preflight-cache-timeout.html
               http/tests/xmlhttprequest/access-control-basic-allow-preflight-cache.html

        * WebCore.vcproj/WebCore.vcproj:
        * WebCore.xcodeproj/project.pbxproj:
        * platform/KURL.h:
        (WTF::):
        * platform/KURLHash.h: Added.
        (WebCore::KURLHash::hash):
        (WebCore::KURLHash::equal):
        (WTF::):
        * xml/XMLHttpRequest.cpp:
        (WebCore::PreflightResultCacheItem::PreflightResultCacheItem):
        (WebCore::preflightResultCache):
        (WebCore::appendPreflightResultCacheEntry):
        (WebCore::canSkipPrelight):
        (WebCore::XMLHttpRequest::makeCrossSiteAccessRequestWithPreflight):
        (WebCore::parseAccessControlAllowList):
        (WebCore::parseAccessControlMaxAge):
        (WebCore::XMLHttpRequest::didReceiveResponsePreflight):

2008-08-04  Eric Seidel  <eric@webkit.org>

        Reviewed by Adam Roben.

        Fix warning seen in MSVC converting ints to floats.

        * rendering/Length.h:
        (WebCore::Length::calcFloatValue):

2008-08-04  Eric Seidel  <eric@webkit.org>

        Reviewed by hyatt.

        Clean up Gradient constructors, make sure all members are initialized.

        * platform/graphics/Gradient.cpp:
        (WebCore::Gradient::Gradient):

2008-08-02  Maxime Britto  <britto@apple.com>

        Reviewed by Eric Seidel.

        <rdar://problem/6118969>
        https://bugs.webkit.org/show_bug.cgi?id=19971 
        Modifiy the cursor interactively when on panning mode (middle click auto scroll)
        When the panning is in progress the cursor is an arrow representing the direction of the current scroll

        * page/EventHandler.cpp:
        (WebCore::EventHandler::autoscrollTimerFired): Before each scroll we actualize the cursor to match the current direction
        (WebCore::EventHandler::setPanScrollCursor): determines the direction of the upcoming scroll.
        (WebCore::EventHandler::handleMouseMoveEvent):
        * page/EventHandler.h: 
        * platform/Cursor.h: Add propotypes for the new cursor functions
        * platform/gtk/CursorGtk.cpp: to avoid build break
        (WebCore::middlePanningCursor):
        (WebCore::eastPanningCursor):
        (WebCore::northPanningCursor):
        (WebCore::northEastPanningCursor):
        (WebCore::northWestPanningCursor):
        (WebCore::southPanningCursor):
        (WebCore::southEastPanningCursor):
        (WebCore::southWestPanningCursor):
        (WebCore::westPanningCursor):
        * platform/mac/CursorMac.mm: to avoid build break
        (WebCore::middlePanningCursor):
        (WebCore::eastPanningCursor):
        (WebCore::northPanningCursor):
        (WebCore::northEastPanningCursor):
        (WebCore::northWestPanningCursor):
        (WebCore::southPanningCursor):
        (WebCore::southEastPanningCursor):
        (WebCore::southWestPanningCursor):
        (WebCore::westPanningCursor):
        * platform/qt/CursorQt.cpp: to avoid build break
        (WebCore::middlePanningCursor):
        (WebCore::eastPanningCursor):
        (WebCore::northPanningCursor):
        (WebCore::northEastPanningCursor):
        (WebCore::northWestPanningCursor):
        (WebCore::southPanningCursor):
        (WebCore::southEastPanningCursor):
        (WebCore::southWestPanningCursor):
        (WebCore::westPanningCursor):
        * platform/win/CursorWin.cpp: Add specific icons for the panning as windows resizing icons are both sides arrows
        (WebCore::middlePanningCursor):
        (WebCore::eastPanningCursor):
        (WebCore::northPanningCursor):
        (WebCore::northEastPanningCursor):
        (WebCore::northWestPanningCursor):
        (WebCore::southPanningCursor):
        (WebCore::southEastPanningCursor):
        (WebCore::southWestPanningCursor):
        (WebCore::westPanningCursor):
        * platform/wx/CursorWx.cpp: to avoid build break
        (WebCore::middlePanningCursor):
        (WebCore::eastPanningCursor):
        (WebCore::northPanningCursor):
        (WebCore::northEastPanningCursor):
        (WebCore::northWestPanningCursor):
        (WebCore::southPanningCursor):
        (WebCore::southEastPanningCursor):
        (WebCore::southWestPanningCursor):
        (WebCore::westPanningCursor):

2008-08-02  Kevin Ollivier  <kevino@theolliviers.com>

        Move to using constants in accordance with discussions about wx renderer commit.

        * platform/wx/RenderThemeWx.cpp:
        (WebCore::RenderThemeWx::minimumMenuListSize):
        (WebCore::RenderThemeWx::popupInternalPaddingLeft):
        (WebCore::RenderThemeWx::popupInternalPaddingRight):
        (WebCore::RenderThemeWx::popupInternalPaddingTop):
        (WebCore::RenderThemeWx::popupInternalPaddingBottom):

2008-08-02  Wouter Bolsterlee  <wbolster@svn.gnome.org>

        Reviewed by Eric Seidel.

        * plugins/gtk/gtk2xtbin.h:

        https://bugs.webkit.org/show_bug.cgi?id=20034
        Fix malformed Vim modeline.

2008-08-01  Dan Bernstein  <mitz@apple.com>

        Reviewed by Dave Hyatt.

        - tweak a comment

        * platform/graphics/cg/ImageCG.cpp:
        (WebCore::BitmapImage::draw):

2008-08-01  Jan Michael Alonzo  <jmalonzo@webkit.org>

        * ChangeLog: Fix date of previous commit (r35520)

2008-08-01  Marco Barisione  <marco.barisione@collabora.co.uk>

        Reviewed by Eric Seidel.

        https://bugs.webkit.org/show_bug.cgi?id=19603
        [SOUP] segfault when closing a file using gio

        Call client->didFinishLoading() only after releasing all the gio
        resources.

        * platform/network/soup/ResourceHandleSoup.cpp:
        (WebCore::closeCallback):
        (WebCore::readCallback):

2008-08-01  Anders Carlsson  <andersca@apple.com>

        Reviewed by Jon.

        <rdar://problem/6120206>
        Crash when plug-in queries for NPPVpluginWantsAllNetworkStreams.
        
        Pass in a pointer to a void* to make sure that plug-ins don't overwrite the stack.
        
        * plugins/PluginStream.cpp:
        (WebCore::PluginStream::wantsAllStreams):

2008-08-01  Robin Dunn  <robin@alldunn.com>

        Reviewed by Eric Seidel.

        Native rendering implementations for form elements in the wx port.
        
        https://bugs.webkit.org/show_bug.cgi?id=19069

        * platform/wx/RenderThemeWx.cpp:
        (WebCore::RenderThemeWx::adjustRepaintRect):
        (WebCore::RenderThemeWx::paintButton):
        (WebCore::RenderThemeWx::paintTextField):
        (WebCore::RenderThemeWx::minimumMenuListSize):
        (WebCore::RenderThemeWx::adjustMenuListStyle):
        (WebCore::RenderThemeWx::paintMenuList):
        (WebCore::RenderThemeWx::adjustMenuListButtonStyle):
        (WebCore::RenderThemeWx::paintMenuListButton):
        (WebCore::RenderThemeWx::popupInternalPaddingLeft):
        (WebCore::RenderThemeWx::popupInternalPaddingRight):
        (WebCore::RenderThemeWx::popupInternalPaddingTop):
        (WebCore::RenderThemeWx::popupInternalPaddingBottom):

2008-07-30  David Hyatt  <hyatt@apple.com>

        Improvements to selection drawing.

        Clip out floating and positioned objects when drawing selection so
        that there is no "double painting" of selection when the selection spans both the space behind the positioned/floating
        object and the positioned/floating object itself.  Improves most Web pages.

        Do not paint left/right selection gaps if the object's edge is already outside the boundary (at a negative
        position).  Significantly improves the look of selections on digg.com, since it uses giant negative text-indent.

        Reviewed by Dan

        Covered by existing selection pixel tests.

        * rendering/RenderBlock.cpp:
        (WebCore::RenderBlock::isSelectionRoot):
        (WebCore::RenderBlock::paintSelection):
        (WebCore::clipOutPositionedObjects):
        (WebCore::RenderBlock::fillSelectionGaps):
        (WebCore::RenderBlock::fillLeftSelectionGap):
        (WebCore::RenderBlock::fillRightSelectionGap):

2008-08-01  Timothy Hatcher  <timothy@apple.com>

        Adds the ability to disable individual properties of a CSS rule.
        When hovering over a rule, checkboxes show up to the right of all
        properties and toggling a checkbox disables/enables the property.
        Behind the scenes the property is removed from the rule when disabled,
        but still remains in the list and in the computed style. When disabled
        the property has a line through it, and is faded in computed style.

        <rdar://problem/5712828> Support disabling individual CSS properties
        https://bugs.webkit.org/show_bug.cgi?id=14377

        Reviewed by Adam Roben.

        * page/inspector/StylesSidebarPane.js:
        (WebInspector.StylesSidebarPane.prototype.update): Include the
        inline style when it also has disabled properties. Call
        deleteDisabledProperty for any property that is in the style,
        since it might have been added back by the page. Remember all
        disabled properties so they show up in computed style.
        (deleteDisabledProperty): Helper function to delete all the
        right properties that track disabled properties.
        (WebInspector.StylePropertiesSection): Add the computed-style
        class when  the section is Computed Style.
        (WebInspector.StylePropertiesSection.prototype.onpopulate):
        Include disabled properties.
        (WebInspector.StylePropertyTreeElement): Added a disabled argument.
        (WebInspector.StylePropertyTreeElement.prototype.get/set disabled):
        Sets the _disabled property and calls updateState.
        (WebInspector.StylePropertyTreeElement.prototype.get priority):
        Return the priority of enabled or disabled properties.
        (WebInspector.StylePropertyTreeElement.prototype.get value):
        Return the value of enabled or disabled properties.
        (WebInspector.StylePropertyTreeElement.prototype.updateTitle): Use the
        priority and value getter. Append the checkbox for root elements of
        an editable section.
        (WebInspector.StylePropertyTreeElement.prototype.toggleEnabled):
        Add or remove properties from the rule and remember removed ones
        by adding three objects to the style: __disabledProperties,
        __disabledPropertyValues and __disabledPropertyPriorities.
        The __disabledProperties object will include all longhand
        properties of a shorthand for use by Computed Style.
        (WebInspector.StylePropertyTreeElement.prototype.updateState):
        Use the value getter. Update the disabled state.
        * page/inspector/inspector.css:
        * page/inspector/utilities.js:
        (Object.hasProperties): Added. Helper to test if an object
        has any properties.

2008-07-31  Anders Carlsson  <andersca@apple.com>

        Reviewed by Darin.

        <rdar://problem/5949410>
        Add the ability to transfer a given application cache to a new database.
        
        * WebCore.base.exp:
        Export ApplicationCacheStorage::storeCopyOfCache.
        
        * loader/appcache/ApplicationCache.cpp:
        (WebCore::ApplicationCache::~ApplicationCache):
        Don't call cacheDestroyed for our special "copy" groups.
        
        * loader/appcache/ApplicationCacheGroup.cpp:
        (WebCore::ApplicationCacheGroup::ApplicationCacheGroup):
        (WebCore::ApplicationCacheGroup::~ApplicationCacheGroup):
        Add a "copy" flag to the ApplicationCacheGroup constructor. A "copied" group is special
        and can only be stored to disk.
        
        * loader/appcache/ApplicationCacheGroup.h:
        (WebCore::ApplicationCacheGroup::isCopy):
        New getter.
        
        * loader/appcache/ApplicationCacheStorage.cpp:
        (WebCore::ApplicationCacheStorage::store):
        Make sure to set the storageID when storing an application resource.
        
        (WebCore::ApplicationCacheStorage::storeNewestCache):
        Change this to return true/false depending on whether storing the cache succeeded or not.
        
        (WebCore::ApplicationCacheStorage::storeCopyOfCache):
        New method which stores a given cache in a new storage (database file).
        
        * loader/appcache/ApplicationCacheStorage.h:
        Add new methods.

2008-07-31  John Sullivan  <sullivan@apple.com>

        WebCore part of <rdar://problem/6116650> Text-only zoom setting should be stored in WebKit prefs

        Reviewed by Hyatt

        * WebCore.base.exp:
        export symbol for WebCoreSettings::setZoomsTextOnly()
        
        * page/Frame.cpp:
        (WebCore::Frame::isZoomFactorTextOnly):
        use value from Settings instead of data member
        (WebCore::Frame::shouldApplyTextZoom):
        call isZoomFactorTextOnly() to get value instead of accessing now-removed data member
        (WebCore::Frame::shouldApplyPageZoom):
        ditto
        (WebCore::Frame::setZoomFactor):
        set value into Settings rather than into data member
        (WebCore::FramePrivate::FramePrivate):
        don't set initial value of now-removed data member; this is managed by Settings now
        
        * page/FramePrivate.h:
        removed m_zoomFactorIsTextOnly
        
        * page/Settings.cpp:
        (WebCore::Settings::setZoomsTextOnly):
        new function, sets values and reapplies styles in all frames
        
        * page/Settings.h:
        (WebCore::Settings::zoomsTextOnly):
        new function, returns value of new data member

2008-07-31  Simon Fraser  <simon.fraser@apple.com>

        Reviewed by Dave Hyatt

        Null-check parent clip rects, because they may not have been
        set up yet.
        https://bugs.webkit.org/show_bug.cgi?id=20243

        * rendering/RenderLayer.cpp:
        (WebCore::RenderLayer::calculateClipRects):

2008-07-31  Dan Bernstein  <mitz@apple.com>

        Reviewed by Dave Hyatt.

        - fix <rdar://problem/6058958> REGRESSION (r34210): Seams are visible in border-image

        * platform/graphics/cg/ImageCG.cpp:
        (WebCore::BitmapImage::draw): To work around a Core Graphics
        interpolation issue, reverted to using a temporary subimage for drawing
        a portion of the image with scaling and high-quality interpolation in
        effect.

2008-07-31  chris fleizach  <cfleizach@apple.com>

        Reviewed by Alice Liu

        <rdar://problem/3563671> VO doesn't highlight characters when interacting when static text in web areas

        Need to expose the AXBoundsForRange parameter which allows an AX client to get the visible bounds
        for individual characters on a webpage.

        Test: accessibility/bounds-for-range.html

        * ChangeLog:
        * page/AccessibilityRenderObject.cpp:
        (WebCore::AccessibilityRenderObject::visiblePositionForIndex):
        * page/mac/AccessibilityObjectWrapper.mm:
        (-[AccessibilityObjectWrapper accessibilityParameterizedAttributeNames]):
        (-[AccessibilityObjectWrapper accessibilityAttributeValue:forParameter:]):

2008-07-31  Kevin Ollivier <kevino@theolliviers.com>

        Second attempt at Windows/wx build fix. Instead of avoiding inclusion of windows.h,
        use defines, etc. to avoid conflicts in each affected file.

        * config.h:
        * platform/image-decoders/jpeg/JPEGImageDecoder.cpp:
        * platform/wx/PopupMenuWx.cpp:

2008-07-31  Erik Bunce  <elbunce@thehive.com>

        Reviewed by Simon.

        https://bugs.webkit.org/show_bug.cgi?id=20224

        Include the Writing Direction sub-menu in the context menu of all
        platforms but GTK. This fixes a regression introduced by revision
        34426.

        * platform/ContextMenu.cpp:
        (WebCore::ContextMenu::populate):

2008-07-31  Brady Eidson  <beidson@apple.com>

        Reviewed by Adam and Hyatt

        Fix for <rdar://problem/6099748>

        Adds a "don't enforce CSS mime type in strict mode" quirk for iWeb 2

        * WebCore.base.exp:

        * html/HTMLLinkElement.cpp:
        (WebCore::HTMLLinkElement::setCSSStyleSheet):

        * loader/CachedCSSStyleSheet.cpp:
        (WebCore::CachedCSSStyleSheet::canUseSheet):
        * loader/CachedCSSStyleSheet.h:
        (WebCore::CachedCSSStyleSheet::sheetText): 
        * page/Settings.cpp:

        (WebCore::Settings::Settings):
        (WebCore::Settings::setEnforceCSSMIMETypeInStrictMode):
        * page/Settings.h:
        (WebCore::Settings::enforceCSSMIMETypeInStrictMode):

2008-07-31  Erik Bunce  <elbunce@thehive.com>

        Reviewed by Simon.

        Added the ability to get SQLite headers and source from the location 
        specified via the SQLITE3SRCDIR environtment variable.

        * WebCore.pro:

2008-07-31  Alexey Proskuryakov  <ap@webkit.org>

        Rubber-stamped by Maciej.

        Eliminate JSLock (it was already disabled, removing the stub implementaion and all
        call sites now).

        * ForwardingHeaders/kjs/JSLock.h: Removed.
        * WebCore.vcproj/WebCore.vcproj:
        * bindings/js/GCController.cpp:
        (WebCore::collect):
        (WebCore::GCController::gcTimerFired):
        (WebCore::GCController::garbageCollectNow):
        * bindings/js/JSCustomSQLStatementCallback.cpp:
        (WebCore::JSCustomSQLStatementCallback::handleEvent):
        * bindings/js/JSCustomSQLStatementErrorCallback.cpp:
        (WebCore::JSCustomSQLStatementErrorCallback::handleEvent):
        * bindings/js/JSCustomSQLTransactionCallback.cpp:
        (WebCore::JSCustomSQLTransactionCallback::handleEvent):
        * bindings/js/JSCustomSQLTransactionErrorCallback.cpp:
        (WebCore::JSCustomSQLTransactionErrorCallback::handleEvent):
        * bindings/js/JSCustomVoidCallback.cpp:
        (WebCore::JSCustomVoidCallback::handleEvent):
        * bindings/js/JSCustomXPathNSResolver.cpp:
        (WebCore::JSCustomXPathNSResolver::lookupNamespaceURI):
        * bindings/js/JSDOMWindowBase.cpp:
        (WebCore::DOMWindowTimer::~DOMWindowTimer):
        (WebCore::JSDOMWindowBase::clear):
        (WebCore::JSDOMWindowBase::timerFired):
        * bindings/js/JSEventCustom.cpp:
        (WebCore::toJS):
        * bindings/js/JSEventListener.cpp:
        (WebCore::JSAbstractEventListener::handleEvent):
        (WebCore::JSLazyEventListener::parseCode):
        * bindings/js/JSNSResolver.cpp:
        (WebCore::JSNSResolver::lookupNamespaceURI):
        * bindings/js/JSNodeFilterCondition.cpp:
        (WebCore::JSNodeFilterCondition::acceptNode):
        * bindings/js/ScheduledAction.cpp:
        (WebCore::ScheduledAction::execute):
        * bindings/js/ScriptController.cpp:
        (WebCore::ScriptController::evaluate):
        (WebCore::ScriptController::clear):
        (WebCore::ScriptController::createHTMLEventHandler):
        (WebCore::ScriptController::createSVGEventHandler):
        (WebCore::ScriptController::initScript):
        (WebCore::ScriptController::updateDocument):
        * bindings/objc/WebScriptObject.mm:
        (_didExecute):
        (-[WebScriptObject callWebScriptMethod:withArguments:]):
        (-[WebScriptObject evaluateWebScript:]):
        (-[WebScriptObject setValue:forKey:]):
        (-[WebScriptObject valueForKey:]):
        (-[WebScriptObject removeWebScriptKey:]):
        (-[WebScriptObject stringRepresentation]):
        (-[WebScriptObject webScriptValueAtIndex:]):
        (-[WebScriptObject setWebScriptValueAtIndex:value:]):
        (+[WebScriptObject _convertValueToObjcValue:originRootObject:rootObject:]):
        * bridge/NP_jsobject.cpp:
        (_NPN_InvokeDefault):
        (_NPN_Invoke):
        (_NPN_Evaluate):
        (_NPN_GetProperty):
        (_NPN_SetProperty):
        (_NPN_RemoveProperty):
        (_NPN_HasProperty):
        (_NPN_HasMethod):
        (_NPN_Enumerate):
        * bridge/c/c_class.cpp:
        (KJS::Bindings::CClass::~CClass):
        (KJS::Bindings::CClass::methodsNamed):
        (KJS::Bindings::CClass::fieldNamed):
        * bridge/c/c_instance.cpp:
        (KJS::Bindings::CInstance::invokeMethod):
        (KJS::Bindings::CInstance::invokeDefaultMethod):
        (KJS::Bindings::CInstance::getPropertyNames):
        * bridge/c/c_runtime.cpp:
        (KJS::Bindings::CField::valueFromInstance):
        (KJS::Bindings::CField::setValueToInstance):
        * bridge/c/c_utility.cpp:
        (KJS::Bindings::convertValueToNPVariant):
        (KJS::Bindings::convertNPVariantToValue):
        * bridge/jni/jni_class.cpp:
        (JavaClass::JavaClass):
        (JavaClass::~JavaClass):
        * bridge/jni/jni_instance.cpp:
        (JavaInstance::stringValue):
        * bridge/jni/jni_jsobject.mm:
        (JavaJSObject::call):
        (JavaJSObject::eval):
        (JavaJSObject::getMember):
        (JavaJSObject::setMember):
        (JavaJSObject::removeMember):
        (JavaJSObject::getSlot):
        (JavaJSObject::setSlot):
        (JavaJSObject::toString):
        (JavaJSObject::convertValueToJObject):
        (JavaJSObject::convertJObjectToValue):
        * bridge/jni/jni_objc.mm:
        (KJS::Bindings::dispatchJNICall):
        * bridge/jni/jni_runtime.cpp:
        (appendClassName):
        (JavaMethod::signature):
        * bridge/jni/jni_runtime.h:
        (KJS::Bindings::JavaString::JavaString):
        (KJS::Bindings::JavaString::_commonInit):
        (KJS::Bindings::JavaString::~JavaString):
        (KJS::Bindings::JavaString::UTF8String):
        * bridge/jni/jni_utility.cpp:
        (KJS::Bindings::convertValueToJValue):
        * bridge/npruntime.cpp:
        (_NPN_GetStringIdentifier):
        * bridge/objc/objc_instance.mm:
        (ObjcInstance::moveGlobalExceptionToExecState):
        (ObjcInstance::invokeMethod):
        (ObjcInstance::invokeDefaultMethod):
        (ObjcInstance::setValueOfUndefinedField):
        (ObjcInstance::getValueOfUndefinedField):
        * bridge/objc/objc_runtime.mm:
        (ObjcField::valueFromInstance):
        (ObjcField::setValueToInstance):
        * bridge/objc/objc_utility.mm:
        (KJS::Bindings::convertValueToObjcValue):
        (KJS::Bindings::convertNSStringToString):
        (KJS::Bindings::convertObjcValueToValue):
        * bridge/qt/qt_instance.cpp:
        (KJS::Bindings::QtRuntimeObjectImp::removeFromCache):
        (KJS::Bindings::QtInstance::~QtInstance):
        (KJS::Bindings::QtInstance::getQtInstance):
        (KJS::Bindings::QtInstance::getRuntimeObject):
        * bridge/qt/qt_runtime.cpp:
        (KJS::Bindings::convertValueToQVariant):
        (KJS::Bindings::convertQVariantToValue):
        (KJS::Bindings::QtRuntimeMetaMethod::call):
        (KJS::Bindings::QtRuntimeConnectionMethod::call):
        (KJS::Bindings::QtConnectionObject::QtConnectionObject):
        (KJS::Bindings::QtConnectionObject::execute):
        * bridge/runtime.cpp:
        (KJS::Bindings::Instance::createRuntimeObject):
        * bridge/testbindings.cpp:
        (main):
        * bridge/testbindings.mm:
        (main):
        * bridge/testqtbindings.cpp:
        (main):
        * dom/Document.cpp:
        (WebCore::Document::~Document):
        * dom/Node.cpp:
        (WebCore::Node::setDocument):
        * history/CachedPage.cpp:
        (WebCore::CachedPage::CachedPage):
        (WebCore::CachedPage::restore):
        (WebCore::CachedPage::clear):
        * html/HTMLPlugInElement.cpp:
        (WebCore::HTMLPlugInElement::createNPObject):
        * loader/FrameLoader.cpp:
        (WebCore::getString):
        * page/Frame.cpp:
        (WebCore::Frame::bindingRootObject):
        (WebCore::Frame::windowScriptNPObject):
        (WebCore::Frame::clearScriptObjects):
        * page/InspectorController.cpp:
        (WebCore::jsStringRef):
        (WebCore::ConsoleMessage::ConsoleMessage):
        (WebCore::XMLHttpRequestResource::XMLHttpRequestResource):
        (WebCore::XMLHttpRequestResource::~XMLHttpRequestResource):
        (WebCore::getResourceDocumentNode):
        (WebCore::search):
        (WebCore::inspectedWindow):
        (WebCore::wrapCallback):
        (WebCore::currentCallFrame):
        (WebCore::profiles):
        (WebCore::InspectorController::focusNode):
        (WebCore::InspectorController::inspectedWindowScriptObjectCleared):
        (WebCore::InspectorController::addDatabaseScriptResource):
        (WebCore::InspectorController::addScriptProfile):
        * page/JavaScriptCallFrame.cpp:
        (WebCore::JavaScriptCallFrame::evaluate):
        * page/JavaScriptProfileNode.cpp:
        (WebCore::getTotalTime):
        (WebCore::getSelfTime):
        (WebCore::getTotalPercent):
        (WebCore::getSelfPercent):
        (WebCore::getNumberOfCalls):
        (WebCore::getChildren):
        (WebCore::getVisible):
        * page/Page.cpp:
        * page/mac/FrameMac.mm:
        (WebCore::Frame::windowScriptObject):
        * page/qt/FrameQt.cpp:
        * plugins/PluginView.cpp:
        (WebCore::PluginView::start):
        (WebCore::getString):
        (WebCore::PluginView::performRequest):
        (WebCore::PluginView::bindingInstance):
        * plugins/gtk/PluginViewGtk.cpp:
        (WebCore::PluginView::paint):
        (WebCore::PluginView::handleKeyboardEvent):
        (WebCore::PluginView::handleMouseEvent):
        (WebCore::PluginView::setNPWindowRect):
        (WebCore::PluginView::stop):
        (WebCore::PluginView::init):
        * plugins/qt/PluginViewQt.cpp:
        (WebCore::PluginView::setNPWindowRect):
        (WebCore::PluginView::stop):
        (WebCore::PluginView::init):
        * plugins/win/PluginViewWin.cpp:
        (WebCore::PluginView::dispatchNPEvent):
        (WebCore::PluginView::handleKeyboardEvent):
        (WebCore::PluginView::handleMouseEvent):
        (WebCore::PluginView::setNPWindowRect):
        (WebCore::PluginView::stop):
        * xml/XMLHttpRequest.cpp:
        (WebCore::XMLHttpRequest::clearResponse):
        (WebCore::XMLHttpRequest::didFinishLoading):
        (WebCore::XMLHttpRequest::didReceiveData):

2008-07-30  Timothy Hatcher  <timothy@apple.com>

        Fix various minor bugs with style editing in the Inspector.

        - Restores the scroll position to 0,0 when finished editing a
        string that was longer than the editing input area.

        - Adjusts the margin of the list item to ensure the text does
        not shift when entering and exiting editing mode.

        - Reliably remembers if a shorthand has children when the
        children haven't been populated yet.

        - Reliably remembers if a shorthand was expanded, and expands
        if needed after editing finishes.

        - Hides color swatches when editing.

        https://bugs.webkit.org/show_bug.cgi?id=20238

        Reviewed by Adam Roben.

        * page/inspector/StylesSidebarPane.js:
        (WebInspector.StylePropertyTreeElement.prototype.startEditing):
        Store the expanded state and children state in wasExpanded and
        reallyHasChildren properties.
        (WebInspector.StylePropertyTreeElement.prototype.editingEnded):
        Removed the wasExpanded argument and use the reallyHasChildren and
        wasExpanded properties to restore state. Deletes the state properties.
        (WebInspector.StylePropertyTreeElement.prototype.editingCancelled):
        Removed the wasExpanded argument.
        (WebInspector.StylePropertyTreeElement.prototype.editingCommitted):
        Removed the wasExpanded argument.
        * page/inspector/inspector.css: Tweak the margin and hides the color
        swatches. ALso removes a rule that was not needed.
        * page/inspector/inspector.js:
        (WebInspector.startEditing): Restore the scrollLeft and scrollTop
        to zero when editing finishes.

2008-07-30  Alice Liu  <alice.liu@apple.com>

        Implement userIdleTime() for Windows, and place a band-aid over other
        platform implementations of userIdleTime().  This will fix the issue
        of indefinitely postposing releasing pages from the PageCache
        on non-Mac platforms, causing us to hang onto just about everything 
        else about a web page.
        
        Reviewed by Sam Weinig.

        * platform/gtk/TemporaryLinkStubs.cpp:
        * platform/wx/TemporaryLinkStubs.cpp:
        * platform/qt/TemporaryLinkStubs.cpp:
        (WebCore::userIdleTime): set to FLT_MAX

        * platform/win/SystemTimeWin.cpp:
        (WebCore::userIdleTime): implemented

2008-07-30  Beth Dakin  <bdakin@apple.com>

        Reviewed by Anders Carlsson.

        Fixes <rdar://problem/6041390>

        Adds the ability to have a frame that is "disconnected" from the 
        main frame from the perspective of top and parent in 
        Javascript.

        * WebCore.base.exp:
        * page/DOMWindow.cpp:
        (WebCore::DOMWindow::parent):
        (WebCore::DOMWindow::top):
        * page/Frame.cpp:
        (WebCore::Frame::isDisconnectedFrame):
        (WebCore::Frame::setIsDisconnectedFrame):
        (WebCore::FramePrivate::FramePrivate):
        * page/Frame.h:
        * page/FramePrivate.h:
        * page/FrameTree.cpp:
        (WebCore::FrameTree::parent):
        (WebCore::FrameTree::top):
        * page/FrameTree.h:

2008-07-25  Eric Seidel  <eric@webkit.org>

        Reviewed by Justin.

        Crash Safari when dragging images into Google presentations
        https://bugs.webkit.org/show_bug.cgi?id=20161

        Test: manual-tests/remove-on-drop-crash.html

        * editing/ReplaceSelectionCommand.cpp:
        (WebCore::ReplaceSelectionCommand::doApply):
        * manual-tests/remove-on-drop-crash.html: Added.

2008-07-30  Christian Dywan  <christian@twotoasts.de>

        Reviewed by Mark.

        Build fix for Cairo < 1.6

        * platform/graphics/cairo/PathCairo.cpp:
        (WebCore::Path::boundingRect): use cairo_stroke_extends for < 1.6

2008-07-29  Kevin McCullough  <kmccullough@apple.com>

        Reviewed by Geoff.

        <rdar://problem/6110314> Crash in profiler dereferencing null frame or
        page (20214)
        - Null check.

        * page/Console.cpp:
        (WebCore::Console::finishedProfiling):

2008-07-30  David Hyatt  <hyatt@apple.com>

        https://bugs.webkit.org/show_bug.cgi?id=18070
        
        Full page zoom needs to work properly with JS mouse events.  Make sure to adjust the coordinates of the
        JS mouse event to account for zoom.

        Reviewed by olliej

        * dom/EventTargetNode.cpp:
        (WebCore::EventTargetNode::dispatchMouseEvent):

2008-07-29  Sam Weinig  <sam@webkit.org>

        Reviewed by Darin Adler.

        Update Cross-site XMLHttpRequests using Access control to
        the latest spec. (Editor's Draft 8 July 2008)

        - This leaves us at about the same place as we previously were
          still needing preflight caching and better redirect support.

        * GNUmakefile.am:
        * WebCore.pro:
        * WebCore.vcproj/WebCore.vcproj:
        * WebCore.xcodeproj/project.pbxproj:
        * WebCoreSources.bkl:
        * xml/AccessControlList.cpp: Removed.
        * xml/AccessControlList.h: Removed.
        * xml/AccessItem.cpp: Removed.
        * xml/AccessItem.h: Removed.
        * xml/AccessItemRule.cpp: Removed.
        * xml/AccessItemRule.h: Removed.
        * xml/XMLHttpRequest.cpp:
        (WebCore::isOnAccessControlSimpleRequestHeaderWhitelist):
        (WebCore::XMLHttpRequest::XMLHttpRequest):
        (WebCore::XMLHttpRequest::isSimpleCrossSiteAccessRequest):
        (WebCore::XMLHttpRequest::makeCrossSiteAccessRequest):
        (WebCore::XMLHttpRequest::makeSimpleCrossSiteAccessRequest):
        (WebCore::XMLHttpRequest::makeCrossSiteAccessRequestWithPreflight):
        (WebCore::XMLHttpRequest::handleAsynchronousPreflightResult):
        (WebCore::XMLHttpRequest::abort):
        (WebCore::XMLHttpRequest::clearRequest):
        (WebCore::XMLHttpRequest::didFinishLoading):
        (WebCore::XMLHttpRequest::didFinishLoadingPreflight):
        (WebCore::XMLHttpRequest::accessControlCheck):
        (WebCore::XMLHttpRequest::didReceiveResponse):
        (WebCore::parseAccessControlAllowList):
        (WebCore::XMLHttpRequest::didReceiveResponsePreflight):
        * xml/XMLHttpRequest.h:

2008-07-29  Kevin Calhoun  <kcalhoun@apple.com>

        Reviewed by Adele.

        Fix for <rdar://problem/6060647> Adopt QTMovieOpenForPlaybackAttribute flag

        * platform/graphics/mac/MediaPlayerPrivateQTKit.mm: (WebCore::MediaPlayerPrivate::createQTMovie):

2008-07-29  Kevin Calhoun  <kcalhoun@apple.com>

        Reviewed by Adele.

        Fix for <rdar://problem/6031021> Make standalone video render more like the quicktime plugin to improve performance

        For standalone video, use QTMovieView to draw.

        * platform/graphics/mac/MediaPlayerPrivateQTKit.mm:
        (WebCore::MediaPlayerPrivate::createQTMovieView): Moved nil checks to setUpVideoRendering.
         Associate the QTMovieView with the WebCoreMovieObserver.
         If we're in a media document, allow QTMovieView to render in its default mode; otherwise tell it to draw synchronously. 
        (WebCore::MediaPlayerPrivate::detachQTMovieView): Set the WebCoreMovieObserver's view to nil.
        (WebCore::MediaPlayerPrivate::createQTVideoRenderer): Nil check is now in setUpVideoRendering, which is the only caller of this.
        (WebCore::MediaPlayerPrivate::setUpVideoRendering): Added nil checks.  Call createQTMovieView for media documents.
        (WebCore::MediaPlayerPrivate::tearDownVideoRendering): Call detachQTMovieView if a QTMovieView exists.
        (WebCore::MediaPlayerPrivate::setRect): Call setFrame on the QTMovieView if necessary.
        (-[WebCoreMovieObserver menuForEventDelegate:]): Added. Returns the frame view's menu.
        (-[WebCoreMovieObserver setView:]): Added.

2008-07-29  Adele Peterson  <adele@apple.com>

        Reviewed by Dan Bernstein.

        Fix for <rdar://problem/6073372> Move built-in controls below <video> element for standalone media documents

        * css/CSSSelector.cpp: (WebCore::CSSSelector::extractPseudoType): Added -webkit-full-page-media pseudo class.
        * css/CSSSelector.h: (WebCore::CSSSelector::): Added PseudoFullPageMedia.
        * css/CSSStyleSelector.cpp: (WebCore::CSSStyleSelector::SelectorChecker::checkOneSelector): Added case to
        apply PseudoFullPageMedia for elements in a full page media document.

        * css/html4.css: Added rule to shift control panel down for video in standalone media documents.

        * rendering/RenderMedia.cpp:
        (WebCore::RenderMedia::lowestPosition): Added implementation that takes the controls into account.
        This makes sure that scrollbars on the page will account for controls not directly contained in the RenderMedia.
        (WebCore::RenderMedia::rightmostPosition): ditto.
        (WebCore::RenderMedia::leftmostPosition): ditto.
        * rendering/RenderMedia.h:

2008-07-29  Sam Weinig  <sam@webkit.org>

        Reviewed by Anders Carlsson.

        <rdar://problem/6084585> Investigate upload progress events.

        - Add progress notifications for data being sent via a ResourceHandle.
        - Add XMLHttpRequestUpload support.

        Upload notifications only work on the Mac right now as the CFNetwork API
        on windows does not expose enough information.

        Tests: http/tests/xmlhttprequest/upload-onload-event.html
               http/tests/xmlhttprequest/upload-onloadstart-event.html
               http/tests/xmlhttprequest/upload-onprogress-event.html
               http/tests/xmlhttprequest/upload-progress-events.html

        * DerivedSources.make:
        * GNUmakefile.am:
        * WebCore.pro:
        * WebCore.vcproj/WebCore.vcproj:
        * WebCore.xcodeproj/project.pbxproj:
        * WebCoreSources.bkl:
        * bindings/js/JSEventTargetBase.cpp:
        (WebCore::toJS):
        * bindings/js/JSXMLHttpRequestCustom.cpp:
        (WebCore::JSXMLHttpRequest::mark):
        * bindings/js/JSXMLHttpRequestUploadCustom.cpp: Added.
        (WebCore::JSXMLHttpRequestUpload::mark):
        (WebCore::JSXMLHttpRequestUpload::onabort):
        (WebCore::JSXMLHttpRequestUpload::setOnabort):
        (WebCore::JSXMLHttpRequestUpload::onerror):
        (WebCore::JSXMLHttpRequestUpload::setOnerror):
        (WebCore::JSXMLHttpRequestUpload::onload):
        (WebCore::JSXMLHttpRequestUpload::setOnload):
        (WebCore::JSXMLHttpRequestUpload::onloadstart):
        (WebCore::JSXMLHttpRequestUpload::setOnloadstart):
        (WebCore::JSXMLHttpRequestUpload::onprogress):
        (WebCore::JSXMLHttpRequestUpload::setOnprogress):
        (WebCore::JSXMLHttpRequestUpload::addEventListener):
        (WebCore::JSXMLHttpRequestUpload::removeEventListener):
        (WebCore::JSXMLHttpRequestUpload::dispatchEvent):
        * dom/EventTarget.cpp:
        (WebCore::EventTarget::toXMLHttpRequestUpload):
        * dom/EventTarget.h:
        * loader/ResourceLoader.cpp:
        (WebCore::ResourceLoader::didSendData):
        * loader/ResourceLoader.h:
        * loader/SubresourceLoader.cpp:
        (WebCore::SubresourceLoader::didSendData):
        * loader/SubresourceLoader.h:
        * loader/SubresourceLoaderClient.h:
        (WebCore::SubresourceLoaderClient::didSendData):
        * page/DOMWindow.idl:
        * platform/network/FormData.cpp:
        (WebCore::FormData::FormData):
        * platform/network/FormData.h:
        (WebCore::FormData::alwaysStream):
        (WebCore::FormData::setAlwaysStream):
        * platform/network/ResourceHandleClient.h:
        (WebCore::ResourceHandleClient::didSendData):
        * platform/network/mac/FormDataStreamMac.h:
        * platform/network/mac/FormDataStreamMac.mm:
        (WebCore::getStreamFormDataMap):
        (WebCore::getStreamResourceHandleMap):
        (WebCore::associateStreamWithResourceHandle):
        (WebCore::disassociateStreamWithResourceHandle):
        (WebCore::DidSendDataCallbackData::DidSendDataCallbackData):
        (WebCore::performDidSendDataCallback):
        (WebCore::formCreate):
        (WebCore::formFinalize):
        (WebCore::formRead):
        (WebCore::setHTTPBody):
        (WebCore::httpBodyFromStream):
        * platform/network/mac/ResourceHandleMac.mm:
        (WebCore::ResourceHandle::start):
        (WebCore::ResourceHandle::cancel):
        (-[WebCoreResourceHandleAsDelegate connection:willSendRequest:redirectResponse:]):
        (-[WebCoreResourceHandleAsDelegate connectionDidFinishLoading:]):
        (-[WebCoreResourceHandleAsDelegate connection:didFailWithError:]):
        * xml/XMLHttpRequest.cpp:
        (WebCore::XMLHttpRequest::XMLHttpRequest):
        (WebCore::XMLHttpRequest::~XMLHttpRequest):
        (WebCore::XMLHttpRequest::upload):
        (WebCore::XMLHttpRequest::open):
        (WebCore::XMLHttpRequest::send):
        (WebCore::XMLHttpRequest::createRequest):
        (WebCore::XMLHttpRequest::abort):
        (WebCore::XMLHttpRequest::networkError):
        (WebCore::XMLHttpRequest::abortError):
        (WebCore::XMLHttpRequest::didSendData):
        * xml/XMLHttpRequest.h:
        (WebCore::XMLHttpRequest::optionalUpload):
        * xml/XMLHttpRequest.idl:
        * xml/XMLHttpRequestUpload.cpp: Added.
        (WebCore::XMLHttpRequestUpload::XMLHttpRequestUpload):
        (WebCore::XMLHttpRequestUpload::addEventListener):
        (WebCore::XMLHttpRequestUpload::removeEventListener):
        (WebCore::XMLHttpRequestUpload::dispatchEvent):
        (WebCore::XMLHttpRequestUpload::dispatchXMLHttpRequestProgressEvent):
        (WebCore::XMLHttpRequestUpload::dispatchAbortEvent):
        (WebCore::XMLHttpRequestUpload::dispatchErrorEvent):
        (WebCore::XMLHttpRequestUpload::dispatchLoadEvent):
        (WebCore::XMLHttpRequestUpload::dispatchLoadStartEvent):
        (WebCore::XMLHttpRequestUpload::dispatchProgressEvent):
        * xml/XMLHttpRequestUpload.h: Added.
        (WebCore::XMLHttpRequestUpload::create):
        (WebCore::XMLHttpRequestUpload::toXMLHttpRequestUpload):
        (WebCore::XMLHttpRequestUpload::associatedXMLHttpRequest):
        (WebCore::XMLHttpRequestUpload::disconnectXMLHttpRequest):
        (WebCore::XMLHttpRequestUpload::setOnAbortListener):
        (WebCore::XMLHttpRequestUpload::onAbortListener):
        (WebCore::XMLHttpRequestUpload::setOnErrorListener):
        (WebCore::XMLHttpRequestUpload::onErrorListener):
        (WebCore::XMLHttpRequestUpload::setOnLoadListener):
        (WebCore::XMLHttpRequestUpload::onLoadListener):
        (WebCore::XMLHttpRequestUpload::setOnLoadStartListener):
        (WebCore::XMLHttpRequestUpload::onLoadStartListener):
        (WebCore::XMLHttpRequestUpload::setOnProgressListener):
        (WebCore::XMLHttpRequestUpload::onProgressListener):
        (WebCore::XMLHttpRequestUpload::eventListeners):
        (WebCore::XMLHttpRequestUpload::refEventTarget):
        (WebCore::XMLHttpRequestUpload::derefEventTarget):
        * xml/XMLHttpRequestUpload.idl: Added.

2008-07-29  Maxime Britto  <britto@apple.com>

        Reviewed by Darin.

        <rdar://problem/6095023> "When pan-scrolling, mouse click on hyperlink stop the pan-Scroll but follow the link after that."
        With this patch we now stop the pan scroll and swallow the event to prevent any following action.

        * page/EventHandler.cpp:
        (WebCore::EventHandler::handleMousePressEvent): If we were in pan scrolling mode we no longer just stop the pan scroll and continue with the function, we now stop and return true to attest that we swallowed the event.

2008-07-29  Maxime Britto  <britto@apple.com>

        Reviewed by adele.

        Test: fast/events/autoscroll-in-textfield.html

        * rendering/RenderObject.cpp:
        (WebCore::RenderObject::canBeProgramaticallyScrolled): reverted a bad change introduced in r35244
        nb:the test case introduced in r35244 is still working.

2008-07-29  Maxime Britto  <britto@apple.com>

        Reviewed by adele.
        This test verifies that the autoscroll works within textfields.

        * fast/events/autoscroll-in-textfield-expected.txt: Added.
        * fast/events/autoscroll-in-textfield.html: Added.

2008-07-29  Adele Peterson  <adele@apple.com>

        Reviewed by Sammy Weinig.

        Fix for <rdar://problem/6103024>
        When a QT movie is loaded directly in the browser, I can't pause it by single-clicking on the video

        Test: media/video-click-dlbclick-standalone.html

        * loader/MediaDocument.cpp: (WebCore::MediaDocument::defaultEventHandler): For standalone media documents,
        match the default Quicktime plugin behavior to allow clicking and double-clicking to pause and play the media.
        * loader/MediaDocument.h: Added defaultEventHandler.

        * html/HTMLMediaElement.cpp: (WebCore::HTMLMediaElement::defaultEventHandler): Return early if the event has been handled.
        * rendering/MediaControlElements.cpp:
        (WebCore::MediaControlMuteButtonElement::defaultEventHandler): Correct what was probably a typo.  Instead of "event->defaultHandled()",
         it is supposed to be "event->setDefaultHandled()".
        (WebCore::MediaControlPlayButtonElement::defaultEventHandler): ditto.
        (WebCore::MediaControlSeekButtonElement::defaultEventHandler): ditto.
        (WebCore::MediaControlFullscreenButtonElement::defaultEventHandler): ditto.

2008-07-29  Dan Bernstein  <mitz@apple.com>

        Reviewed by Dave Hyatt.

        - fix <rdar://problem/6059648> Some content not visible when the window is short at courtneyalbright.com

        Test: fast/overflow/float-in-relpositioned.html

        * rendering/RenderBlock.cpp:
        (WebCore::RenderBlock::lowestPosition): Add this block's relative offset
        to floats' and positioned objects' lowest position.
        (WebCore::RenderBlock::rightmostPosition): Ditto.
        (WebCore::RenderBlock::leftmostPosition): Ditto.
        * rendering/RenderBox.cpp:
        (WebCore::RenderBox::lowestPosition): Removed redundant test.
        (WebCore::RenderBox::rightmostPosition): Ditto.
        (WebCore::RenderBox::leftmostPosition): Ditto.

2008-07-29  Dan Bernstein  <mitz@apple.com>

        Reviewed by Dave Hyatt.

        - fix <rdar://problem/6048566> Repaint original element's position, not its offset position

        Test: fast/repaint/layout-state-relative.html

        * rendering/RenderBox.cpp:
        (WebCore::RenderBox::absolutePosition): Changed the LayoutState-enabled
        code path to account for the object's relative offset.
        (WebCore::RenderBox::computeAbsoluteRepaintRect): Ditto.

2008-07-29  Keishi Hattori  <casey.hattori@gmail.com>

        Fixed Bug 19158: Inspector should support console.group/console.groupEnd

        <https://bugs.webkit.org/show_bug.cgi?id=19158>

        Reviewed by Tim Hatcher and Adam Roben.

        * bindings/js/JSConsoleCustom.cpp:
        (WebCore::JSConsole::group): Added.
        * page/Console.cpp:
        (WebCore::Console::group): Added.
        (WebCore::Console::groupEnd): Added.
        * page/Console.h:
        (WebCore::):
        * page/Console.idl: Added group/groupEnd.
        * page/InspectorController.cpp:
        (WebCore::ConsoleMessage::ConsoleMessage):
        (WebCore::InspectorController::InspectorController): Added m_groupLevel.
        (WebCore::InspectorController::addMessageToConsole): Added groupLevel argument.
        (WebCore::InspectorController::startGroup): Increments m_groupLevel by one and calls js function if needed.
        (WebCore::InspectorController::endGroup): Decrements m_groupLevel by one and calls js function if needed.
        (WebCore::InspectorController::addScriptConsoleMessage): Added groupLevel argument.
        (WebCore::InspectorController::didCommitLoad): Resets m_groupLevel.
        * page/InspectorController.h:
        * page/inspector/Console.js:
        (WebInspector.Console): Added groupLevel and currentGroup topGroup.
        (WebInspector.Console.addMessage): Calls addMessage method in the currentGroup.
        (WebInspector.Console.startGroup): Added.
        (WebInspector.Console.endGroup): Added.
        (WebInspector.Console.clearMessages): Resets groupLevel and currentGroup.
        (WebInspector.ConsoleMessage): Added groupLevel property.
        (WebInspector.ConsoleMessage.MessageLevel.GroupTitle): Added.
        (WebInspector.ConsoleGroup): Added.
        (WebInspector.ConsoleGroup.addMessage): Adds console message to group.
        (WebInspector.ConsoleGroup._titleClicked): Adds "collapsed" style class.
        * page/inspector/inspector.css:
        * page/inspector/inspector.js:
        (WebInspector.startGroupInConsole): Calls console.startGroup
        (WebInspector.endGroupInConsole): Calls console.endGroup

2008-07-29  Adam Roben  <aroben@apple.com>

        Add names for WebCore's threads

        Reviewed by Anders Carlsson.

        * loader/icon/IconDatabase.cpp:
        (WebCore::IconDatabase::open):
        * storage/DatabaseThread.cpp:
        (WebCore::DatabaseThread::start):
        * storage/LocalStorageThread.cpp:
        (WebCore::LocalStorageThread::start):
        Pass in names to createThread.

        * platform/network/cf/ResourceHandleCFNet.cpp:
        (WebCore::runLoaderThread):
        (WebCore::ResourceHandle::loaderRunLoop):
        Changed to use WTF::createThread.

2008-07-28  Anders Carlsson  <andersca@apple.com>

        Reviewed by Kevin Decker.

        Based on a patch from Dimcho Balev.
        
        Windows part of 
    
        https://bugs.webkit.org/show_bug.cgi?id=18676
        <rdar://problem/6106578>
        Plug-In API Proposal: Enable plugins to receive response body when an HTTP error occurs

        * plugins/PluginStream.cpp:
        (WebCore::PluginStream::wantsAllStreams):
        * plugins/PluginStream.h:

2008-07-28  Brady Eidson  <beidson@apple.com>

        Reviewed by Sam Weinig

        Test: security/autocomplete-cleared-on-back.html

        <rdar://problem/6093281> - autocomplete="off" should work when going back

        Taken care of in two ways:
        1 - Listening for the page cache notification to clear the form, in cases where the page
            is being restored from the page cache
        2 - Not saving such form elements when doing the normal "save state" to a history item,
            for cases with no page cache

        * html/HTMLFormElement.cpp:
        (WebCore::HTMLFormElement::~HTMLFormElement):
        (WebCore::HTMLFormElement::parseMappedAttribute):
        (WebCore::HTMLFormElement::didRestoreFromCache):
        (WebCore::HTMLFormElement::willMoveToNewOwnerDocument):
        (WebCore::HTMLFormElement::didMoveToNewOwnerDocument):
        * html/HTMLFormElement.h:

        * html/HTMLInputElement.cpp:
        (WebCore::HTMLInputElement::~HTMLInputElement):
        (WebCore::HTMLInputElement::setInputType):
        (WebCore::HTMLInputElement::saveState):
        (WebCore::HTMLInputElement::parseMappedAttribute):
        (WebCore::HTMLInputElement::needsCacheCallback):
        (WebCore::HTMLInputElement::registerForCacheCallbackIfNeeded): Only register if the type or attribute
          indicate we should.
        (WebCore::HTMLInputElement::unregisterForCacheCallbackIfNeeded): Only unregister if both the type
          and attribute are clear of needing registration.
        (WebCore::HTMLInputElement::didRestoreFromCache):
        (WebCore::HTMLInputElement::willMoveToNewOwnerDocument):
        (WebCore::HTMLInputElement::didMoveToNewOwnerDocument):
        * html/HTMLInputElement.h:

2008-07-28  David Hyatt  <hyatt@apple.com>

        Add support for CSS variable declaration blocks.

        Reviewed by Sam

        Added tests in fast/css/variables.

        * css/CSSGrammar.y:
        * css/CSSMutableStyleDeclaration.h:
        (WebCore::CSSMutableStyleDeclaration::isMutableStyleDeclaration):
        * css/CSSParser.cpp:
        (WebCore::CSSParser::addVariableDeclarationBlock):
        * css/CSSParser.h:
        * css/CSSProperty.cpp:
        (WebCore::CSSProperty::cssText):
        * css/CSSPropertyNames.in:
        * css/CSSStyleSelector.cpp:
        (WebCore::CSSStyleSelector::addMatchedDeclaration):
        (WebCore::CSSStyleSelector::resolveVariablesForDeclaration):
        * css/CSSStyleSelector.h:
        * css/CSSValueList.h:
        (WebCore::CSSValueList::isValueList):
        * css/CSSVariablesDeclaration.cpp:
        (WebCore::CSSVariablesDeclaration::CSSVariablesDeclaration):
        (WebCore::CSSVariablesDeclaration::getVariableValue):
        (WebCore::CSSVariablesDeclaration::removeVariable):
        (WebCore::CSSVariablesDeclaration::addParsedVariable):
        (WebCore::CSSVariablesDeclaration::getParsedSimpleVariable):
        (WebCore::CSSVariablesDeclaration::getParsedComplexVariable):
        * css/CSSVariablesDeclaration.h:
        (WebCore::CSSVariablesDeclaration::create):
        * css/StyleBase.cpp:
        (WebCore::StyleBase::cssText):
        * css/StyleBase.h:
        (WebCore::StyleBase::isValueList):
        (WebCore::StyleBase::isMutableStyleDeclaration):

2008-07-28  Anders Carlsson  <andersca@apple.com>

        Reviewed by Sam.

        <rdar://problem/6098335>
        https://bugs.webkit.org/show_bug.cgi?id=20150
        
        Handle willSendRequest correctly.

        * loader/SubresourceLoader.cpp:
        (WebCore::SubresourceLoader::willSendRequest):
        Make sure to keep the previous URL around so we know when to call willSendRequest.
        
        * xml/XMLHttpRequest.cpp:
        (WebCore::XMLHttpRequest::processSyncLoadResults):
        Abort if we don't have access to the response URL.
        
        (WebCore::XMLHttpRequest::willSendRequest):
        Dispatch a network error if we can't access the new URL.

2008-07-28  Geoffrey Garen  <ggaren@apple.com>

        Reviewed by Sam Weinig.

        Renamed "ConstructTypeNative" => "ConstructTypeHost".
        
2008-07-28  Anders Carlsson  <andersca@apple.com>

        Reviewed by Kevin Decker.

        Based on a patch by Dimcho Balev.

        https://bugs.webkit.org/show_bug.cgi?id=18676
        <rdar://problem/6106578>
        Plug-In API Proposal: Enable plugins to receive response body when an HTTP error occurs
        
        * bridge/npapi.h:
        Add new enum values.
        
        * loader/NetscapePlugInStreamLoader.cpp:
        (WebCore::NetscapePlugInStreamLoader::didReceiveResponse):
        When the plug-in indicates that it wants all streams to be delivered, don't cancel the stream
        if an error occurs.
        
        * loader/NetscapePlugInStreamLoader.h:
        (WebCore::NetscapePlugInStreamLoaderClient::wantsAllStreams):
        Add new client method.

2008-07-27  Sam Weinig  <sam@webkit.org>

        Reviewed by Oliver Hunt.

        Fix for https://bugs.webkit.org/show_bug.cgi?id=20176
        querySelectorAll id optimization no longer working

        Turn the querySelector/querySelectorAll id optimization back on
        for only strict and almost strict mode.  In quirks mode, the optimiztion
        won't work as the id match is not case sensitive.

        Tests: fast/dom/SelectorAPI/caseID-almost-strict.html
               fast/dom/SelectorAPI/caseID-strict.html
               fast/dom/SelectorAPI/caseID.html

        * dom/Node.cpp:
        (WebCore::Node::querySelector):
        (WebCore::Node::querySelectorAll):
        * dom/SelectorNodeList.cpp:
        (WebCore::createSelectorNodeList):
        * dom/SelectorNodeList.h:

2008-07-27  Anatoli Papirovski  <apapirovski@mac.com>

        Reviewed by Dave Hyatt.

        Fix for https://bugs.webkit.org/show_bug.cgi?id=14346
        Modified the css parser:
        - not to fail when closing braces are not found for 
          a declaration at the end of the file
        - not to accept "!important fail" as valid
        - to keep accepting @import when it comes after invalid @ rules
        - not to drop the whole @media block when there's an error before the 
          closing brace
        + some other minor css parsing revisions.

        CSSGrammar.y tweaked by David Kilzer to fix Tiger builds.

        * css/CSSGrammar.y:

2008-07-27  Jan Michael Alonzo  <jmalonzo@webkit.org>

        Reviewed by Eric Seidel.

        Use --outputDir instead of --output when invoking make_names.pl
        There's no option named "output" in make_names.pl

        * GNUmakefile.am:
        * WebCore.pro:
        * DerivedSources.make: Remove --output. Not necessary here.
        * bindings/scripts/generate-bindings.pl: Rename --outputdir to
          --outputDir for consistency with make_names.pl

2008-07-26  Dirk Schulze  <vbs85@gmx.de>

        Reviewed by Eric Seidel.

        http://bugs.webkit.org/show_bug.cgi?id=18694
        [CAIRO] Problem with rotation in a given matrix in SVG

        Changed values given to AffineTransform.

        * platform/graphics/cairo/AffineTransformCairo.cpp:
        (WebCore::AffineTransform::AffineTransform):
        (WebCore::AffineTransform::setMatrix):

2008-07-26  Jan Michael Alonzo  <jmalonzo@webkit.org>

        Reviewed by Mark Rowe.

        Call curl_global_cleanup() to release resources acquired by curl_global_init()

        * platform/network/curl/ResourceHandleManager.cpp:
        (WebCore::ResourceHandleManager::~ResourceHandleManager):

2008-07-26  Marc Ordinas i Llopis  <marc.ordinasillopis@collabora.co.uk>

        Reviewed by Simon Hausmann.

        Bug 18938: [GTK] Plugins not resized
        https://bugs.webkit.org/show_bug.cgi?id=18938

        * plugins/PluginView.cpp:
        (WebCore::PluginView::setFrameGeometry): When viewing a full-page
        plugin in unix, geometry changes have to be passed to the plugin.

2008-07-26  Keishi Hattori  <casey.hattori@gmail.com>

        Reviewed by Adam Roben.

        Add console.time/timeEnd.
        https://bugs.webkit.org/show_bug.cgi?id=19159

        * manual-tests/inspector/console-time.html: Added. Test cases for console.time/timeEnd.
        * page/Console.cpp:
        (WebCore::Console::time): Added.
        (WebCore::Console::timeEnd): Added.
        * page/Console.h:
        * page/Console.idl: Added console.time/timeEnd.
        * page/InspectorController.cpp:
        (WebCore::InspectorController::startTiming): Added.
        (WebCore::InspectorController::stopTiming): Added.
        * page/InspectorController.h:

2008-07-26  Dirk Schulze  <vbs85@gmx.de>

        Reviewed by Nikolas Zimmermann.

        Fixes rendering issues with gradients in SVG/Cairo.

        * platform/graphics/cairo/PathCairo.cpp:
        (WebCore::Path::boundingRect):
        * svg/graphics/cairo/SVGPaintServerGradientCairo.cpp:
        (WebCore::applyStrokeStyleToContext):
        (WebCore::SVGPaintServerGradient::setup):

2008-07-26  Dirk Schulze  <vbs85@gmx.de>

        Reviewed by Nikolas Zimmermann.

        Added pattern-support for SVG in Cairo.

        * svg/graphics/cairo/SVGPaintServerPatternCairo.cpp:
        (WebCore::applyStrokeStyleToContext):
        (WebCore::SVGPaintServerPattern::setup):

2008-07-26  Keishi Hattori  <casey.hattori@gmail.com>

        Reviewed by Adam Roben.

        Fixed bug 18540: console.log('multiple', 'strings') quotes all strings after the first
        <https://bugs.webkit.org/show_bug.cgi?id=18540>

        * page/inspector/Console.js:
        (WebInspector.ConsoleMessage.prototype._format): String arguments are appended without formatting.

2008-07-26  Anthony Ricaud  <rik24d@gmail.com>

        Reviewed by Tim Hatcher.

        <https://bugs.webkit.org/show_bug.cgi?id=20055> Line highlighting should last longer

        Restore the fade out effect after highlighting.

        * page/inspector/SourceFrame.js: Add a class for fade-out effects and sets it at the end of highlighting time.

2008-07-26  Michelangelo De Simone  <michelangelo@me.com>

        Reviewed by Adele Petersen.

        Added the simple willValidate attribute to form controls according to
        WebForms 2 spec.

        URL: http://www.w3.org/TR/web-forms-2/#willvalidate

        Tests: fast/forms/willvalidate-000.html
               fast/forms/willvalidate-001.html
               fast/forms/willvalidate-002.html
               fast/forms/willvalidate-003.html
               fast/forms/willvalidate-004.html
               fast/forms/willvalidate-005.html
               fast/forms/willvalidate-006.html
               fast/forms/willvalidate-007.html
               fast/forms/willvalidate-008.html
               fast/forms/willvalidate-009.html

        * html/HTMLButtonElement.h: Added willValidate(), always false.
        * html/HTMLButtonElement.idl: willValidate attribute exposed.
        * html/HTMLFieldSetElement.h: Added willValidate(), always false.
        * html/HTMLFieldSetElement.idl: willValidate attribute exposed.
        * html/HTMLFormControlElement.cpp: (WebCore::HTMLFormControlElement::willValidate):
        Added base willValidate() implementation.
        * html/HTMLFormControlElement.h: Added willValidate().
        * html/HTMLInputElement.cpp: (WebCore::HTMLInputElement::willValidate):
        Added willValidate(), checks for input type.
        * html/HTMLInputElement.h: Added willValidate()
        * html/HTMLInputElement.idl: willValidate attribute exposed.
        * html/HTMLSelectElement.idl: willValidate attribute exposed.
        * html/HTMLTextAreaElement.idl: willValidate attribute exposed.

2008-07-26  Mark Rowe  <mrowe@apple.com>

        Build fix.

        * loader/FrameLoader.cpp:
        (WebCore::FrameLoader::load): Use 0 rather than nil as this is a C++ file.

2008-07-26  Mark Rowe  <mrowe@apple.com>

        Build fix.

        * loader/FrameLoader.h: Use 0 rather than nil as this is a C++ header.

2008-07-26  Daniel Jalkut  <jalkut@red-sweater.com>

        Reviewed by Geoff Garen.

        Revised the FrameLoader class to clean up a variety of load methods, and hopefully
        move things closer to integrating into a smaller set of load methods. To this
        end, I renamed many of the overloaded load() methods to have more meaningful and 
        easier to search names.  I added comments to the header file to provide clues as 
        to how many of the load methods are being used, and how they fit into the loading 
        process. I suspect that the renamed methods and comments indicating their present 
        usage will facilitate easier cleanup by myself and others as inspiration strikes.

        Updated clients of FrameLoader where necessary to adapt to the new method names and signatures.

        Combined the 3 canLoad() methods into a single canLoad which expresses the 
        intended logic of the 3 with a single method interface.

        Removed unnecessary "treatAsLocal" attribute of CachedResource. It was only called from
        one place in FrameLoader.cpp, and it derived at initialization time by calling back to FrameLoader.

        Removed unused userGesture parameter to one variant of the urlSelected method, and 
        moved one of the urlSelected methods so that it lives nearer to its overloaded 
        sibling.

        * WebCore.base.exp:
        * loader/Cache.cpp:
        (WebCore::Cache::requestResource):
        * loader/CachedResource.cpp:
        (WebCore::CachedResource::CachedResource):
        * loader/CachedResource.h:
        (WebCore::CachedResource::errorOccurred):
        * loader/FrameLoader.cpp:
        (WebCore::FrameLoader::createWindow):
        (WebCore::FrameLoader::urlSelected):
        (WebCore::FrameLoader::loadURLIntoChildFrame):
        (WebCore::FrameLoader::loadPlugin):
        (WebCore::FrameLoader::loadFrameRequestWithFormState):
        (WebCore::FrameLoader::loadFrameRequestWithFormAndValues):
        (WebCore::FrameLoader::loadURL):
        (WebCore::FrameLoader::loadWithNavigationAction):
        (WebCore::FrameLoader::load):
        (WebCore::FrameLoader::loadWithDocumentLoader):
        (WebCore::FrameLoader::canLoad):
        (WebCore::FrameLoader::reloadAllowingStaleData):
        (WebCore::FrameLoader::reload):
        (WebCore::FrameLoader::continueLoadAfterWillSubmitForm):
        (WebCore::FrameLoader::submitForm):
        (WebCore::FrameLoader::loadPostRequest):
        (WebCore::FrameLoader::continueLoadAfterNewWindowPolicy):
        (WebCore::FrameLoader::loadItem):
        * loader/FrameLoader.h:
        * loader/SubresourceLoader.cpp:
        (WebCore::SubresourceLoader::create):
        * page/ContextMenuController.cpp:
        (WebCore::ContextMenuController::contextMenuItemSelected):

2008-07-26  Sam Weinig  <sam@webkit.org>

        Reviewed by Dan Bernstein.

        Fix https://bugs.webkit.org/show_bug.cgi?id=20122
        <rdar://problem/6089522>
        REGRESSION (r35075-r35110): Cannot enlarge images at Apple Store product page

        Use strict parsing when in AlmostStrict mode.

        Tests: fast/dom/SelectorAPI/dumpNodeList-almost-strict.html
               fast/dom/SelectorAPI/id-fastpath-almost-strict.html
               fast/dom/SelectorAPI/id-fastpath-strict.html

        * dom/Node.cpp:
        (WebCore::Node::querySelector):
        (WebCore::Node::querySelectorAll):

2008-07-25  Ariya Hidayat  <ariya.hidayat@trolltech.com>

        Reviewed by Simon.

        Switch off QPainter's anti aliasing when painting the widgets using QStyle
        because otherwise the widgets will look blurry and not crisp.

        * platform/qt/RenderThemeQt.cpp:
        (WebCore::StylePainter::StylePainter):
        (WebCore::StylePainter::~StylePainter):
        * platform/qt/RenderThemeQt.h:

2008-07-25  Dan Bernstein  <mitz@apple.com>

        Reviewed by Anders Carlsson.

        - fix crash due to re-entering purgeInactiveFontData() now that it is
          called by releaseFontData()

        Not testable in DumpRenderTree

        * platform/graphics/FontCache.cpp:
        (WebCore::FontCache::purgeInactiveFontData): Added a reentry guard.

2008-07-25  Brady Eidson  <beidson@apple.com>

        Reviewed by Sam

        Test: security/set-form-autocomplete-attribute.html

        Part of the fix for <rdar://problem/6093281> - Improper handling of autocomplete

        The autocomplete attribute works on both <form> and <input> elements, but was not
        inherited properly when someone asked an <input> if it should autocomplete.

        I fixed this up based on the rules in the current WF2 spec so if the <input> element
        has its own autocomplete attribute set, it will follow that but otherwise it will
        inherit from its parent <form>

        * WebCore.base.exp:

        * html/HTMLInputElement.cpp:
        (WebCore::HTMLInputElement::init):
        (WebCore::HTMLInputElement::autoComplete):
        (WebCore::HTMLInputElement::parseMappedAttribute):
        * html/HTMLInputElement.h:
        (WebCore::HTMLInputElement::):

2008-07-25  Wouter Bolsterlee  <uws+webkit@xs4all.nl>

        Reviewed by Holger Freyther.

        https://bugs.webkit.org/show_bug.cgi?id=20078
        [GTK] Use G_* macros instead of deprecated GTK_* macros in gtk2xtbin.h

        * plugins/gtk/gtk2xtbin.h:

2008-07-25  Anders Carlsson  <andersca@apple.com>

        Reviewed by Sam.

        Add workaround for a Leopard bug which causes webarchive/test-xml-stylesheet.xml to fail.

        * platform/network/mac/WebCoreURLResponse.mm:
        (-[NSURLResponse _webcore_MIMEType]):

2008-07-25  chris fleizach  <cfleizach@apple.com>

        Reviewed by Beth Dakin

        <rdar://problem/6084806> AX: REGRESSION: returned line number from TextArea is incorrect

        Tests: accessibility/textarea-insertion-point-line-number.html
               accessibility/textarea-line-for-index.html

        * page/AccessibilityObject.cpp:
        (WebCore::AccessibilityObject::lineForPosition):
        * page/AccessibilityObject.h:
        * page/mac/AccessibilityObjectWrapper.mm:
        (-[AccessibilityObjectWrapper accessibilityAttributeValue:]):
        (-[AccessibilityObjectWrapper accessibilityAttributeValue:forParameter:]):

2008-07-25  Jacob Refstrup  <jacob.refstrup@hp.com>

        Reviewed by mitz.

        - fix https://bugs.webkit.org/show_bug.cgi?id=17906
        <rdar://problem/5805741> white-space: pre-wrap or -webkit-line-break: after-white-space text can overlap float at end of line
        
        Test: fast/block/float/editable-text-overlapping-float.html

        * rendering/RenderBlock.h:
        * rendering/bidi.cpp:
        (WebCore::RenderBlock::skipTrailingWhitespace):
        - renamed to reflect usage and removed call to position floats; 
          they only get added
        (WebCore::RenderBlock::skipLeadingWhitespace):
        - renamed to reflect usage
        (WebCore::RenderBlock::findNextLineBreak):
        - use skipTrailingWhitespace at end of line (as before but with new
          name)

2008-07-25  Dan Bernstein  <mitz@apple.com>

        Reviewed by Sam Weinig.

        - Finish fixing https://bugs.webkit.org/show_bug.cgi?id=17097
          <rdar://problem/5715471> CGFontRefs (and HFONTs on Windows) leak because FontCache grows without bound

        * platform/graphics/FontCache.cpp:
        (WebCore::FontDataCacheKeyTraits): Changed needsDestruction to true because FontPlatformData
        instances hold references to the platform resources and release them in the destructor.
        (WebCore::cTargetInactiveFontData): Added, replacing cInactiveFontDataPurgeRatio with the
        number of inactive FontData instances to leave in the cache when automatically purging.
        (WebCore::FontCache::getCachedFontData): Moved the code that checks if there are too many
        inactive FontData instances and if so calls purgeInactiveFontData() from here...
        (WebCore::FontCache::releaseFontData): ... to here.
        (WebCore::FontCache::purgeInactiveFontData): Added code to also purge the platform font data
        cache. All FontPlatformData instances that do not have entries in the font data cache are
        removed, thus releasing the platform resources (such as HFONTs and NSFonts).

2008-07-24  David Hyatt  <hyatt@apple.com>

        Add support for an alternate syntax for CSS variables.  Testers on www-style will be able to try out
        both versions of the syntax in WebKit to help us make a decision regarding which one to go with.

        Reviewed by Dan

        Added fast/css/variables/alternate-syntax/ (duplicated all existing CSS variables tests)

        * css/CSSGrammar.y:
        * css/CSSParser.cpp:
        (WebCore::CSSParser::createVariablesRule):
        (WebCore::CSSParser::checkForVariables):
        * css/CSSParser.h:
        * css/CSSParserValues.cpp:
        (WebCore::CSSParserValue::isVariable):
        (WebCore::CSSParserValueList::addValue):
        (WebCore::CSSParserValueList::deleteValueAt):
        (WebCore::CSSParserValue::createCSSValue):
        * css/CSSParserValues.h:
        * css/CSSPrimitiveValue.cpp:
        (WebCore::CSSPrimitiveValue::cleanup):
        (WebCore::CSSPrimitiveValue::getStringValue):
        (WebCore::CSSPrimitiveValue::cssText):
        (WebCore::CSSPrimitiveValue::parserValue):
        * css/CSSPrimitiveValue.h:
        (WebCore::CSSPrimitiveValue::):
        (WebCore::CSSPrimitiveValue::isVariable):
        * css/CSSStyleSelector.cpp:
        (WebCore::CSSStyleSelector::addMatchedDeclaration):
        * css/CSSVariablesRule.cpp:
        (WebCore::CSSVariablesRule::CSSVariablesRule):
        (WebCore::CSSVariablesRule::cssText):
        * css/CSSVariablesRule.h:
        (WebCore::CSSVariablesRule::create):
        * css/maketokenizer:
        * css/tokenizer.flex:

2008-07-25  Maxime Britto  <britto@apple.com>

        Reviewed by Anders Carlsson.

        <rdar://6102387> "REGRESSION: horizontal scroll with the mouse wheel is inverted on some subframes"

        * page/EventHandler.cpp:
        (WebCore::EventHandler::handleWheelEvent): Inverted the scroll direction relative to the delta value (positive scrolls left,negative scrolls right)

2008-07-25  Adele Peterson  <adele@apple.com>

        Another build fix.

        * platform/win/PlatformScrollBarSafari.cpp:
        (WebCore::PlatformScrollbar::paint):

2008-07-25  Adele Peterson  <adele@apple.com>

        More build fixes.

        * platform/win/PlatformScrollBarSafari.cpp:
        (WebCore::PlatformScrollbar::paint):

2008-07-25  Adele Peterson  <adele@apple.com>

        Build fix.

        * platform/win/PlatformScrollBarSafari.cpp:

2008-07-24  Tor Arne Vestbø  <tavestbo@trolltech.com>

        Reviewed by Simon

        Provide access to the underlying QKeyEvent in PlatformKeyboardEvent.

        * platform/PlatformKeyboardEvent.h: add accessor and member.
        * platform/qt/PlatformKeyboardEventQt.cpp: copy pointer in ctor.
        (WebCore::PlatformKeyboardEvent::PlatformKeyboardEvent):

2008-07-25  Simon Hausmann  <hausmann@webkit.org>

        Fix linking of QtWebKit against the statically built JavaScriptCore
        library, under Windows/Mac we may need _d/_debug suffixes.

        * WebCore.pro:

2008-07-25  Simon Hausmann  <hausmann@webkit.org>

        Rubber-stamped by Lars.

        Fix the Qt build by adapting to the latest ArgList API changes and
        replacing the inclusion of npapi.h in MainThreadScheduler with a forward
        declaration of NPP to avoid an include conflict. npapi.h on X11 includes
        X headers, which include wonderful defines such as "#define Status" that
        cause conflicts.

        * bridge/qt/qt_runtime.cpp:
        (KJS::Bindings::findMethodIndex):
        (KJS::Bindings::QtRuntimeConnectionMethod::call):
        * plugins/PluginMainThreadScheduler.h:

2008-07-25  Simon Hausmann  <hausmann@webkit.org>

        Discussed with and rubber-stamped by Lars.

        Fix the build system for the Qt port.

        Recent JavaScriptCore changes require the addition of JavaScriptCore/API to the
        include search path. With a build process that combines JavaScriptCore and
        WebCore in one build process/Makefile the existance of
        JavaScriptCore/API/Node.h and WebCore/dom/Node.h causes include conflicts.

        This commit solves this by introducing a separate build of JavaScriptCore into
        a static library.

        As a result of the split-up a race-condition due to broken dependencies of
        regular source files to header files of generated sources showed up very
        frequently when doing parallel builds (which the buildbot does). This commit at
        the same time tries to address the dependency problem by making the
        addExtraCompiler() function also generate a pseudo extra compiler that
        represents the header file output, so that qmake is aware of the creation of
        the header file for dependency calculation.

        At the same time I removed a lot of cruft from the pro files to ease maintenance.

        * WebCore.pro:

2008-07-24  kevino  <kevino@theolliviers.com>

        wx build fix on Win for plugins coode.

        * plugins/PluginDatabase.cpp:
        * plugins/PluginView.cpp:
        (WebCore::PluginView::PluginView):
        * plugins/PluginView.h:

2008-07-24  Sam Weinig  <sam@webkit.org>

        Reviewed by Anders Carlsson.

        Make isElementNode() non-virtual for a speedup on many benchmarks
        including 20% on http://ejohn.org/apps/fragment/.

        - Replace Node::m_attrWasSpecifiedOrElementHasRareData with bits in 
          Element and Attr where space was available.  Use the new free bit
          to represent if an node is an element or not.

        * dom/Attr.cpp:
        (WebCore::Attr::Attr):
        * dom/Attr.h:
        (WebCore::Attr::specified):
        (WebCore::Attr::setSpecified):
        * dom/ContainerNode.cpp:
        (WebCore::ContainerNode::ContainerNode):
        * dom/ContainerNode.h:
        * dom/Element.cpp:
        (WebCore::Element::Element):
        * dom/Element.h:
        (WebCore::Element::hasRareData):
        (WebCore::Element::setHasRareData):
        * dom/EventTargetNode.cpp:
        (WebCore::EventTargetNode::EventTargetNode):
        * dom/EventTargetNode.h:
        * dom/Node.cpp:
        (WebCore::Node::Node):
        * dom/Node.h:
        (WebCore::Node::isElementNode):

2008-07-24  Dan Bernstein  <mitz@apple.com>

        Reviewed by Dave Hyatt.

        - fix <rdar://problem/6082111> REGRESSION (r31876): Root element with percent height does not resize when resizing the window vertically

        Not testable in DumpRenderTree

        * rendering/RenderView.cpp:
        (WebCore::RenderView::layout): Ensured that all children with percentage
        heights get laid out again if the height changes.

2008-07-24  kevino  <kevino@theolliviers.com>

        Windows build fix for wx. wx doesn't implement pan scrolling yet. 

        * page/EventHandler.cpp:
        (WebCore::EventHandler::handleAutoscroll):
        (WebCore::EventHandler::autoscrollTimerFired):
        (WebCore::EventHandler::stopAutoscrollTimer):
        (WebCore::EventHandler::handleMousePressEvent):

2008-07-24  David Hyatt  <hyatt@apple.com>

        Fix for bug 18673, crash when using full page zoom on generated content.  Don't call
        intrinsicSizeChanged when we are first setting our style.

        Reviewed by olliej

        * ChangeLog:
        * rendering/RenderReplaced.cpp:
        (WebCore::RenderReplaced::setStyle):

2008-07-24  Julien Chaffraix  <jchaffraix@webkit.org>

        Reviewed by Eric.

        Bug 20053: .in files should use a custom format instead of XML

        - Remove our XML parser perl module (XML::Tiny)

        - Add a custom perl parser

        - Move XML files to the new format

        * bindings/scripts/InFilesParser.pm: Added.
        * bindings/scripts/XMLTiny.pm: Removed.
        * dom/make_names.pl: Switched to our new
        parser.

        * html/HTMLAttributeNames.in: Switched to
        our custom format.
        * html/HTMLTagNames.in: Ditto.
        * svg/svgattrs.in: Ditto.
        * svg/svgtags.in: Ditto.
        * svg/xlinkattrs.in: Ditto.
        * xml/xmlattrs.in: Ditto.

2008-07-23  Julien Chaffraix  <jchaffraix@webkit.org>

        Reviewed by Eric.

        Bug 19588: CRASH doing open() on destroyed window
        https://bugs.webkit.org/show_bug.cgi?id=19588

        Add frame's page null check as it could have been
        detached from the page.

        Test: fast/frames/crash-removed-iframe.html

        * bindings/js/JSDOMWindowBase.cpp:
        (WebCore::windowProtoFuncOpen):
        * page/FrameTree.cpp:
        (WebCore::FrameTree::find):

2008-07-23  Dan Bernstein  <mitz@apple.com>

        Reviewed by Alexey Proskuryakov.

        - fix a leak when using hex color values in CSS variables

        - fix CSSOM access to hex color values in variables declarations

        Test: fast/css/variables/color-hex-test.html

        Added a new unit/type, CSS_PARSER_HEXCOLOR, which serves as the unit for
        CSSParserValues coming from colors in hex notation. CSSParserValues can
        no longer have CSS_RGBCOLOR as their unit. CSS_PARSER_HEXCOLOR is also
        used as the type for CSSValues in CSS variables declarations where the
        parser value was a hex color. However the type of all other color
        CSSValues remains CSS_RGBCOLOR.

        * css/CSSGrammar.y: Changed to use the new CSS_PARSER_HEXCOLOR value
        for color values in hex notation.
        * css/CSSParser.cpp:
        (WebCore::CSSParser::parseColorFromValue): Updated for the new unit.
        * css/CSSParserValues.cpp:
        (WebCore::CSSParserValue::createCSSValue): Ditto.
        * css/CSSPrimitiveValue.cpp:
        (WebCore::CSSPrimitiveValue::cleanup): Fixed the leak by deref()ing the
        string containing the color.
        (WebCore::CSSPrimitiveValue::cssText): Added support for
        CSS_PARSER_HEXCOLOR for when serializing variable values.
        (WebCore::CSSPrimitiveValue::parserValue): Updated for the new unit.
        * css/CSSPrimitiveValue.h:
        (WebCore::CSSPrimitiveValue::): Added a new unti, CSS_PARSER_HEXCOLOR.

2008-07-23  Beth Dakin  <bdakin@apple.com>

        Reviewed by Dan Bernstein.

        Fix for <rdar://problem/5997215> display: table-row-group 
        for :before content causes a crash
 
        The actual bug fix here is to ddd the generated content container 
        as a child before adding any of the generated content to the 
        container. There are two correctness fixes as well that deal with 
        style changes and correctly.

        This patch also makes Node::diff() a static function.

        * dom/Node.cpp:
        (WebCore::Node::diff):
        * dom/Node.h:
        (WebCore::Node::):
        (WebCore::Node::recalcStyle):
        * rendering/RenderContainer.cpp:
        (WebCore::findBeforeAfterParent):
        (WebCore::RenderContainer::updateBeforeAfterContentForContainer):
        * svg/SVGUseElement.cpp:
        (WebCore::SVGUseElement::recalcStyle):

2008-07-23  Timothy Hatcher  <timothy@apple.com>

        Updates the elements DOM tree when nodes are added or removed from
        the inspected document.

        https://bugs.webkit.org/show_bug.cgi?id=6590
        <rdar://problem/5712921>

        Reviewed by Adam Roben.

        * loader/FrameLoader.cpp:
        (WebCore::FrameLoader::dispatchWindowObjectAvailable): Added a call to
        InspectorController::inspectedWindowScriptObjectCleared.
        * page/InspectorController.cpp:
        (WebCore::InspectorController::inspectedWindowScriptObjectCleared):
        Calls the WebInspector.inspectedWindowCleared script function.
        * page/InspectorController.h:
        * page/inspector/ElementsPanel.js:
        (WebInspector.ElementsPanel): Create the event listener callback wrappers.
        (WebInspector.ElementsPanel.prototype.show): Call _updateModifiedNodes if
        there are any recently modified nodes.
        (WebInspector.ElementsPanel.prototype.reset): Remove previous mutation event listeners.
        Adds a check for InspectorController.isWindowVisible to prevent adding
        event listeners when the window isn't visible.
        (WebInspector.ElementsPanel.prototype.inspectedWindowCleared): 
        (WebInspector.ElementsPanel.prototype._addMutationEventListeners): Add DOMNodeInserted,
        DOMNodeRemoved and DOMContentLoaded event listeners to the passed in window or window's document.
        (WebInspector.ElementsPanel.prototype._removeMutationEventListeners): Removes the event listeners
        added in _addMutationEventListeners.
        (WebInspector.ElementsPanel.prototype.updateMutationEventListeners): Call _addMutationEventListeners
        again to reinstate the listners if the document changed or window cleared them.
        (WebInspector.ElementsPanel.prototype.registerMutationEventListeners): Append the window to
        _mutationMonitoredWindows and call _addMutationEventListeners.
        (WebInspector.ElementsPanel.prototype.unregisterMutationEventListeners): Remove the window from
        _mutationMonitoredWindows and call _removeMutationEventListeners.
        (WebInspector.ElementsPanel.prototype.unregisterAllMutationEventListeners): Call
        _removeMutationEventListeners for all windows in _mutationMonitoredWindows and
        clear _mutationMonitoredWindows.
        (WebInspector.ElementsPanel.prototype._contentLoaded): Append the node and parent
        to the recentlyModifiedNodes array. Call _updateModifiedNodesSoon if visible.
        (WebInspector.ElementsPanel.prototype._nodeInserted): Ditto.
        (WebInspector.ElementsPanel.prototype._nodeRemoved): Ditto.
        (WebInspector.ElementsPanel.prototype._updateModifiedNodesSoon): Call
        _updateModifiedNodes on a zero timeout.
        (WebInspector.ElementsPanel.prototype._updateModifiedNodes): Iterate over
        the recentlyModifiedNodes array and call updateChildren on all the parent
        elements that had changes. Only calls updateChildren once per parent element.
        (WebInspector.ElementsPanel.prototype._isAncestorIncludingParentFrames): Return
        false if the nodes are the same. Return true if the nodes are the same while
        looking at ancestor frame elements. THis use to return false, which was incorrect.
        (WebInspector.DOMNodeTreeElement.prototype.onpopulate): Call updateChildren.
        (WebInspector.DOMNodeTreeElement.prototype.updateChildren): Copied from
        onpopulate and changed to rebuild the children elements by adding new children,
        moving existing children and removed old children.
        (WebInspector.DOMNodeTreeElement.prototype.onexpand): If the node has a contentDocument
        call registerMutationEventListeners to track any mutations.
        * page/inspector/inspector.js:
        (WebInspector.inspectedWindowCleared): Call ElementsPanel.inspectedWindowCleared.
        * page/inspector/treeoutline.js:
        (TreeElement.prototype.get hasChildren): Return _hasChildren.
        (TreeElement.prototype.set hasChildren): Set _hasChildren and update the className.
        (TreeElement.prototype.hasAncestor): Return true if the element has the passed in ancestor.
        (TreeElement.prototype.expand): Fix an exception that can happen if expand is
        called before _attach.
        * WebCore/manual-tests/inspector/dom-mutation.html: Added.
        * WebCore/manual-tests/inspector/resources/mutate-frame-2.html: Added.
        * WebCore/manual-tests/inspector/resources/mutate-frame.html: Added.

2008-07-22  Timothy Hatcher  <timothy@apple.com>

        Fix an exception that occurred when double clicking the closing tag
        of an element in the DOM tree.

        Reviewed by Anders Carlsson.

        * page/inspector/ElementsPanel.js:
        (WebInspector.ElementsPanel.prototype._ondblclick): Null check
        element.ondblclick.

2008-07-22  Timothy Hatcher  <timothy@apple.com>

        Fix a regression where elements in subframes would not be revealed
        or selected when inspected from the context menu. This was caused by
        JavaScript equality is not being true for JSInspectedObjectWrappers
        of the same node wrapped with different global ExecStates. This change
        adds a helper function that uses isSameNode to compare wrapped nodes.

        https://bugs.webkit.org/show_bug.cgi?id=19377

        Reviewed by Adam Roben.

        * page/inspector/ElementsPanel.js:
        (WebInspector.ElementsPanel.prototype.set rootDOMNode): Use objectsAreSame
        to compare nodes.
        (WebInspector.ElementsPanel.prototype.set focusedDOMNode): Ditto.
        (WebInspector.ElementsPanel.prototype.set hoveredDOMNode): Ditto. 
        (WebInspector.ElementsPanel.prototype._updateModifiedNodes): Ditto.
        (WebInspector.ElementsPanel.prototype.revealNode): Ditto.
        (WebInspector.ElementsPanel.prototype.updateBreadcrumb): Ditto.
        (WebInspector.DOMNodeTreeElement.prototype.updateChildren): Ditto.
        * page/inspector/treeoutline.js:
        (TreeOutline.prototype.findTreeElement): Add an equal argument
        to accept a functions to compare two representedObjects. Defaults
        to strict equal if not supplied. All current clients pass objectsAreSame.
        * page/inspector/utilities.js:
        (Node.prototype.enclosingNodeOrSelfWithNodeNameInArray): Use objectsAreSame
        to compare nodes.
        (Node.prototype.enclosingNodeOrSelfWithClass): Ditto.
        (Element.prototype.query): Use the ownerDocument of the node, not document.
        (objectsAreSame): Added. Compares strict equal first, then uses isSameNode if
        it exists on both objects.
        (isAncestorNode): Use objectsAreSame to compare nodes.
        (firstCommonNodeAncestor): Ditto.
        (traverseNextNode): Ditto.

2008-07-21  Timothy Hatcher  <timothy@apple.com>

        Added InspectorController.isWindowVisible to the JavaScript class
        for use in an upcoming change. This will allow the Inspector to not
        perform selective actions while the window is hidden.

        Reviewed by Adam Roben.

        * page/InspectorController.cpp:
        (WebCore::isWindowVisible): Call InspectorController::windowVisible.
        (WebCore::InspectorController::windowScriptObjectAvailable): Add
        the isWindowVisible function to the JavaScript class.

2008-07-21  Timothy Hatcher  <timothy@apple.com>

        Added TreeOutline.removeChildAtIndex and TreeElement.removeChildAtIndex
        for efficiency of callers that know the index of the child. This
        will be used in an upcoming change.

        Reviewed by Adam Roben.

        * page/inspector/treeoutline.js:
        (TreeOutline._removeChildAtIndex): Renamed from _removeChild
        and modified to take an index.
        (TreeOutline._removeChild): Call _removeChildAtIndex with the
        child index found using indexOf.
        (TreeOutline.prototype.removeChildAtIndex): Added. Calls
        TreeOutline._removeChildAtIndex.
        (TreeElement.prototype.removeChildAtIndex): Ditto.

2008-07-21  Timothy Hatcher  <timothy@apple.com>

        Fixes a regression where TreeOutline.findTreeElement would
        return the parent TreeElement of the representedObject instead
        of the TreeElement for the representedObject. Regressed with the
        fix for bug 19164.

        Reviewed by Adam Roben.

        * page/inspector/treeoutline.js:
        (TreeOutline.prototype.findTreeElement): When performing a slow search,
        do a final search for representedObject instead of returning item, which
        is the parent of representedObject.

2008-07-23  Adele Peterson  <adele@apple.com>

        Reviewed by Adam.

        WebCore part of fix for <rdar://problem/5698672>  Add drawing callback for a WebKit app to draw its own scrollbars

        * WebCore.base.exp: Added symbols.
        * page/Chrome.cpp:
        (WebCore::ChromeClient::paintCustomScrollbar): Added. Calls up to WebKit, which will call a new delegate method.
        (WebCore::ChromeClient::paintCustomScrollCorner): ditto.
        * page/ChromeClient.h:
        * page/Settings.cpp:
        (WebCore::Settings::Settings): Added the ability to store whether or not the application has decided to draw its own scrollbars.
        (WebCore::Settings::setShouldPaintCustomScrollbars):
        * page/Settings.h: (WebCore::Settings::shouldPaintCustomScrollbars):
        * platform/ScrollBar.h: Moved ScrollbarControlSize enum to ScrollTypes.h
        * platform/ScrollTypes.h: (WebCore::): Moved some existing types, and added new ones to be used in WebCore in WebKit.
        * platform/win/PlatformScrollBar.h: Moved ScrollbarPart enum to ScrollTypes.h
        * platform/win/PlatformScrollBarSafari.cpp:
        (WebCore::ScrollbarPartToScrollBarPiece): Added helper function.
        (WebCore::ScrollBarPieceMaskToScrollbarControlPartMask): ditto.
        (WebCore::ScrollbarControlStateFromThemeState): ditto.
        (WebCore::PlatformScrollbar::paint): Consolidated painting so the logic for the individual pieces is all in one place.
         Added new code to paint the custom scrollbars if necessary.
        * platform/win/ScrollViewWin.cpp: (WebCore::ScrollView::paint): Added code to paint the custom scroll corner if necessary.

2008-07-23  Sam Weinig  <sam@webkit.org>

        Reviewed by Anders Carlsson.

        Cleanup and pack the member variables in Node.

        * bindings/js/JSNodeCustom.cpp:
        (WebCore::JSNode::mark):
        * dom/Attr.cpp:
        (WebCore::Attr::Attr):
        * dom/Attr.h:
        (WebCore::Attr::specified):
        (WebCore::Attr::setSpecified):
        * dom/ContainerNode.cpp:
        (WebCore::ContainerNode::setFocus):
        * dom/Document.cpp:
        (WebCore::Document::adoptNode):
        * dom/Element.cpp:
        (WebCore::Element::~Element):
        (WebCore::Element::rareData):
        (WebCore::Element::createRareData):
        * dom/Element.h:
        (WebCore::Element::hasRareData):
        (WebCore::Element::setHasRareData):
        * dom/Node.h:
        (WebCore::Node::setIsLink):
        (WebCore::Node::inSubtreeMark):
        (WebCore::Node::setInSubtreeMark):
        (WebCore::Node::attrWasSpecifiedOrElementHasRareData):
        (WebCore::Node::setAttrWasSpecifiedOrElementHasRareData):
        * html/HTMLAnchorElement.cpp:
        (WebCore::HTMLAnchorElement::supportsFocus):
        (WebCore::HTMLAnchorElement::isFocusable):
        (WebCore::HTMLAnchorElement::defaultEventHandler):
        (WebCore::HTMLAnchorElement::parseMappedAttribute):
        (WebCore::HTMLAnchorElement::isLiveLink):
        * html/HTMLImageElement.cpp:
        (WebCore::HTMLImageElement::parseMappedAttribute):
        * html/HTMLInputElement.cpp:
        (WebCore::HTMLInputElement::setInputType):
        * html/HTMLTableElement.cpp:
        (WebCore::HTMLTableElement::attach):
        * svg/SVGAElement.cpp:
        (WebCore::SVGAElement::svgAttributeChanged):
        (WebCore::SVGAElement::defaultEventHandler):

2008-07-23  Kevin Calhoun  <kcalhoun@apple.com>

        Reviewed by Adele.

        Follow-up fix for <rdar://problem/6031039> don't disable track-types when media is in a standalone document

        Associate MovieControllers with Movies to support all of the media types QuickTime is able to play in standalone media documents.

        * platform/graphics/win/QTMovieWin.cpp:
        (QTMovieWinPrivate::QTMovieWinPrivate):
        (QTMovieWinPrivate::~QTMovieWinPrivate):
        (QTMovieWinPrivate::task):
        (QTMovieWinPrivate::createMovieController):
        (QTMovieWinPrivate::createGWorld):
        (QTMovieWinPrivate::setSize):
        (QTMovieWinPrivate::deleteGWorld):
        (QTMovieWin::play):
        (QTMovieWin::pause):
        (QTMovieWin::setRate):
        (QTMovieWin::setCurrentTime):
        (QTMovieWin::load):

2008-07-23  Kevin Calhoun  <kcalhoun@apple.com>

        Reviewed by Adele.

        Added a debug mode for viewing frames per second for videos.  This is controlled by two 
        independent compiler flags DRAW_FRAME_RATE in MediaPlayerPrivateQTKit.h and MediaPlayerPrivateQuickTimeWin.h.
        Unless either flags is turned on there is no change to the code for video frame drawing.

        * platform/graphics/mac/MediaPlayerPrivateQTKit.h:
        * platform/graphics/mac/MediaPlayerPrivateQTKit.mm:
        (WebCore::MediaPlayerPrivate::MediaPlayerPrivate):
        (WebCore::MediaPlayerPrivate::play):
        (WebCore::MediaPlayerPrivate::pause):
        (WebCore::MediaPlayerPrivate::didEnd):
        (WebCore::MediaPlayerPrivate::repaint):
        (WebCore::MediaPlayerPrivate::paint):
        * platform/graphics/win/MediaPlayerPrivateQuickTimeWin.cpp:
        (WebCore::MediaPlayerPrivate::MediaPlayerPrivate):
        (WebCore::MediaPlayerPrivate::play):
        (WebCore::MediaPlayerPrivate::pause):
        (WebCore::MediaPlayerPrivate::didEnd):
        (WebCore::MediaPlayerPrivate::paint):
        (WebCore::MediaPlayerPrivate::movieNewImageAvailable):
        * platform/graphics/win/MediaPlayerPrivateQuickTimeWin.h:

2008-07-23  Adele Peterson  <adele@apple.com>

        Reviewed by Sam.

        Fix for <rdar://problem/6080634> use lower quality CG interpolation in MediaPlayerPrivateQTKit to improve performance

        * platform/graphics/GraphicsContext.cpp: (WebCore::GraphicsContext::drawImage):
        Call setImageInterpolationQuality(InterpolationNone) instead of setUseLowQualityImageInterpolation(true).
        * platform/graphics/GraphicsContext.h:
        (WebCore::): Added InterpolationQuality enum.
        (WebCore::GraphicsContext::setImageInterpolationQuality): Renamed from setUseLowQualityImageInterpolation.
        The implementation was always setting the quality to "none", and now we want to distinguish between "none" and "low".
        (WebCore::GraphicsContext::imageInterpolationQuality): Renamed from useLowQualityImageInterpolation.
        * platform/graphics/cg/GraphicsContextCG.cpp:
        (WebCore::GraphicsContext::setImageInterpolationQuality): Added.
        (WebCore::GraphicsContext::imageInterpolationQuality): Added.
        * platform/graphics/mac/MediaPlayerPrivateQTKit.mm: (WebCore::MediaPlayerPrivate::paint):
        Calls setImageInterpolationQuality(InterpolationLow) which will improve the painting performance without degrading quality too much.

2008-07-23  Sam Weinig  <sam@webkit.org>

        Reviewed by Anders Carlsson.

        Remove extraneous allocations by using equalIgnoringCase rather than
        String::lower.

        * dom/StyledElement.cpp:
        (WebCore::StyledElement::addCSSColor):
        * html/HTMLCollection.cpp:
        (WebCore::HTMLCollection::checkForNameMatch):
        * html/HTMLFormCollection.cpp:
        (WebCore::HTMLFormCollection::getNamedFormItem):
        * html/HTMLLinkElement.cpp:
        (WebCore::HTMLLinkElement::tokenizeRelAttribute):
        * html/HTMLObjectElement.cpp:
        (WebCore::HTMLObjectElement::containsJavaApplet):
        * html/PreloadScanner.cpp:
        (WebCore::PreloadScanner::emitCSSRule):
        * loader/FrameLoader.cpp:
        (WebCore::FrameLoader::createJavaAppletWidget):
        * page/DOMSelection.cpp:
        (WebCore::DOMSelection::modify):
        * rendering/RenderPartObject.cpp:
        (WebCore::RenderPartObject::updateWidget):

2008-07-23  Maxime Britto  <britto@apple.com>

        Reviewed by Adam Roben.

        <rdar://6092952> "REGRESSION: Crash beneath EventHandler::stopAutoscrollTimer() when closing Gmail"
        Add a check for the m_page member value before asking for page()->mainFrame()

        * page/EventHandler.cpp:
        (WebCore::EventHandler::stopAutoscrollTimer):

2008-07-23  Kevin Calhoun  <kcalhoun@apple.com>

       Reviewed by Adele.

       Fix for <rdar://problem/5710065> QT movies should be inactive when opened

       Implemented deferral of set-up of video rendering on Mac until the ready state is Loaded and 
       until after movie tracks of unsupported types have been disabled, to make sure they never draw.

        * platform/graphics/mac/MediaPlayerPrivateQTKit.mm:
        (WebCore::MediaPlayerPrivate::load):
        (WebCore::MediaPlayerPrivate::updateStates):
        (WebCore::MediaPlayerPrivate::setVisible):

2008-07-22  Maxime Britto  <britto@apple.com>

        Reviewed by John Sullivan.

        <rdar://problem/6083116>
        When pan-scrolling, Back then Forward causes pan-scrolling to start again

        * page/Frame.cpp:
        (WebCore::Frame::clearTimers): Ask to stop the autoscroll timer when we clear the timers from the frame
        * loader/FrameLoader.cpp:
        (WebCore::FrameLoader::scrollToAnchor): When the link is an anchor we Frame::clearTimers() isn't called since we're only scrolling the page so we need to ask to stop the autoscroll timer here too.

2008-07-22  Geoffrey Garen  <ggaren@apple.com>

        Reviewed by Oliver Hunt and Sam Weinig.

        Next step toward putting doubles in registers: Prepare the Register class
        and its clients for registers that don't contain JSValue*s.
        
2008-07-22  Sam Weinig  <sam@webkit.org>

        Reviewed by Mark Rowe.

        <rdar://problem/5788451> toDataURL not implemented for Windows (need mapping of MIME type to UTI)
        Add additional support for JPEG and GIF for toDataURL encoding canvases.

        * platform/MIMETypeRegistry.cpp:
        (WebCore::initializeSupportedImageMIMETypesForEncoding):
        * platform/graphics/cg/ImageBufferCG.cpp:
        (WebCore::utiFromMIMEType):

2008-07-22  Chris Fleizach  <cfleizach@apple.com>

        Reviewed by Dave Hyatt.

        <rdar://problem/6004877> internal anchors on this page are not showing up in the AXLinkedUIElements
        Test: accessibility/internal-link-anchors2.html

        * page/AccessibilityRenderObject.cpp:
        (WebCore::AccessibilityRenderObject::internalLinkElement):

2008-07-22  Anders Carlsson  <andersca@apple.com>

        Reviewed by Adam.

        Allocate the empty StringImpl from the heap.
        
        * platform/text/StringImpl.cpp:
        (WebCore::StringImpl::empty):

2008-07-21  Kevin McCullough  <kmccullough@apple.com>

        Reviewed by Tim.

        <rdar://problem/5951532> JSProfiler: Implement heavy (or bottom-up)
        view (19228)
        - Implement UI for Heavy (Bottom Up) view.

        * English.lproj/localizedStrings.js:
        * page/JavaScriptProfile.cpp: Expose the ability to get a heavy/tree
        profile from a profile to the Web Inspector's JavaScript.
        (WebCore::getHeavyProfileCallback):
        (WebCore::getTreeProfileCallback):
        (WebCore::ProfileClass):
        * page/inspector/ProfileView.js: Implement the dropdown for changing
        profile views.
        * page/inspector/inspector.css:

2008-07-22  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Adam Roben.

        <rdar://problem/5955602> WebKit should support charset name x-windows-949

        Test: fast/encoding/char-decoding.html

        * platform/text/TextCodecICU.cpp:
        (WebCore::TextCodecICU::registerExtendedEncodingNames): Added support for this name for
        Firefox compatibility.

2008-07-22  Gavin Barraclough  <barraclough@apple.com>

        Reviewed by Alexey Proskuryakov.

        New test to check that arrays fail gracefully (throw an out of memory exception)
        when the vector grows to large.

        * manual-tests/array-out-of-memory.html: Added.

2008-07-21  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Dan Bernstein.

        https://bugs.webkit.org/show_bug.cgi?id=20117
        setBaseAndExtent fails to reverse the current selection

        Test: editing/selection/setBaseAndExtent-revert-selection.html

        * editing/Selection.h: (WebCore::operator==): Compare direction, too.

2008-07-21  Julien Chaffraix  <jchaffraix@webkit.org>

        Reviewed by Sam Weinig.

        Bug 19919: Add selectors' string parsing in CSSParser
        https://bugs.webkit.org/show_bug.cgi?id=19919

        No functional change.

        * css/CSSGrammar.y: Added entry for parsing only a selector.
        * css/CSSParser.cpp:
        (WebCore::CSSParser::CSSParser):
        (WebCore::CSSParser::parseSelector):
        * css/CSSParser.h: Added m_floatingSelector to hold the
        Selector parsed in parseSelector.

        * css/tokenizer.flex: Added "@-webkit-selector" token.
        * dom/Node.cpp:
        (WebCore::Node::querySelector):
        (WebCore::Node::querySelectorAll): Switched to parseSelector
        method.

2008-07-21  Kevin Calhoun  <kcalhoun@apple.com>

        Reviewed by Adele.

        Fix for <rdar://problem/6081160> REGRESSION: Hang loading many pages if QuickTime isn't installed

        * platform/graphics/win/QTMovieWin.cpp:
        (initializeSupportedTypes): Do a Quicktime version minimum version check.
        (QTMovieWin::initializeQuickTime): Store the Quicktime version globally so in can be used in initializeSupportedTypes as well.

2008-07-21  Kevin Calhoun  <kcalhoun@apple.com>

        Reviewed by Adele.

        Fix for <rdar://problem/5713336> <video> and <audio> elements that use a autoplay attribute fail to start playing when returning back to page

        * html/HTMLMediaElement.cpp: (WebCore::HTMLMediaElement::willSaveToCache): Reset the ready state to DATA_UNAVAILABLE when saving to the cache
        so that everything starts back up normally when the page is retrieved from the cache.

2008-07-21  Sam Weinig  <sam@webkit.org>

        Reviewed by Mark Rowe.

        Remove unused interface declaration.

        * platform/network/mac/ResourceHandleMac.mm:

2008-07-21  Mark Rowe  <mrowe@apple.com>

        Reviewed by Sam Weinig.

        <rdar://problem/6091287> Revamp the handling of CFBundleShortVersionString to be fixed at the major component of the version number.

        * Configurations/Version.xcconfig:
        * Info.plist:

2008-07-21  Kevin Calhoun  <kcalhoun@apple.com>

        Reviewed by Adele.

        Fix for <rdar://problem/6031039> don't disable track-types when media is in a standalone document

        * platform/graphics/MediaPlayer.cpp: (WebCore::MediaPlayer::inMediaDocument): Added.
        * platform/graphics/MediaPlayer.h:
        * platform/graphics/mac/MediaPlayerPrivateQTKit.mm: (WebCore::MediaPlayerPrivate::updateStates):
        * platform/graphics/win/MediaPlayerPrivateQuickTimeWin.cpp: (WebCore::MediaPlayerPrivate::updateStates):

2008-07-21  Anders Carlsson  <andersca@apple.com>

        Reviewed by Jon.

        Don't allow requests to be made when the document loader is stopping all loaders.

        * plugins/PluginView.cpp:
        (WebCore::PluginView::load):

2008-07-20  Maxime Britto  <britto@apple.com>

        Reviewed by John Sullivan.

        [PFR] <rdar://problem/6080639> New middle click scrolling speed seems much slower than in FF
        Accelerate and enhance the smoothness of the pan scrollling.

        * page/EventHandler.cpp: Changed the TimerInterval from 0.1 to 0.05. The scrolling is way more fluid like this.
        * rendering/RenderLayer.cpp: 
        (WebCore::RenderLayer::panScrollFromPoint): Differentiate the speed within a 200 pixel side square, around the original click location to the speed for farther distances. This way we allow easyier handle when we are close to the center and very fast scrolling when we go far from the original point.

2008-07-18  David Hyatt  <hyatt@apple.com>

        Change the cached clip rects to not assume they should be infinite when the root layer has been
        shifted as the result of a transformation.

        Reviewed by Maciej

        Added fast/transforms/overflow-with-transform.html

        * rendering/RenderLayer.cpp:
        (WebCore::RenderLayer::calculateClipRects):

2008-07-21  Rob Buis  <buis@kde.org>

        Reviewed by Mitz.

        https://bugs.webkit.org/show_bug.cgi?id=19966
        CSS variables crash when using hex notation for colors

        Support hex colors as values for the css variables.

        Test: fast/css/variables/color-hex-test.html

        * css/CSSParserValues.cpp:
        (WebCore::CSSParserValue::createCSSValue):
        * css/CSSPrimitiveValue.cpp:
        (WebCore::CSSPrimitiveValue::parserValue):
        * css/CSSVariablesRule.cpp:

2008-07-21  Simon Hausmann  <hausmann@webkit.org>

        Reviewed by Holger.

        Fix drawing of windowless plugins on Windows with the Qt port by
        avoiding the reset of the translation of the HDC to 0, 0.

        * plugins/win/PluginViewWin.cpp:
        (WebCore::PluginView::paint):

2008-07-21  Simon Hausmann  <hausmann@webkit.org>

        Reviewed by Holger.

        Fix rendering of transparent windowless netscape plugins by passing
        the right conversion parameter to QPixmap::fromWinHBITMAP when
        converting from HBITMAP to QPixmap.

        * platform/graphics/qt/GraphicsContextQt.cpp:
        (WebCore::GraphicsContext::releaseWindowsContext):

2008-07-21  Simon Hausmann  <hausmann@webkit.org>

        Reviewed by Holger.

        In the implementation of getValue for NPNVnetscapeWindow treat
        windowHandleForPlatformWidget on the return value of
        containingWindow() to receive the correct HWND for the Qt port.

        * plugins/win/PluginViewWin.cpp:
        (WebCore::PluginView::getValue):

2008-07-21  Simon Hausmann  <hausmann@webkit.org>

        Reviewed by Holger.

        Fix windowHandleForPlatformWidget to return 0 as HWND if we don't have
        a QWidget. This can happen on page/view destruction for example.

        * plugins/win/PluginViewWin.cpp:
        (windowHandleForPlatformWidget):

2008-07-20  Steve Falkenburg  <sfalken@apple.com>

        Touch file to force rebuild for vsprops change.

        * WebCorePrefix.h:

2008-07-20  Sam Weinig  <sam@webkit.org>

        Remove extra space Oliver Hunt left in.

        * page/Console.cpp:
        (WebCore::Console::reportException):
        (WebCore::Console::reportCurrentException):

2008-07-20  Oliver Hunt  <oliver@apple.com>

        Reviewed by Dan Bernstein.

        Bug 19757: Crash when an ondragstart handler hides the element
        <https://bugs.webkit.org/show_bug.cgi?id=19757>

        The solution to this is problem is just to null check the renderer
        immediately before launching the system drag, and terminate the
        drag if the renderer is gone.

        * page/EventHandler.cpp:
        (WebCore::EventHandler::handleDrag):

2008-07-20  Nikolas Zimmermann  <zimmermann@kde.org>

        Reviewed by Oliver.

        Fixes: https://bugs.webkit.org/show_bug.cgi?id=12171

        Remove manual SVG property <-> XML attribute synchronization in SVGPolyElement.
        Added svg/custom/poly-points-attribute-changes.svg (testcase from Rob)

        * svg/SVGPointList.cpp:
        (WebCore::SVGPointList::valueAsString):
        * svg/SVGPointList.h:
        (WebCore::SVGPointList::create):
        * svg/SVGPolyElement.cpp:
        (WebCore::SVGPolyElement::SVGPolyElement):
        (WebCore::SVGPolyElement::svgAttributeChanged):
        (WebCore::SVGPolyElement::updateAnimatedSVGAttribute):
        * svg/SVGPolyElement.h:

2008-07-20  Nikolas Zimmermann  <zimmermann@kde.org>

        Reviewed by Oliver.

        Cleanup JSSVGPODTypeWrapper code.

        Rename: JSSVGPODTypeWrapperCreatorReadOnly -> JSSVGStaticPODTypeWrapper
                JSSVGPODTypeWrapperReadWrite       -> JSSVGDynamicPODTypeWrapper
                JSSVGPODTypeWrapperCache           -> JSSVGDynamicPODTypeWrapperCacheCache

        No functional changes.

        * bindings/js/JSSVGMatrixCustom.cpp:
        (WebCore::JSSVGMatrix::multiply):
        (WebCore::JSSVGMatrix::inverse):
        (WebCore::JSSVGMatrix::translate):
        (WebCore::JSSVGMatrix::scale):
        (WebCore::JSSVGMatrix::scaleNonUniform):
        (WebCore::JSSVGMatrix::rotate):
        (WebCore::JSSVGMatrix::rotateFromVector):
        (WebCore::JSSVGMatrix::flipX):
        (WebCore::JSSVGMatrix::flipY):
        (WebCore::JSSVGMatrix::skewX):
        (WebCore::JSSVGMatrix::skewY):
        * bindings/js/JSSVGPODTypeWrapper.h:
        (WebCore::JSSVGDynamicPODTypeWrapper::create):
        (WebCore::JSSVGDynamicPODTypeWrapper::operator PODType):
        (WebCore::JSSVGDynamicPODTypeWrapper::JSSVGDynamicPODTypeWrapper):
        (WebCore::JSSVGStaticPODTypeWrapper::create):
        (WebCore::JSSVGStaticPODTypeWrapper::operator PODType):
        (WebCore::JSSVGStaticPODTypeWrapper::JSSVGStaticPODTypeWrapper):
        (WebCore::JSSVGPODTypeWrapperCreatorForList::create):
        (WebCore::JSSVGPODTypeWrapperCreatorForList::operator PODType):
        (WebCore::JSSVGPODTypeWrapperCreatorForList::JSSVGPODTypeWrapperCreatorForList):
        (WebCore::PODTypeWrapperCacheInfo::PODTypeWrapperCacheInfo):
        (WebCore::PODTypeWrapperCacheInfo::operator==):
        (WebCore::PODTypeWrapperCacheInfoHash::hash):
        (WebCore::PODTypeWrapperCacheInfoHash::equal):
        (WebCore::PODTypeWrapperCacheInfoTraits::emptyValue):
        (WebCore::PODTypeWrapperCacheInfoTraits::constructDeletedValue):
        (WebCore::PODTypeWrapperCacheInfoTraits::isDeletedValue):
        (WebCore::JSSVGDynamicPODTypeWrapperCache::dynamicWrapperHashMap):
        (WebCore::JSSVGDynamicPODTypeWrapperCache::lookupOrCreateWrapper):
        (WebCore::JSSVGDynamicPODTypeWrapperCache::forgetWrapper):
        * bindings/js/JSSVGPointListCustom.cpp:
        (WebCore::finishGetter):
        (WebCore::finishSetter):
        (WebCore::finishSetterReadOnlyResult):
        (WebCore::JSSVGPointList::initialize):
        (WebCore::JSSVGPointList::insertItemBefore):
        (WebCore::JSSVGPointList::replaceItem):
        (WebCore::JSSVGPointList::appendItem):
        * bindings/js/JSSVGTransformListCustom.cpp:
        (WebCore::finishGetter):
        (WebCore::finishSetter):
        (WebCore::finishSetterReadOnlyResult):
        (WebCore::JSSVGTransformList::initialize):
        (WebCore::JSSVGTransformList::getItem):
        (WebCore::JSSVGTransformList::insertItemBefore):
        (WebCore::JSSVGTransformList::replaceItem):
        (WebCore::JSSVGTransformList::removeItem):
        (WebCore::JSSVGTransformList::appendItem):
        * bindings/scripts/CodeGeneratorJS.pm:

2008-07-19  Oliver Hunt  <oliver@apple.com>

        Reviewed by Mark Rowe.

        Bug 15979: Console logs in a database callback lose line number information
        <https://bugs.webkit.org/show_bug.cgi?id=15979>

        The problem was that there were multiple versions of the logic to
        log an exception to the console, many of which were incorrect.  We
        resolve this by making one single shared reportException method,
        which handles the exceptions correctly.

        This improves fidelity of callback errors, and ensures that
        exceptions thrown in timer callbacks correctly report line numbers,
        etc.

        Test: fast/js/exceptions-thrown-in-callbacks.html

        * bindings/js/JSCustomSQLStatementCallback.cpp:
        (WebCore::JSCustomSQLStatementCallback::handleEvent):
        * bindings/js/JSCustomSQLStatementErrorCallback.cpp:
        (WebCore::JSCustomSQLStatementErrorCallback::handleEvent):
        * bindings/js/JSCustomSQLTransactionCallback.cpp:
        (WebCore::JSCustomSQLTransactionCallback::handleEvent):
        * bindings/js/JSCustomSQLTransactionErrorCallback.cpp:
        (WebCore::JSCustomSQLTransactionErrorCallback::handleEvent):
        * bindings/js/JSCustomVoidCallback.cpp:
        (WebCore::JSCustomVoidCallback::handleEvent):
        * bindings/js/JSCustomXPathNSResolver.cpp:
        (WebCore::JSCustomXPathNSResolver::lookupNamespaceURI):
        * bindings/js/JSEventListener.cpp:
        (WebCore::JSAbstractEventListener::handleEvent):
        * bindings/js/ScheduledAction.cpp:
        (WebCore::ScheduledAction::execute):
        * bindings/js/ScriptController.cpp:
        (WebCore::ScriptController::evaluate):
        * bindings/objc/WebScriptObject.mm:
        (WebCore::addExceptionToConsole):
        * page/Console.cpp:
        (WebCore::Console::reportException):
        * page/Console.h:

2008-07-20  Nikolas Zimmermann  <zimmermann@kde.org>

        Rubber stamped by Oliver.

        Another attempt to fix the win build.

        * svg/SVGAnimatedProperty.h:

2008-07-20  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by David Kilzer.

        Fix high CPU usage on testmyiphone.com.

        - Made the logic for determining when to stop looking for meta charset more strainghtforward.
        Previously, this happened if a tag that's disallowed in HEAD was seen past the first 512
        bytes. Now, the algorithm bails out at the boundary if we are lo longer in HEAD (i.e, an
        offending tag was seen at any point before).

        - The above change made one of our regression tests fail, because it had its <meta>
        declaration past the 512 byte boundary. Fixed it by raising the boundary to 1024 bytes.

        - Made the algorithm bail out quickly if a comment that's not in HEAD crosses the boundary.

        - Moved a check for XML content type out of the loop.

        * loader/TextResourceDecoder.cpp:
        (WebCore::TextResourceDecoder::checkForHeadCharset): 

2008-07-20  Oliver Hunt  <oliver@apple.com>

        Reviewed by NOBODY (build fix).

        Attempt to fix windows build

        * svg/SVGAnimatedProperty.h:

2008-07-19  Nikolas Zimmermann  <zimmermann@kde.org>

        Reviewed by Oliver & parts by Eric.

        Fixes: https://bugs.webkit.org/show_bug.cgi?id=20051

        Rewrite animated property concept without heavy macro usage, replace by a templatified solution.
        Fewer virtual function calls, no more usage of the tear-off's within internal code (synchronization needed it before.)

        * dom/Element.cpp:
        (WebCore::Element::attributes):
        (WebCore::Element::getAttribute):
        (WebCore::Element::hasAttributes):
        * dom/Element.h:
        (WebCore::Element::updateAnimatedSVGAttribute): Take const String&, not StringImpl*.
        * svg/SVGAElement.cpp:
        (WebCore::SVGAElement::SVGAElement):
        * svg/SVGAElement.h:
        * svg/SVGAltGlyphElement.h:
        * svg/SVGAnimatedProperty.h: Added.
        * svg/SVGAnimatedTemplate.h:
        (WebCore::lookupOrCreateWrapper):
        * svg/SVGAnimationElement.h:
        * svg/SVGCircleElement.cpp:
        (WebCore::SVGCircleElement::SVGCircleElement):
        * svg/SVGCircleElement.h:
        * svg/SVGClipPathElement.cpp:
        (WebCore::SVGClipPathElement::SVGClipPathElement):
        * svg/SVGClipPathElement.h:
        * svg/SVGComponentTransferFunctionElement.cpp:
        (WebCore::SVGComponentTransferFunctionElement::SVGComponentTransferFunctionElement):
        * svg/SVGComponentTransferFunctionElement.h:
        * svg/SVGCursorElement.cpp:
        (WebCore::SVGCursorElement::SVGCursorElement):
        * svg/SVGCursorElement.h:
        * svg/SVGDefsElement.h:
        (WebCore::SVGDefsElement::contextElement):
        * svg/SVGElement.cpp:
        (WebCore::SVGElement::updateAnimatedSVGAttribute):
        * svg/SVGElement.h:
        (WebCore::SVGElement::supplementalTransform):
        (WebCore::SVGElement::invokeSVGPropertySynchronizer):
        (WebCore::SVGElement::invokeAllSVGPropertySynchronizers):
        (WebCore::SVGElement::addSVGPropertySynchronizer):
        * svg/SVGEllipseElement.cpp:
        (WebCore::SVGEllipseElement::SVGEllipseElement):
        * svg/SVGEllipseElement.h:
        * svg/SVGExternalResourcesRequired.cpp:
        (WebCore::SVGExternalResourcesRequired::SVGExternalResourcesRequired):
        * svg/SVGExternalResourcesRequired.h:
        * svg/SVGFEBlendElement.cpp:
        (WebCore::SVGFEBlendElement::SVGFEBlendElement):
        * svg/SVGFEBlendElement.h:
        * svg/SVGFEColorMatrixElement.cpp:
        (WebCore::SVGFEColorMatrixElement::SVGFEColorMatrixElement):
        * svg/SVGFEColorMatrixElement.h:
        * svg/SVGFEComponentTransferElement.cpp:
        (WebCore::SVGFEComponentTransferElement::SVGFEComponentTransferElement):
        * svg/SVGFEComponentTransferElement.h:
        * svg/SVGFECompositeElement.cpp:
        (WebCore::SVGFECompositeElement::SVGFECompositeElement):
        * svg/SVGFECompositeElement.h:
        * svg/SVGFEDiffuseLightingElement.cpp:
        (WebCore::SVGFEDiffuseLightingElement::SVGFEDiffuseLightingElement):
        * svg/SVGFEDiffuseLightingElement.h:
        * svg/SVGFEDisplacementMapElement.cpp:
        (WebCore::SVGFEDisplacementMapElement::SVGFEDisplacementMapElement):
        * svg/SVGFEDisplacementMapElement.h:
        * svg/SVGFEFloodElement.h:
        * svg/SVGFEGaussianBlurElement.cpp:
        (WebCore::SVGFEGaussianBlurElement::SVGFEGaussianBlurElement):
        * svg/SVGFEGaussianBlurElement.h:
        * svg/SVGFEImageElement.cpp:
        (WebCore::SVGFEImageElement::SVGFEImageElement):
        * svg/SVGFEImageElement.h:
        * svg/SVGFELightElement.cpp:
        (WebCore::SVGFELightElement::SVGFELightElement):
        * svg/SVGFELightElement.h:
        (WebCore::SVGFELightElement::contextElement):
        * svg/SVGFEMergeElement.h:
        * svg/SVGFEMergeNodeElement.cpp:
        (WebCore::SVGFEMergeNodeElement::SVGFEMergeNodeElement):
        * svg/SVGFEMergeNodeElement.h:
        * svg/SVGFEOffsetElement.cpp:
        (WebCore::SVGFEOffsetElement::SVGFEOffsetElement):
        * svg/SVGFEOffsetElement.h:
        * svg/SVGFESpecularLightingElement.cpp:
        (WebCore::SVGFESpecularLightingElement::SVGFESpecularLightingElement):
        * svg/SVGFESpecularLightingElement.h:
        * svg/SVGFETileElement.cpp:
        (WebCore::SVGFETileElement::SVGFETileElement):
        * svg/SVGFETileElement.h:
        * svg/SVGFETurbulenceElement.cpp:
        (WebCore::SVGFETurbulenceElement::SVGFETurbulenceElement):
        * svg/SVGFETurbulenceElement.h:
        * svg/SVGFilterElement.cpp:
        (WebCore::SVGFilterElement::SVGFilterElement):
        * svg/SVGFilterElement.h:
        * svg/SVGFilterPrimitiveStandardAttributes.cpp:
        (WebCore::SVGFilterPrimitiveStandardAttributes::SVGFilterPrimitiveStandardAttributes):
        * svg/SVGFilterPrimitiveStandardAttributes.h:
        * svg/SVGFitToViewBox.cpp:
        (WebCore::SVGFitToViewBox::SVGFitToViewBox):
        * svg/SVGFitToViewBox.h:
        * svg/SVGFontElement.h:
        (WebCore::SVGFontElement::rendererIsNeeded):
        (WebCore::SVGFontElement::contextElement):
        * svg/SVGForeignObjectElement.cpp:
        (WebCore::SVGForeignObjectElement::SVGForeignObjectElement):
        * svg/SVGForeignObjectElement.h:
        * svg/SVGGElement.h:
        * svg/SVGGradientElement.cpp:
        (WebCore::SVGGradientElement::SVGGradientElement):
        * svg/SVGGradientElement.h:
        (WebCore::SVGGradientElement::contextElement):
        * svg/SVGImageElement.cpp:
        (WebCore::SVGImageElement::SVGImageElement):
        * svg/SVGImageElement.h:
        * svg/SVGLineElement.cpp:
        (WebCore::SVGLineElement::SVGLineElement):
        * svg/SVGLineElement.h:
        * svg/SVGLinearGradientElement.cpp:
        (WebCore::SVGLinearGradientElement::SVGLinearGradientElement):
        * svg/SVGLinearGradientElement.h:
        * svg/SVGMarkerElement.cpp:
        (WebCore::SVGMarkerElement::SVGMarkerElement):
        (WebCore::SVGMarkerElement::canvasResource):
        * svg/SVGMarkerElement.h:
        * svg/SVGMaskElement.cpp:
        (WebCore::SVGMaskElement::SVGMaskElement):
        * svg/SVGMaskElement.h:
        * svg/SVGPathElement.cpp:
        (WebCore::SVGPathElement::SVGPathElement):
        (WebCore::SVGPathElement::parseMappedAttribute):
        * svg/SVGPathElement.h:
        * svg/SVGPatternElement.cpp:
        (WebCore::SVGPatternElement::SVGPatternElement):
        * svg/SVGPatternElement.h:
        (WebCore::SVGPatternElement::contextElement):
        * svg/SVGPolyElement.h:
        * svg/SVGPreserveAspectRatio.cpp:
        * svg/SVGRadialGradientElement.cpp:
        (WebCore::SVGRadialGradientElement::SVGRadialGradientElement):
        * svg/SVGRadialGradientElement.h:
        * svg/SVGRectElement.cpp:
        (WebCore::SVGRectElement::SVGRectElement):
        * svg/SVGRectElement.h:
        * svg/SVGSVGElement.cpp:
        (WebCore::SVGSVGElement::SVGSVGElement):
        * svg/SVGSVGElement.h:
        * svg/SVGScriptElement.cpp:
        * svg/SVGScriptElement.h:
        * svg/SVGStopElement.cpp:
        (WebCore::SVGStopElement::SVGStopElement):
        * svg/SVGStopElement.h:
        * svg/SVGStyledElement.cpp:
        (WebCore::SVGStyledElement::SVGStyledElement):
        * svg/SVGStyledElement.h:
        * svg/SVGStyledTransformableElement.cpp:
        (WebCore::SVGStyledTransformableElement::SVGStyledTransformableElement):
        * svg/SVGStyledTransformableElement.h:
        * svg/SVGSwitchElement.h:
        * svg/SVGSymbolElement.h:
        (WebCore::SVGSymbolElement::contextElement):
        * svg/SVGTRefElement.h:
        * svg/SVGTSpanElement.h:
        * svg/SVGTextContentElement.cpp:
        (WebCore::SVGTextContentElement::SVGTextContentElement):
        * svg/SVGTextContentElement.h:
        (WebCore::SVGTextContentElement::contextElement):
        * svg/SVGTextElement.cpp:
        (WebCore::SVGTextElement::SVGTextElement):
        * svg/SVGTextElement.h:
        * svg/SVGTextPathElement.cpp:
        (WebCore::SVGTextPathElement::SVGTextPathElement):
        * svg/SVGTextPathElement.h:
        * svg/SVGTextPositioningElement.cpp:
        (WebCore::SVGTextPositioningElement::SVGTextPositioningElement):
        * svg/SVGTextPositioningElement.h:
        * svg/SVGTransformable.h:
        * svg/SVGURIReference.cpp:
        (WebCore::SVGURIReference::SVGURIReference):
        * svg/SVGURIReference.h:
        * svg/SVGUseElement.cpp:
        (WebCore::SVGUseElement::SVGUseElement):
        * svg/SVGUseElement.h:
        * svg/SVGViewElement.h:
        * svg/SVGViewSpec.h:

2008-07-18  Maxime Britto  <britto@apple.com>

        Reviewed by Adele.
        
        Fixed <rdar://problem/6049803>
        Prevent the autoscroll to trigger in WebClips when starting or hovering on an editable field.

        Test: fast/events/autoscroll-with-non-scrollable-parent.html

        * ChangeLog:
        * page/EventHandler.cpp: Edited
        (WebCore::EventHandler::handleMousePressEvent): changed the name of the funtion called to canBeProgramaticallyScrolled()
        (WebCore::EventHandler::handleMouseDraggedEvent): prevent the autoscroll to keep looking for a renderer when it's already triggered
        * rendering/RenderLayer.cpp:
        (WebCore::RenderLayer::scrollRectToVisible): verifies that the top layer can be programmatically scrolled before asking him to make the rect visible
        * rendering/RenderListBox.h:
        (WebCore::RenderListBox::canBeProgramaticallyScrolled):
        * rendering/RenderObject.cpp:
        (WebCore::RenderObject::canBeProgramaticallyScrolled): Edited : For the 3rd case we want document's renderer to have scrollbar as it's the top layer   
        (WebCore::RenderObject::hasScrollableView): Verifies that the Object has a view with scrollBars
        * rendering/RenderObject.h: Renamed shouldAutosroll() for canBeProgramaticallyScrolled()
        * rendering/RenderTextControl.h:
        (WebCore::RenderTextControl::canBeProgramaticallyScrolled):

2008-07-18  Sam Weinig  <sam@webkit.org>

        Reviewed by Anders Carlsson.

        <rdar://problem/6087283> Add support for uploading files via XMLHttpRequest

        - Overload XMLHttpRequests send() method to accept File tokens.

        * bindings/js/JSXMLHttpRequestCustom.cpp:
        (WebCore::JSXMLHttpRequest::send): 
        * xml/XMLHttpRequest.cpp:
        (WebCore::XMLHttpRequest::send):
        * xml/XMLHttpRequest.h:

2008-07-18  Geoffrey Garen  <ggaren@apple.com>

        Reviewed by Cameron Zwarich.
        
        Three renames:
        
        "CallTypeNative" => "CallTypeHost"
        "code" => "byteCode"
        "generatedCode" => "generatedByteCode"

2008-07-18  Adele Peterson  <adele@apple.com>

        Reviewed by Dan Bernstein.

        I recently made a change to avoid fading media controls in and out if a video element actually only contains audio,
        which broke the code that did the same thing for audio elements that contain video (but don't actually display that video).
        This change will now check both the media element and the player to decide whether or not to make the controls persistent.

        * rendering/RenderMedia.cpp: (WebCore::RenderMedia::updateControlVisibility):

2008-07-18  Simon Fraser  <simon.fraser@apple.com>

        Reviewed by mitz

        Remove braces around single-line conditional.
        
        * css/CSSComputedStyleDeclaration.cpp:
        (WebCore::computedTransform):

2008-07-18  Simon Fraser  <simon.fraser@apple.com>

        Reviewed by Dave Hyatt

        getComputedStyle() for -webkit-transform should return 
        'none' for elements with no renderer, or those with no
        transform.

        https://bugs.webkit.org/show_bug.cgi?id=20008

        Testcase: LayoutTests/fast/css/computed-style-without-renderer
                  LayoutTests/fast/css/computed-style-expected.txt

        * css/CSSComputedStyleDeclaration.cpp:
        (WebCore::computedTransform):

2008-07-18  Simon Fraser  <simon.fraser@apple.com>

        Reviewed by Dave Hyatt

        Fix assertion about creating Length values with percentage types
        when blending transforms.
        https://bugs.webkit.org/show_bug.cgi?id=20086

        * rendering/style/RenderStyle.cpp:
        (WebCore::TranslateTransformOperation::blend):

2008-07-17  Jacob Refstrup  <jacob.refstrup@hp.com>

        Reviewed by rwlbuis@gmail.com

        https://bugs.webkit.org/show_bug.cgi?id=19965

        - Added "@"{ident} rule (below other @-rules) to use flex for longest match
          (if an earlier rule - e.g. @media - also matches then flex chooses that one
           however, if a longer match - e.g. @mediaall matches flex will choose that)
        - Updated grammar to defined ATKEYWORD token and to use that instead of '@'
          in the error recovery grammar. 

        Test: css2.1/atrule_longest_match.html

        * ChangeLog:
        * css/CSSGrammar.y:
        * css/tokenizer.flex:

2008-07-17  David Hyatt  <hyatt@apple.com>

        Make sure the check to see if a frame/iframe is being rendered inside a transparency layer is
        recursive (and checks for transparency layers all the way up the ancestor document chain back to
        the top-level frame).

        Reviewed by Dan

        * rendering/RenderView.cpp:
        (WebCore::RenderView::paintBoxDecorations):

2008-07-16  Jon Honeycutt  <jhoneycutt@apple.com>

        REGRESSION: Can't create windowless plug-in with Flash 9
        https://bugs.webkit.org/show_bug.cgi?id=20070

        Reviewed by Mark Rowe.

        * plugins/win/PluginPackageWin.cpp:
        (WebCore::PluginPackage::determineQuirks): Reverse argument order;
        PlatformModuleVersion constructor takes leastSig, mostSig.

2008-07-16  Eric Seidel  <eric@webkit.org>

        Reviewed by mitz.

        Attempt to make initializeATSUStyle human-readable by
        splitting it out into better-named static inline functions.

        No functional changes, thus no tests.

        * platform/graphics/mac/FontMac.mm:
        (WebCore::fontHasMirroringInfo):
        (WebCore::disableLigatures):
        (WebCore::initializeATSUStyle):

2008-07-16  Eric Seidel  <eric@webkit.org>

        No review, build fix only.

        Attempt to fix Mac build

        * WebCore.xcodeproj/project.pbxproj: Make TextRun.h a private header.

2008-07-16  Eric Seidel  <eric@webkit.org>

        Reviewed by mitz.

        Make ATSULayoutParameters a real C++ class
        (Give it a destructor to clean up after itself)
        (Also use OwnArrayPtr instead of manual member cleanup)

        * platform/graphics/mac/FontMac.mm:
        (WebCore::ATSULayoutParameters::ATSULayoutParameters):
        (WebCore::ATSULayoutParameters::~ATSULayoutParameters):
        (WebCore::overrideLayoutOperation):
        (WebCore::ATSULayoutParameters::initialize):
        (WebCore::Font::selectionRectForComplexText):
        (WebCore::Font::drawComplexText):
        (WebCore::Font::floatWidthForComplexText):
        (WebCore::Font::offsetForPositionForComplexText):

2008-07-16  Eric Seidel  <eric@webkit.org>

        Reviewed by mitz.

        Make ownership of copied UChar buffer clearer
        (and more leak-proof) by using a OwnArrayPtr.

        No functional changes, thus no tests.

        * platform/graphics/mac/FontMac.mm:
        (WebCore::copyRunForDirectionalOverrideIfNecessary):
        (WebCore::Font::selectionRectForComplexText):
        (WebCore::Font::drawComplexText):
        (WebCore::Font::offsetForPositionForComplexText):

2008-07-16  Eric Seidel  <eric@webkit.org>

        Reviewed by Sam.

        Split out TextRun into its own header file.
        Re-order members to place all bools together
        (to allow compilers to better pack the struct)

        No functional changes, thus no tests.

        * WebCore.vcproj/WebCore.vcproj:
        * WebCore.xcodeproj/project.pbxproj:
        * platform/graphics/Font.h: Moved TextRun into its own file.
        * platform/graphics/TextRun.h: Split out from Font.h

2008-07-16  Simon Fraser  <simon.fraser@apple.com>

        Reviewed by Dave Hyatt

        AnimationController needs to adjust z-index in the blended
        style in case opacity or transform were changed by blending.

        https://bugs.webkit.org/show_bug.cgi?id=20047
        
        Test: transitions/opacity-transition-zindex.html

        * page/AnimationController.cpp:
        (WebCore::AnimationController::updateImplicitAnimations):

2008-07-16  Nikolas Zimmermann  <zimmermann@kde.org>

        Reviewed by Sam.

        Fixes: https://bugs.webkit.org/show_bug.cgi?id=20052 
        Prepare SVGAnimatedProperty introduction.

        Export the tag & attribute names as string literals for SVGNames/XLinkNames and one property in HTMLNames. SVGAnimatedProperty
        contains two string literal template parameters, and we're using these exported string literals from {SVG,HTML,XLink}Names as input paramters.
        See https://bugs.webkit.org/show_bug.cgi?id=20051 for details.

        * dom/make_names.pl: Handle new params "exportString" / "exportStrings".
        * html/HTMLAttributeNames.in: Expose just the single "class" attribute, as string.
        * svg/svgattrs.in: Export all SVG attributes as strings.
        * svg/svgtags.in: Export all SVG tags as strings.
        * svg/xlinkattrs.in: Expose all XLink attributes as strings.

2008-07-16  Nikolas Zimmermann  <zimmermann@kde.org>

        Reviewed by Eric.

        Fixes: https://bugs.webkit.org/show_bug.cgi?id=10745 (SVGLength object needs some weight loss)
        Don't store a context pointer in SVGLength, saving memory. Let the caller of the value() & convertToSpecifiedUnits() pass it.

        Remove some uneeded contextElement() functions, by moving into approriate shared base classes.

        * GNUmakefile.am:
        * WebCore.pro:
        * WebCore.vcproj/WebCore.vcproj:
        * WebCore.xcodeproj/project.pbxproj:
        * bindings/js/JSSVGLengthCustom.cpp: Added.
        (WebCore::JSSVGLength::value):
        (WebCore::JSSVGLength::convertToSpecifiedUnits):
        * bindings/scripts/CodeGeneratorObjC.pm:
        * css/CSSCursorImageValue.cpp:
        (WebCore::CSSCursorImageValue::updateIfSVGCursorIsUsed):
        * rendering/RenderForeignObject.cpp:
        (WebCore::RenderForeignObject::translationForAttributes):
        * rendering/RenderSVGImage.cpp:
        (WebCore::RenderSVGImage::layout):
        * rendering/RenderSVGRoot.cpp:
        (WebCore::RenderSVGRoot::calcViewport):
        * rendering/RenderSVGText.cpp:
        (WebCore::RenderSVGText::layout):
        * rendering/RenderSVGViewportContainer.cpp:
        (WebCore::RenderSVGViewportContainer::calcViewport):
        * rendering/SVGCharacterLayoutInfo.cpp:
        (WebCore::SVGCharacterLayoutInfo::addLayoutInformation):
        (WebCore::SVGCharacterLayoutInfo::addStackContent):
        * rendering/SVGCharacterLayoutInfo.h:
        * rendering/SVGRootInlineBox.cpp:
        (WebCore::SVGRootInlineBox::buildTextChunks):
        * svg/SVGAnimateElement.h:
        * svg/SVGAnimateMotionElement.h:
        * svg/SVGAnimateTransformElement.h:
        * svg/SVGAnimationElement.h:
        (WebCore::SVGAnimationElement::contextElement):
        * svg/SVGCircleElement.cpp:
        (WebCore::SVGCircleElement::SVGCircleElement):
        (WebCore::SVGCircleElement::parseMappedAttribute):
        (WebCore::SVGCircleElement::toPathData):
        * svg/SVGCursorElement.cpp:
        (WebCore::SVGCursorElement::SVGCursorElement):
        (WebCore::SVGCursorElement::parseMappedAttribute):
        * svg/SVGEllipseElement.cpp:
        (WebCore::SVGEllipseElement::SVGEllipseElement):
        (WebCore::SVGEllipseElement::parseMappedAttribute):
        (WebCore::SVGEllipseElement::toPathData):
        * svg/SVGFilterElement.cpp:
        (WebCore::SVGFilterElement::SVGFilterElement):
        (WebCore::SVGFilterElement::parseMappedAttribute):
        (WebCore::SVGFilterElement::canvasResource):
        * svg/SVGFilterPrimitiveStandardAttributes.cpp:
        (WebCore::SVGFilterPrimitiveStandardAttributes::SVGFilterPrimitiveStandardAttributes):
        (WebCore::SVGFilterPrimitiveStandardAttributes::parseMappedAttribute):
        (WebCore::SVGFilterPrimitiveStandardAttributes::setStandardAttributes):
        * svg/SVGForeignObjectElement.cpp:
        (WebCore::SVGForeignObjectElement::SVGForeignObjectElement):
        (WebCore::SVGForeignObjectElement::parseMappedAttribute):
        * svg/SVGImageElement.cpp:
        (WebCore::SVGImageElement::SVGImageElement):
        (WebCore::SVGImageElement::parseMappedAttribute):
        * svg/SVGLength.cpp:
        (WebCore::SVGLength::SVGLength):
        (WebCore::SVGLength::value):
        (WebCore::SVGLength::convertToSpecifiedUnits):
        (WebCore::SVGLength::PercentageOfViewport):
        * svg/SVGLength.h:
        * svg/SVGLength.idl:
        * svg/SVGLengthList.cpp:
        (WebCore::SVGLengthList::parse):
        * svg/SVGLengthList.h:
        * svg/SVGLineElement.cpp:
        (WebCore::SVGLineElement::SVGLineElement):
        (WebCore::SVGLineElement::parseMappedAttribute):
        (WebCore::SVGLineElement::toPathData):
        * svg/SVGLinearGradientElement.cpp:
        (WebCore::SVGLinearGradientElement::SVGLinearGradientElement):
        (WebCore::SVGLinearGradientElement::parseMappedAttribute):
        * svg/SVGMarkerElement.cpp:
        (WebCore::SVGMarkerElement::SVGMarkerElement):
        (WebCore::SVGMarkerElement::parseMappedAttribute):
        (WebCore::SVGMarkerElement::canvasResource):
        * svg/SVGMaskElement.cpp:
        (WebCore::SVGMaskElement::SVGMaskElement):
        (WebCore::SVGMaskElement::parseMappedAttribute):
        (WebCore::SVGMaskElement::drawMaskerContent):
        * svg/SVGPatternElement.cpp:
        (WebCore::SVGPatternElement::SVGPatternElement):
        (WebCore::SVGPatternElement::parseMappedAttribute):
        (WebCore::SVGPatternElement::buildPattern):
        * svg/SVGRadialGradientElement.cpp:
        (WebCore::SVGRadialGradientElement::SVGRadialGradientElement):
        (WebCore::SVGRadialGradientElement::parseMappedAttribute):
        * svg/SVGRectElement.cpp:
        (WebCore::SVGRectElement::SVGRectElement):
        (WebCore::SVGRectElement::parseMappedAttribute):
        (WebCore::SVGRectElement::toPathData):
        * svg/SVGSVGElement.cpp:
        (WebCore::SVGSVGElement::SVGSVGElement):
        (WebCore::SVGSVGElement::viewport):
        (WebCore::SVGSVGElement::parseMappedAttribute):
        (WebCore::SVGSVGElement::getCTM):
        (WebCore::SVGSVGElement::getScreenCTM):
        * svg/SVGTextContentElement.cpp:
        (WebCore::SVGTextContentElement::SVGTextContentElement):
        (WebCore::SVGTextContentElement::parseMappedAttribute):
        * svg/SVGTextPathElement.cpp:
        (WebCore::SVGTextPathElement::SVGTextPathElement):
        (WebCore::SVGTextPathElement::parseMappedAttribute):
        * svg/SVGTextPositioningElement.cpp:
        (WebCore::SVGTextPositioningElement::parseMappedAttribute):
        * svg/SVGUseElement.cpp:
        (WebCore::SVGUseElement::SVGUseElement):
        (WebCore::SVGUseElement::parseMappedAttribute):
        (WebCore::SVGUseElement::buildPendingResource):
        (WebCore::SVGUseElement::buildInstanceTree):
        (WebCore::SVGUseElement::handleDeepUseReferencing):
        (WebCore::SVGUseElement::alterShadowTreeForSVGTag):
        (WebCore::SVGUseElement::expandUseElementsInShadowTree):
        (WebCore::SVGUseElement::expandSymbolElementsInShadowTree):
        * svg/SVGUseElement.h:
        * svg/SynchronizableTypeWrapper.h:
        * svg/graphics/SVGImage.cpp:
        (WebCore::SVGImage::size):

2008-07-16  Geoffrey Garen  <ggaren@apple.com>

        Reviewed by Oliver Hunt.

        Support for JavaScriptCore's first step toward putting doubles in
        registers: Treat ArgList iterators as Register*'s, not JSValue*'s.

        * bindings/js/ScheduledAction.cpp:
        (WebCore::ScheduledAction::ScheduledAction):

2008-07-15  Maxime Britto  <britto@apple.com>

        Reviewed by Eric.

        https://bugs.webkit.org/show_bug.cgi?id=17589
        <rdar://problem/5770893>
        Retrieve the wheel sensitivity setting from windows system settings for the horizontal and the vertical scrolling.
        Allows the page scrolling with the wheel (if activated in windows settings) on both horizontal and vertical ways
        For the other platforms, nothing is changed but if someone want to activate this feature 
        he/she has to retrieve the settings and fill out the m_lineScrollSensitivity and/or m_charScrollSensitivity in his/her PlatformWheelEvent constructor.

        * ChangeLog:
        * page/EventHandler.cpp:
        (WebCore::scrollAndAcceptEvent): static inline function to avoid copy/paste in the member functions
        (WebCore::EventHandler::handleWheelEvent): Call to the above mentionned static inline function with the right parameters 
        * platform/PlatformWheelEvent.h:
        (WebCore::PlatformWheelEvent::deltaX): Now returns the delta multiplied by the user settings for the number of lines to scroll
        (WebCore::PlatformWheelEvent::deltaY): Now returns the delta multiplied by the user settings for the number of chars to scroll
        (WebCore::PlatformWheelEvent::isPageXScrollModeEnabled):
        (WebCore::PlatformWheelEvent::isPageYScrollModeEnabled):
        * platform/gtk/WheelEventGtk.cpp: Add the values to avoid build break but the factors are initialized to 1 not to change the previous behavior
        (WebCore::PlatformWheelEvent::PlatformWheelEvent):
        * platform/mac/WheelEventMac.mm: Add the values to avoid build break but the factors are initialized to 1 not to change the previous behavior
        (WebCore::PlatformWheelEvent::PlatformWheelEvent):
        * platform/qt/WheelEventQt.cpp: Add the values to avoid build break but the factors are initialized to 1 not to change the previous behavior
        (WebCore::PlatformWheelEvent::PlatformWheelEvent):
        * platform/win/ScrollViewWin.cpp: Added the page scroll (horiz/vertical) and reduced the number of pixels to scroll per line to keep the standard behavior with the factor
        (WebCore::adjustDeltaForPageScrollMode): static inline function to avoid copy/paste in the member functions
        (WebCore::ScrollView::updateScrollbars):
        (WebCore::ScrollView::wheelEvent):
        * platform/win/WheelEventWin.cpp: Retrieves the new values by using the win32 API.
        (WebCore::PlatformWheelEvent::PlatformWheelEvent):
        * platform/wx/MouseWheelEventWx.cpp: Add the values to avoid build break but the factors are initialized to 1 not to change the previous behavior
        (WebCore::PlatformWheelEvent::PlatformWheelEvent):

2008-07-15  Kevin Ollivier  <kevino@theolliviers.com>

        wx build fix - adding AccessibilityImageMapLink.cpp to the wx build.

        * WebCoreSources.bkl:

2008-07-15  Kevin McCullough  <kmccullough@apple.com>

        Reviewed by Dan.

        <rdar://problem/5620273> REGRESSION: Apparent caching between form
        submits twice (on Maconomy) (18401)

        Frames did not set the createdByParser flag even when they were.

        * html/HTMLElementFactory.cpp:
        (WebCore::frameConstructor):
        (WebCore::iframeConstructor):

2008-07-15  Dan Bernstein  <mitz@apple.com>

        Reviewed by Dave Hyatt.

        - fix https://bugs.webkit.org/show_bug.cgi?id=19525
          <rdar://problem/5961768> -webkit-box-reflect in hyperlink causes webkit to crash

        Test: fast/reflections/inline-crash.html

        * rendering/RenderInline.cpp:
        (WebCore::RenderInline::setStyle): Added setHasReflection(false).
        Inline flows never have reflections.

2008-07-14  David Hyatt  <hyatt@apple.com>

        Allow <style> and <link> pretty much anywhere.  They will still be moved to the <head> if
        no <body> exists yet though.

        Reviewed by Sam

        Added fast/css/style-parsed-outside-of-head.html

        * html/HTMLElement.cpp:
        (WebCore::inlineTagList):

2008-07-15  Kevin McCullough  <kmccullough@apple.com>

        Reviewed by Geoff.

        Rename pageGroupIdentifier to profileGroup to keep mention of a
        pageGroup out of JavaScriptCore.

        * bindings/js/JSQuarantinedObjectWrapper.cpp:
        (WebCore::JSQuarantinedObjectWrapper::allowsUnwrappedAccessFrom):
        * bindings/js/ScriptController.cpp:
        (WebCore::ScriptController::clear):
        (WebCore::ScriptController::initScript):
        * history/CachedPage.cpp:
        (WebCore::CachedPage::restore):

2008-07-15  Adam Roben  <aroben@apple.com>

        WebCore part of adding WebKit[Set]ShouldUseFontSmoothing functions

        <rdar://6059127>

        Reviewed by John Sullivan.

        * platform/graphics/win/FontCGWin.cpp:
        (WebCore::Font::drawGlyphs): Pass the result of
        WebCoreShouldUseFontSmoothing() into wkSetFontSmoothingStyle.
        * platform/win/WebCoreTextRenderer.cpp:
        (WebCore::WebCoreSetShouldUseFontSmoothing):
        (WebCore::WebCoreShouldUseFontSmoothing):
        Added.
        * platform/win/WebCoreTextRenderer.h:

2008-07-15  Adam Roben  <aroben@apple.com>

        Windows build fix

        * WebCore.vcproj/WebCore.vcproj: Add AccessibilityImageMapLink.{cpp,h}
        to the project.

2008-07-15  Holger Hans Peter Freyther  <zecke@selfish.org>

        Build fix for the Gtk+ and Qt platform.

        * GNUmakefile.am: Add AccessibilityImageMapLink.cpp to the build
        * WebCore.pro: Add AccessibilityImageMapLink.cpp to the build

2008-07-14  Dan Bernstein  <mitz@apple.com>

        - Tiger build fix

        * platform/mac/WidgetMac.mm:
        (WebCore::Widget::paint):

2008-07-14  Dan Bernstein  <mitz@apple.com>

        Reviewed by John Sullivan.

        - WebCore part of fixing <rdar://problem/6071850> Subviews not drawn correctly when using -cacheDisplayInRect:toBitmapImageRep:

        * platform/mac/WidgetMac.mm:
        (WebCore::Widget::paint): Changed to account for the case of drawing
        into a bitmap context that is not a window's backing store. In that
        case, -displayRectIgnoringOpacity:inContext: is used to redirect the
        drawing to the correct context, after setting up the right transform
        on it. For subframes, additional code ensures that the scroll view will
        not paint the background behind a transparent frame.

2008-07-14  chris fleizach  <cfleizach@apple.com>

        Reviewed by Beth Dakin

        <rdar://problem/6038106> AXChildren returned for this web area is null
        Accessibility of image maps needed to be updated

        Tests: accessibility/image-map1.html
               accessibility/image-map2.html

        * WebCore.xcodeproj/project.pbxproj:
        * page/AXObjectCache.cpp:
        (WebCore::AXObjectCache::get):
        * page/AccessibilityImageMapLink.cpp: Added.
        (WebCore::AccessibilityImageMapLink::AccessibilityImageMapLink):
        (WebCore::AccessibilityImageMapLink::~AccessibilityImageMapLink):
        (WebCore::AccessibilityImageMapLink::create):
        (WebCore::AccessibilityImageMapLink::parentObject):
        (WebCore::AccessibilityImageMapLink::anchorElement):
        (WebCore::AccessibilityImageMapLink::accessibilityDescription):
        (WebCore::AccessibilityImageMapLink::title):
        (WebCore::AccessibilityImageMapLink::elementRect):
        (WebCore::AccessibilityImageMapLink::size):
        * page/AccessibilityImageMapLink.h: Added.
        (WebCore::AccessibilityImageMapLink::setHTMLAreaElement):
        (WebCore::AccessibilityImageMapLink::setHTMLMapElement):
        (WebCore::AccessibilityImageMapLink::roleValue):
        (WebCore::AccessibilityImageMapLink::accessibilityIsIgnored):
        (WebCore::AccessibilityImageMapLink::isLink):
        * page/AccessibilityListBoxOption.h:
        * page/AccessibilityObject.cpp:
        (WebCore::AccessibilityObject::selectedChildren):
        (WebCore::AccessibilityObject::visibleChildren):
        * page/AccessibilityObject.h:
        (WebCore::):
        * page/AccessibilityRenderObject.cpp:
        (WebCore::AccessibilityRenderObject::parentObject):
        (WebCore::AccessibilityRenderObject::isAnchor):
        (WebCore::AccessibilityRenderObject::anchorElement):
        (WebCore::AccessibilityRenderObject::helpText):
        (WebCore::AccessibilityRenderObject::intValue):
        (WebCore::AccessibilityRenderObject::stringValue):
        (WebCore::AccessibilityRenderObject::title):
        (WebCore::AccessibilityRenderObject::accessibilityDescription):
        (WebCore::AccessibilityRenderObject::elementRect):
        (WebCore::AccessibilityRenderObject::accessibilityIsIgnored):
        (WebCore::AccessibilityRenderObject::roleValue):
        (WebCore::AccessibilityRenderObject::canSetFocusAttribute):
        (WebCore::AccessibilityRenderObject::addChildren):
        * page/AccessibilityRenderObject.h:
        * page/mac/AccessibilityObjectWrapper.mm:
        (convertToNSArray):
        (RoleEntry::):

2008-07-14  Sam Weinig  <sam@webkit.org>

        Rubber-stamped by David Hyatt.

        Remove unused ExceptionCode parameter from compareDocumentPosition.

        * dom/Document.cpp:
        (WebCore::Document::addStyleSheetCandidateNode):
        * dom/Node.cpp:
        (WebCore::Node::compareDocumentPosition):
        * dom/Node.h:
        * dom/Node.idl:

2008-07-14  David Hyatt  <hyatt@apple.com>

        Fix for bugzilla bug 5476, link and style elements should be allowed outside the <head>.

        Reviewed by Sam

        Added fast/css/style-outside-head.html
        Added fast/css/link-outside-head.html

        * dom/Document.cpp:
        (WebCore::Document::addStyleSheetCandidateNode):
        (WebCore::Document::removeStyleSheetCandidateNode):
        (WebCore::Document::recalcStyleSelector):
        * dom/Document.h:
        * dom/Node.cpp:
        (WebCore::Node::compareDocumentPosition):
        * dom/ProcessingInstruction.cpp:
        (WebCore::ProcessingInstruction::checkStyleSheet):
        (WebCore::ProcessingInstruction::insertedIntoDocument):
        (WebCore::ProcessingInstruction::removedFromDocument):
        (WebCore::ProcessingInstruction::finishParsingChildren):
        * dom/ProcessingInstruction.h:
        (WebCore::ProcessingInstruction::setCreatedByParser):
        * dom/StyleElement.cpp:
        (WebCore::StyleElement::removedFromDocument):
        * dom/XMLTokenizer.cpp:
        (WebCore::XMLTokenizer::startElementNs):
        (WebCore::XMLTokenizer::processingInstruction):
        (WebCore::):
        * html/HTMLElementFactory.cpp:
        (WebCore::linkConstructor):
        * html/HTMLLinkElement.cpp:
        (WebCore::HTMLLinkElement::HTMLLinkElement):
        (WebCore::HTMLLinkElement::insertedIntoDocument):
        (WebCore::HTMLLinkElement::removedFromDocument):
        (WebCore::HTMLLinkElement::finishParsingChildren):
        * html/HTMLLinkElement.h:
        (WebCore::HTMLLinkElement::setCreatedByParser):
        * html/HTMLStyleElement.cpp:
        (WebCore::HTMLStyleElement::insertedIntoDocument):
        (WebCore::HTMLStyleElement::removedFromDocument):
        * svg/SVGStyleElement.cpp:
        (WebCore::SVGStyleElement::insertedIntoDocument):
        (WebCore::SVGStyleElement::removedFromDocument):

2008-07-14  Sam Weinig  <sam@webkit.org>

        Reviewed by Mark Rowe.

        Sort interface extended attributes to appease *the* Mark Rowe.

        * page/DOMWindow.idl:

2008-07-14  Anders Carlsson  <andersca@apple.com>

        Reviewed by Geoff.

        <rdar://problem/6073974>
        https://bugs.webkit.org/show_bug.cgi?id=18106
        The "onscroll" event bubbles, which is inconsistent with Firefox and IE

        Don't bubble the scroll event.
        
        * rendering/RenderLayer.cpp:
        (WebCore::RenderLayer::scrollToOffset):
        * rendering/RenderListBox.cpp:
        (WebCore::RenderListBox::valueChanged):

2008-07-14  Adele Peterson  <adele@apple.com>

        Reviewed by Geoff.

        Fix for <rdar://problem/5784890> REGRESSION (Safari 3): Can't edit SpeedStream 4100 DSL modem settings

        The web server on this particular piece of hardware doesn't handle "text/xml" in the 
        Accept header if the headers are sent in a certain order.  Safari 2 used to send "*/*" in 
        the Accept header.  Firefox 2 sent "text/xml" but in an acceptable order for the web 
        server.  And Firefox 3 doesn't send "text/xml" at all in the Accept header since it 
        is being deprecated in favor of "application/xml".  We decided that the best solution is 
        to match Firefox 3 and stop sending "text/xml" in the Accept header.

        No test.  There appears to be no way to get the raw headers in the original order in perl/php.

        * loader/FrameLoader.cpp: (WebCore::FrameLoader::addExtraFieldsToRequest):

2008-07-14  Sam Weinig  <sam@webkit.org>

        Reviewed by Adele Peterson.

        Fix for <rdar://problem/5769819>

        Test: http/tests/security/cross-frame-access-object-prototype.html

        * bindings/js/JSDOMWindowCustom.cpp:
        (WebCore::JSDOMWindow::getPropertyAttributes): Perform security check.
        (WebCore::JSDOMWindow::defineGetter): Ditto.
        (WebCore::JSDOMWindow::defineSetter): Ditto.
        (WebCore::JSDOMWindow::lookupGetter): Ditto.
        (WebCore::JSDOMWindow::lookupSetter): Ditto.
        * bindings/scripts/CodeGeneratorJS.pm: Add support for custom versions
        of all the core JSObject functionality.
        * page/DOMWindow.idl: Override remaining core JSObject functionality,
        to inject security checks.

2008-07-14  Adam Roben  <aroben@apple.com>

        Windows build fixes

        * WebCore.vcproj/WebCore.vcproj: Add include/pthreads to the include
        path.
        * bindings/scripts/CodeGeneratorCOM.pm: Touched this to force COM
        bindings to regenerate.
        * loader/FTPDirectoryDocument.cpp:
        * loader/FTPDirectoryParser.cpp:
        Fixed some duplicate macro definitions now that we're including
        pthread.h again.

2008-07-14  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Kevin McCullough.

        Make JSGlobalData refcounted in preparation to adding a way to create contexts that share
        global data.

        * bindings/js/JSDOMWindowBase.cpp:
        (WebCore::JSDOMWindowBase::commonJSGlobalData): Create JSGlobalData with create() method.

2008-07-14  Simon Hausmann  <hausmann@webkit.org>

        Reviewed by Holger.

        Make listDirectory() in the Qt port work with empty namefilters.
        Don't include . and .. to avoid scanning the parent directory.

        * platform/qt/FileSystemQt.cpp:
        (WebCore::listDirectory):

2008-07-14  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Geoff Garen.

        Eliminate per-thread JavaScript global data instance support and make arbitrary
        global data/global object combinations possible.

        * bindings/js/JSDOMWindowBase.h:
        * bindings/js/JSDOMWindowBase.cpp: (WebCore::JSDOMWindowBase::commonJSGlobalData): Added.
        WebCore uses its own instance of JSGlobalData, as JSC no longer provides a per-thread one.

        * bindings/js/JSDOMWindowShell.cpp:
        (WebCore::JSDOMWindowShell::JSDOMWindowShell):
        (WebCore::JSDOMWindowShell::operator new):
        * bindings/js/ScriptController.cpp:
        (WebCore::ScriptController::clear):
        * bindings/scripts/CodeGeneratorJS.pm:
        Pass commonJSGlobalData() as an allocator.

        * bridge/c/c_utility.cpp:
        (KJS::Bindings::identifierFromNPIdentifier):
        * bridge/jni/jni_class.cpp:
        (JavaClass::JavaClass):
        * history/CachedPage.cpp:
        (WebCore::CachedPage::restore):
        * storage/Database.cpp:
        (WebCore::Database::Database):
        * bindings/js/GCController.cpp:
        (WebCore::collect):
        (WebCore::GCController::gcTimerFired):
        (WebCore::GCController::garbageCollectNow):
        Use JSDOMWindow::commonJSGlobalData().

        * ForwardingHeaders/wtf/ThreadSpecific.h: Added (collector.h now includes this header, so
        it need to be accesible outside of JSC).

        * WebCore.base.exp: Export JSDOMWindowBase::commonJSGlobalData().

2008-07-14  Ariya Hidayat  <ariya.hidayat@trolltech.com>

        Reviewed by Simon.

        MinGW build fixes

        * plugins/win/PluginDatabaseWin.cpp:
        * plugins/win/PluginViewWin.cpp:
        (WebCore::PluginView::handleKeyboardEvent):
        (WebCore::PluginView::handleMouseEvent):
        * svg/SynchronizableTypeWrapper.h:
        (WebCore::::SynchronizableTypeWrapper):

2008-07-13  Sam Weinig  <sam@webkit.org>

        Reviewed by Oliver Hunt and Dan Bernstein.

        Fix for <rdar://problem/5888127>
        https://bugs.webkit.org/show_bug.cgi?id=18699

        - Match Firefox in restricting the size of custom cursor to images to
          128x128 px.
        - Restrict custom cursor hotspots to values within the bounds of the
          cursor image.

        * manual-tests/cursor-max-size.html: Added.
        * page/EventHandler.cpp:
        (WebCore::EventHandler::selectCursor):

2008-07-13  Kevin Ollivier  <kevino@theolliviers.com>

        wx build fix.

        * platform/graphics/wx/AffineTransformWx.cpp:
        (WebCore::AffineTransform::a):
        (WebCore::AffineTransform::b):
        (WebCore::AffineTransform::c):
        (WebCore::AffineTransform::d):
        (WebCore::AffineTransform::e):
        (WebCore::AffineTransform::f):

2008-07-12  Dan Bernstein  <mitz@apple.com>

        Reviewed by Oliver Hunt.

        - fix https://bugs.webkit.org/show_bug.cgi?id=18088
          <rdar://problem/6036232> white-space:nowrap; float:left; causing the misalignment issue

        Test: fast/block/basic/min-pref-width-nowrap-floats.html

        * rendering/RenderBlock.cpp:
        (WebCore::RenderBlock::calcInlinePrefWidths): Fixed a case where a
        float's width was added to the minimum preferred widths instead of just
        acting as a lower bound on the minimum preferred width (since the float
        can always be pushed down to be the only thing on the line).

2008-07-12  David D. Kilzer  <ddkilzer@webkit.org>

        Bug 13067: Manually adding #hash to URL reloads entire page instead of jumping to #hash location in cached page

        <https://bugs.webkit.org/show_bug.cgi?id=13067>

        Reviewed by Darin.

        Test: WebCore/manual-tests/hash-ref.html

        * loader/FrameLoader.cpp:
        (WebCore::FrameLoader::load(const KURL& newURL, const String& referrer,
             FrameLoadType newLoadType, const String& frameName, Event* event,
             PassRefPtr<FormState> formState)): Extracted logic into
        shouldScrollToAnchor() for determining when to scroll to an anchor.

        (WebCore::FrameLoader::load(DocumentLoader* loader, FrameLoadType type,
             PassRefPtr<FormState> formState)): Added check for
        shouldScrollToAnchor() to catch cases when the user manually added a
        hash ref to the URL in the address bar.  This is the bug fix.

        (WebCore::FrameLoader::shouldReload): Simplified early return logic.
        We only need to check if the destinationURL has a hash ref, not the
        currentURL, per the comment in the method.

        (WebCore::FrameLoader::shouldScrollToAnchor): Added.  Logic extracted
        from the FrameLoader::load(const KURL& newURL, ...) method.  Fixed order
        of arguments to shouldReload() since they were backwards, although the
        previous logic in the method made this irrelevant.

        (WebCore::FrameLoader::loadItem): Removed call to shouldReload().  Since
        we're navigating to a HistoryItem, it doesn't make sense to ask whether
        we need to reload the page or not.  Additionally, the logic at the end
        of shouldReload() is also checked in urlsMatchItem(), so there's no need
        to call the method.  This fixed the fast/css/target-fragment-match.html
        test from continuously reloading after the other changes.

        * loader/FrameLoader.h:
        (WebCore::FrameLoader::shouldScrollToAnchor): Added.

        * manual-tests/hash-ref.html: Added.
        * manual-tests/resources/hash-ref-test.html: Added.

2008-07-11  Stephanie Lewis  <slewis@apple.com>

        Reviewed by Darin Adler.

        No Functionality Changed.  Change all the leak counting code to use the new WTF leak counter class.

        * bindings/js/JSCustomSQLTransactionCallback.cpp:
        (WebCore::JSCustomSQLTransactionCallback::JSCustomSQLTransactionCallback):
        (WebCore::JSCustomSQLTransactionCallback::~JSCustomSQLTransactionCallback):
        * bindings/js/JSEventListener.cpp:
        (WebCore::JSEventListener::JSEventListener):
        (WebCore::JSEventListener::~JSEventListener):
        * dom/Node.cpp:
        (WebCore::Node::Node):
        (WebCore::Node::~Node):
        * dom/Range.cpp:
        (WebCore::Range::Range):
        (WebCore::Range::~Range):
        * history/CachedPage.cpp:
        (WebCore::CachedPage::CachedPage):
        (WebCore::CachedPage::~CachedPage):
        * loader/SubresourceLoader.cpp:
        (WebCore::SubresourceLoader::SubresourceLoader):
        (WebCore::SubresourceLoader::~SubresourceLoader):
        * page/Frame.cpp:
        (WebCore::Frame::Frame):
        (WebCore::Frame::~Frame):
        * page/Page.cpp:
        (WebCore::Page::Page):
        (WebCore::Page::~Page):
        * rendering/RenderObject.cpp:
        (WebCore::RenderObject::RenderObject):
        (WebCore::RenderObject::~RenderObject):
        * rendering/bidi.cpp:
        (WebCore::throw):
        (WebCore::BidiRun::operator delete):

2008-07-11  Sam Weinig  <sam@webkit.org>

        Reviewed by Mark Rowe.

        Update getSubStringLength and selectSubString methods exception throwing conditions
        based on SVG working group errata.

        Test: svg/custom/selectSubString.html

        * svg/SVGTextContentElement.cpp:
        (WebCore::SVGTextContentElement::getSubStringLength):
        (WebCore::SVGTextContentElement::selectSubString):

2008-07-11  Sam Weinig  <sam@webkit.org>

        Reviewed by Mark Rowe.

        We can only use the Id fast path for querySelector and querySelectorAll
        if the selector is purely an Id selector.

        Test: fast/dom/SelectorAPI/id-fastpath.html

        * dom/Node.cpp:
        (WebCore::Node::querySelector):
        * dom/SelectorNodeList.cpp:
        (WebCore::createSelectorNodeList):

2008-07-11  David Hyatt  <hyatt@apple.com>

        Implement the DOM level 3 compareDocumentPosition method on Node.

        Reviewed by Darin

        * dom/Node.cpp:
        (WebCore::Node::compareDocumentPosition):
        * dom/Node.h:
        * dom/Node.idl:

2008-07-11  Brady Eidson  <beidson@apple.com>

        Rubberstamped by Sam

        Removed unneeded export

        * WebCore.base.exp:

2008-07-11  Kevin McCullough  <kmccullough@apple.com>

        Reviewed by Geoff.

        <rdar://problem/6067178> REGRESSION: Start profile button in profiler
        now profiles inspector rather than actual page (19833)
        - The JSQuarantinedObjectWrapper should use the wrapped exec state
        so that calls to it execute in its quarantined world.

        * bindings/js/JSQuarantinedObjectWrapper.cpp:
        (WebCore::JSQuarantinedObjectWrapper::construct):
        (WebCore::JSQuarantinedObjectWrapper::call):

2008-07-11  Simon Fraser  <simon.fraser@apple.com>

        Reviewed by Dave Hyatt

        StyleRareNonInheritedData needs to initialize and compare
        m_maskBoxImage.
        <https://bugs.webkit.org/show_bug.cgi?id=20005>

        * rendering/style/RenderStyle.cpp:
        (WebCore::StyleRareNonInheritedData::StyleRareNonInheritedData):
        (WebCore::StyleRareNonInheritedData::operator==):

2008-07-11  Simon Fraser  <simon.fraser@apple.com>

        Reviewed by Dave Hyatt

        Bug 18885: RenderLayer::enclosingPositionedAncestor() should
        look for transforms, since transforms create containing
        blocks.
        <https://bugs.webkit.org/show_bug.cgi?id=18885>

        Test: fast/transforms/transform-positioned-ancestor.html

        * rendering/RenderLayer.cpp:
        (WebCore::RenderLayer::stackingContext):
        (WebCore::RenderLayer::enclosingPositionedAncestor):
        (WebCore::RenderLayer::enclosingTransformedAncestor):

2008-07-11  Jacob Refstrup  <jacob.refstrup@hp.com>

        Reviewed by Darin Adler

        http://bugs.webkit.org/show_bug.cgi?id=19978
        GTK port always ends up with # at the end of resource URLs (and hence can't load files)

        - Optimized KURL::removeRef() and used it rather than setRef("")
          which after r35040 does the wrong thing.

        * platform/KURL.cpp:
        (WebCore::KURL::removeRef):
        * platform/network/curl/ResourceHandleManager.cpp:
        (WebCore::ResourceHandleManager::initializeHandle):

2008-07-11  Simon Hausmann  <hausmann@webkit.org>

        Fix the Qt/Windows build, include windows.h for HWND directly
        instead of implicit inclusion through Timer.h.

        * plugins/win/PluginMessageThrottlerWin.h:

2008-07-11  Dan Bernstein  <mitz@apple.com>

        Reviewed by Darin Adler.

        - fix popularity tracking for cached resources, which regressed in r23923

        * loader/Cache.cpp:
        (WebCore::Cache::requestResource): Changed to increase the access count
        whenever this function returns a CachedResource and the cache is
        enabled, instead of only when creating a new CachedResources. The
        incorrect behavior resulted in all resources in the cache having an
        access count of exactly 1 at all times.
        (WebCore::Cache::requestUserCSSStyleSheet): Ditto.

2008-07-11  Ariya Hidayat  <ariya.hidayat@trolltech.com>

        Reviewed by Simon.

        Enable Netscape plugins for the Qt/Windows build.

        This required various smaller fixes across a wider set of
        files described below.

        * WebCore.pro: Add various windows specific files to the build.
        * page/Page.h: Extend the #ifdeffery for windows types to include the
        Qt/Windows build.
        * platform/graphics/GraphicsContext.h: Added inTransparencyLayer() for
        the Qt port, as PluginViewWin.cpp uses it.
        * platform/graphics/qt/GraphicsContextQt.cpp:
        (WebCore::GraphicsContext::inTransparencyLayer): Implemented function.
        * platform/qt/TemporaryLinkStubs.cpp: Mask out some stubs as they
        are now implemented through *Win.cpp files.
        * plugins/PluginDatabase.cpp: Change PLATFORM(WIN) to WIN_OS.
        * plugins/PluginView.cpp: Change PLATFORM(WIN) to WIN_OS.
        (WebCore::PluginView::setFrameGeometry): Ditto.
        (WebCore::PluginView::PluginView): Ditto.
        * plugins/PluginView.h: Introduce the PlatformPluginWidget typedef,
        which expands to HWND directly for the Qt/Windows build and
        PlatformWidget for the remaining platforms. That is because
        PlatformWidget is QWidget* for the Qt build but for the plugin
        window we need a native window, aka HWND.
        * plugins/win/PluginPackageWin.cpp: Fix compilation, include shlwapi.h
        after config.h.
        * plugins/win/PluginViewWin.cpp:
        (windowHandleForPlatformWidget): Added a little helper function to
        determine the HWND from a PlatformWidget.
        (WebCore::registerPluginView): For the Qt port we need to set the
        global application instance handle here in the library, as the
        browser doesn't do it.
        (WebCore::PluginView::handleMouseEvent): Mask out
        ignoreNextSetCursor/lastSetCursor for the Qt port, it's not used.
        (WebCore::PluginView::invalidateRect): Convert from IntRect to RECT
        manually just here to avoid compiling in IntRectWin.cpp.
        (WebCore::PluginView::invalidateRegion): Ditto.
        (WebCore::PluginView::forceRedraw): Call windowHandleForPlatformWidget
        on containingWindow() to get the correct HWND for the Qt port.
        (WebCore::PluginView::init): Determine the parent HWND for m_window
        using windowHandleForPlatformWidget.

2008-07-11  Simon Hausmann  <hausmann@webkit.org>

        Rubber-stamped by Holger.

        Enable Database and Icondatabase functionality for the Qt/Windows
        build when building inside Qt, as we can use the builtin copy of
        sqlite then.

        * WebCore.pro:

2008-07-11  Ariya Hidayat  <ariya.hidayat@trolltech.com>

        Reviewed by Adam Roben.

        Fix compile with MinGW since it does not like friend static function.

        * plugins/PluginView.h:
        * plugins/win/PluginViewWin.cpp:

2008-07-11  Ariya Hidayat  <ariya.hidayat@trolltech.com>

        Reviewed by Simon.

        Fix Qt/Win32 build.

        * platform/graphics/qt/GraphicsContextQt.cpp:

2008-07-10  Sam Weinig  <sam@webkit.org>

        Reviewed by Oliver Hunt.

        Add support for NSResolver to resolve namespaces for querySelector 
        and querySelectorAll.

        - Namespace resolution is done after parsing by iterating over all the
          parts of the CSSSelector.

        Tests: fast/dom/SelectorAPI/NSResolver-basic.xhtml
               fast/dom/SelectorAPI/NSResolver-exceptions.xhtml

        * GNUmakefile.am: Updated with new files.
        * WebCore.pro: Ditto.
        * WebCore.vcproj/WebCore.vcproj: Ditto.
        * WebCore.xcodeproj/project.pbxproj: Ditto.
        * WebCoreSources.bkl: Ditto.

        * bindings/js/JSDOMBinding.cpp:
        (WebCore::execStateFromNode):
        * bindings/js/JSDOMBinding.h:
        Move execStateFromNode here from NodeFilter.

        * bindings/js/JSDocumentCustom.cpp:
        (WebCore::JSDocument::querySelector): Don't throw a NOT_SUPPORTED_ERR for NSResolver
        and instead create one if the argument is not undefined or null.
        (WebCore::JSDocument::querySelectorAll): Ditto.
        * bindings/js/JSDocumentFragmentCustom.cpp:
        (WebCore::JSDocumentFragment::querySelector): Ditto.
        (WebCore::JSDocumentFragment::querySelectorAll): Ditto.
        * bindings/js/JSElementCustom.cpp:
        (WebCore::JSElement::querySelector): Ditto.
        (WebCore::JSElement::querySelectorAll): Ditto.

        * bindings/js/JSNSResolver.cpp: Added.
        (WebCore::JSNSResolver::JSNSResolver):
        (WebCore::JSNSResolver::mark):
        (WebCore::JSNSResolver::lookupNamespaceURI): Try and get the function
        from the passed in argument, either the value itself, or the result of
        getting the lookupNamespaceURI property, and call it.
        (WebCore::toNSResolver):
        * bindings/js/JSNSResolver.h: Added.
        (WebCore::JSNSResolver::create):

        * dom/Document.idl: Update with NSResolver parameter.
        * dom/DocumentFragment.idl: Ditto.
        * dom/Element.idl: Ditto.

        * dom/NSResolver.h: Added.
        (WebCore::NSResolver::~NSResolver):
        (WebCore::NSResolver::mark):
        Abstract base class.

        * dom/NSResolver.idl: Added.

        * dom/Node.cpp:
        (WebCore::forEachTagSelector):
        (WebCore::forEachSelector):
        Functions to iterate over all parts of the selector.

        (WebCore::SelectorNeedsNamespaceResolutionFunctor::operator()):
        Functor to be passed to forEachSelector to determine if a selector
        needs namespace resolution, for the case when no NSResolver is passed
        and we need to determine whether to throw a NAMESPACE_ERR.

        (WebCore::ResolveNamespaceFunctor::ResolveNamespaceFunctor):
        (WebCore::ResolveNamespaceFunctor::operator()):
        Functor to resolve namespaces for the selector.

        (WebCore::selectorNeedsNamespaceResolution):
        (WebCore::resolveNamespacesForSelector):
        (WebCore::Node::querySelector): Resolve namepspaces, including the defaultNamespace
        if a NSResolver is passed in.
        (WebCore::Node::querySelectorAll): Ditto.
        * dom/Node.h:

        * dom/NodeFilter.cpp:
        * dom/NodeFilter.h:
        * dom/NodeIterator.h:
        (WebCore::NodeIterator::nextNode):
        (WebCore::NodeIterator::previousNode):
        * dom/TreeWalker.h:
        (WebCore::TreeWalker::parentNode):
        (WebCore::TreeWalker::firstChild):
        (WebCore::TreeWalker::lastChild):
        (WebCore::TreeWalker::previousSibling):
        (WebCore::TreeWalker::nextSibling):
        (WebCore::TreeWalker::previousNode):
        (WebCore::TreeWalker::nextNode):
        Use the version of execStateFromNode in JSDOMBinding.

2008-07-10  Mark Rowe  <mrowe@apple.com>

        Reviewed by Sam Weinig.

        Define WEBKIT_VERSION_MIN_REQUIRED=WEBKIT_VERSION_LATEST when building WebKit to ensure that no symbols end up with the weak_import attribute.

        * Configurations/WebCore.xcconfig:

2008-07-10  Dean Jackson  <dino@apple.com>

        Reviewed by hyatt.

        Calculate computed style for -webkit-transform property
        https://bugs.webkit.org/show_bug.cgi?id=19864

        Test: css3/transform-computed-style-001.html

        * css/CSSComputedStyleDeclaration.cpp:
        (WebCore::computedTransform):
        (WebCore::CSSComputedStyleDeclaration::getPropertyCSSValue):
            handles -webkit-transform property now
        * manual-tests/computed-transform-value.html: Added.

2008-07-10  Dan Bernstein  <mitz@apple.com>

        Reviewed by Adam Roben.

        - fix a parse error in inspector.js

        * page/inspector/inspector.js: Added missing brace.

2008-07-10  Adam Roben  <aroben@apple.com>

        Build fix

        * WebCore.vcproj/QTMovieWin.vcproj: Add
        OSXCompatibilityHeaders[/GNUCompatibility] to the include path.

2008-07-10  Chris Fleizach  <cfleizach@apple.com>

        Reviewed by Dan Bernstein

        <rdar://problem/6067408> AX: internal anchors broken

        * page/AccessibilityRenderObject.cpp:
        (WebCore::AccessibilityRenderObject::internalLinkElement):
        * platform/KURL.cpp:
        (WebCore::KURL::removeRef):
        * platform/KURL.h:

2008-07-10  Mark Rowe  <mrowe@apple.com>

        Build fix.

        * bridge/npapi.h: Remove extra comma.

2008-07-10  Sam Weinig  <sam@webkit.org>

        Reviewed by Mark Rowe.

        Remove no-op debug method.

        * css/CSSSelector.cpp:
        * css/CSSSelector.h:

2008-07-10  Sam Weinig  <sam@webkit.org>

        Reviewed by Dave Hyatt and Darin Adler.

        Add support for calling querySelector and querySelectorAll on DocumentFragments

        - Fixes bug where nodes not in the document tree would not match based on ID due
          to over optimization.

        Test: fast/dom/SelectorAPI/detached-element.html

        * GNUmakefile.am:
        * WebCore.pro:
        * WebCore.vcproj/WebCore.vcproj:
        * WebCore.xcodeproj/project.pbxproj:
        * WebCoreSources.bkl:
        * bindings/js/JSDocumentFragmentCustom.cpp: Added.
        (WebCore::JSDocumentFragment::querySelector): Add custom code matching JSElement
        and JSDocument that checks for a 2nd arguments and throws an exception indicating
        we do not currently support the optional NSResolver part of the Selectors API spec.
        (WebCore::JSDocumentFragment::querySelectorAll): Ditto.
        * dom/DocumentFragment.idl: Add querySelector and querySelectorAll declarations.

        * dom/Node.cpp:
        (WebCore::Node::querySelector): Make the CSS parser parse the selector
        according to the strictness of the document so that mixed case ID selectors
        match in quirks mode.  Also, don't use the fast ID path if the root is not
        in the DOM tree, as it won't work.
        (WebCore::Node::querySelectorAll): Ditto.
        * dom/SelectorNodeList.cpp:
        (WebCore::createSelectorNodeList): Don't use the fast ID path if the root is not
        in the DOM tree, as it won't work.

2008-07-10  Anthony Ricaud  <rik24d@gmail.com>

        Bug 19389: querySelectorAll exception while searching invalid CSS selector
        <https://bugs.webkit.org/show_bug.cgi?id=19389>

        Reviewed by Tim Hatcher.

        * page/inspector/inspector.js: Added a try/catch block.

2008-07-10  Brent Fulgham  <bfulgham@gmail.com>

        Correct a build regression due to an uninitialized variable.

        <https://bugs.webkit.org/show_bug.cgi?id=19976>

        Reviewed by Darin.

        * platform/graphics/cairo/FontCairo.cpp:
        (WebCore::Font::drawGlyphs):

2008-07-10  Adam Roben  <aroben@apple.com>

        Fix Bug 19580: REGRESSION (r34432): PGO-only crash in
        HTMLCollection::resetCollectionInfo (codegen issue?)

        <https://bugs.webkit.org/show_bug.cgi?id=19580>
        <rdar://6029794>

        Reviewed by Cameron Zwarich.

        * WebCore.vcproj/WebCore.vcproj: Disable LTCG for HTMLFormElement.cpp,
        which was causing some bad codegen in HTMLFormElement::elements.
        * html/HTMLFormElement.cpp: Touched this file to force it to rebuild.

2008-07-10  Anders Carlsson  <andersca@apple.com>

        Reviewed by Jon.

        <rdar://problem/6067135>
        WebKit should respond true to a query for NPNVSupportsWindowless.
        
        Handle NPNVSupportsWindowless and return true.
        
        * bridge/npapi.h:
        * plugins/win/PluginViewWin.cpp:
        (WebCore::PluginView::getValue):

2008-07-10  Kevin McCullough  <kmccullough@apple.com>

        Reviewed by Darin.

        -Minor cleanup. Renamed callTree() to head() and no longer use m_head
        directly but instead keep it private and access via a method().

        * page/JavaScriptProfile.cpp:
        (WebCore::getHeadCallback):

2008-07-10  Simon Fraser  <simon.fraser@apple.com>

        When a mask image changes, ensure that elements
        that use that mask image are repainted correctly.
        
        <https://bugs.webkit.org/show_bug.cgi?id=19954>
        
        Reviewed by Dave Hyatt

        * manual-tests/canvas-mask-redraw.html
          Manual testcase
        * rendering/RenderBox.cpp:
        (WebCore::RenderBox::imageChanged):
        (WebCore::RenderBox::repaintLayerRectsForImage):
        * rendering/RenderBox.h:
        Loop through background layers and mask layers, and
        if this image is used in a layer, compute a repaint
        rect and repaint.
        * rendering/RenderImage.cpp:
        (WebCore::RenderImage::imageChanged):
        If this image has a mask, call the base class method.
        * rendering/RenderObject.cpp:
        Remove a bogus 'return'.

2008-07-10  Simon Fraser  <simon.fraser@apple.com>

        Transforms create a containing block, so
        RenderLayer::shouldBeOverflowOnly() needs to look for transforms.
        <https://bugs.webkit.org/show_bug.cgi?id=18886>
        
        Reviewed by Dave Hyatt

        Test: fast/transforms/transform-overflow.html

        * rendering/RenderLayer.cpp:
        (WebCore::RenderLayer::shouldBeOverflowOnly):

2008-07-09  Alex Mathews  <possessedpenguinbob@gmail.com>

        Reviewed by Oliver Hunt.

        bug 19835: WebKit needs cross-platform filter system
        <https://bugs.webkit.org/show_bug.cgi?id=19835>

        More class refactoring in preparation for cross-platform filter 
        implementation.

        * WebCore.xcodeproj/project.pbxproj:
        * rendering/SVGRenderTreeAsText.h:
        (WebCore::operator<<):
        * svg/FilterEffect.cpp:
        (WebCore::FilterEffect::externalRepresentation):
        * svg/FilterEffect.h:
        * svg/SVGFEBlendElement.cpp:
        (WebCore::SVGFEBlendElement::build):
        * svg/SVGFEBlendElement.h:
        * svg/SVGFEColorMatrixElement.cpp:
        (WebCore::SVGFEColorMatrixElement::build):
        * svg/SVGFEColorMatrixElement.h:
        * svg/SVGFEComponentTransferElement.cpp:
        (WebCore::SVGFEComponentTransferElement::build):
        * svg/SVGFEComponentTransferElement.h:
        * svg/SVGFECompositeElement.cpp:
        (WebCore::SVGFECompositeElement::build):
        * svg/SVGFECompositeElement.h:
        * svg/SVGFEDiffuseLightingElement.cpp:
        (WebCore::SVGFEDiffuseLightingElement::filterEffect):
        (WebCore::SVGFEDiffuseLightingElement::build):
        (WebCore::SVGFEDiffuseLightingElement::findLights):
        * svg/SVGFEDiffuseLightingElement.h:
        * svg/SVGFEDisplacementMapElement.cpp:
        (WebCore::SVGFEDisplacementMapElement::SVGFEDisplacementMapElement):
        (WebCore::SVGFEDisplacementMapElement::stringToChannel):
        (WebCore::SVGFEDisplacementMapElement::filterEffect):
        (WebCore::SVGFEDisplacementMapElement::build):
        * svg/SVGFEDisplacementMapElement.h:
        * svg/SVGFEFloodElement.cpp:
        (WebCore::SVGFEFloodElement::filterEffect):
        (WebCore::SVGFEFloodElement::build):
        * svg/SVGFEFloodElement.h:
        (WebCore::SVGFEFloodElement::contextElement):
        * svg/SVGFEGaussianBlurElement.cpp:
        (WebCore::SVGFEGaussianBlurElement::filterEffect):
        (WebCore::SVGFEGaussianBlurElement::build):
        * svg/SVGFEGaussianBlurElement.h:
        * svg/SVGFEImageElement.cpp:
        (WebCore::SVGFEImageElement::filterEffect):
        (WebCore::SVGFEImageElement::build):
        * svg/SVGFEImageElement.h:
        * svg/SVGFEMergeElement.cpp:
        (WebCore::SVGFEMergeElement::filterEffect):
        (WebCore::SVGFEMergeElement::build):
        * svg/SVGFEMergeElement.h:
        (WebCore::SVGFEMergeElement::contextElement):
        * svg/SVGFEOffsetElement.cpp:
        (WebCore::SVGFEOffsetElement::filterEffect):
        (WebCore::SVGFEOffsetElement::build):
        * svg/SVGFEOffsetElement.h:
        * svg/SVGFESpecularLightingElement.cpp:
        (WebCore::SVGFESpecularLightingElement::filterEffect):
        (WebCore::SVGFESpecularLightingElement::findLights):
        (WebCore::SVGFESpecularLightingElement::build):
        * svg/SVGFESpecularLightingElement.h:
        * svg/SVGFETileElement.cpp:
        (WebCore::SVGFETileElement::filterEffect):
        (WebCore::SVGFETileElement::build):
        * svg/SVGFETileElement.h:
        * svg/SVGFETurbulenceElement.cpp:
        (WebCore::SVGFETurbulenceElement::SVGFETurbulenceElement):
        (WebCore::SVGFETurbulenceElement::parseMappedAttribute):
        (WebCore::SVGFETurbulenceElement::filterEffect):
        (WebCore::SVGFETurbulenceElement::build):
        * svg/SVGFETurbulenceElement.h:
        * svg/SVGFilterPrimitiveStandardAttributes.h:
        * svg/graphics/filters/SVGFEConvolveMatrix.cpp:
        (WebCore::FEConvolveMatrix::FEConvolveMatrix):
        (WebCore::FEConvolveMatrix::create):
        (WebCore::FEConvolveMatrix::kernelSize):
        (WebCore::FEConvolveMatrix::setKernelSize):
        (WebCore::FEConvolveMatrix::kernel):
        (WebCore::FEConvolveMatrix::setKernel):
        (WebCore::FEConvolveMatrix::divisor):
        (WebCore::FEConvolveMatrix::setDivisor):
        (WebCore::FEConvolveMatrix::bias):
        (WebCore::FEConvolveMatrix::setBias):
        (WebCore::FEConvolveMatrix::targetOffset):
        (WebCore::FEConvolveMatrix::setTargetOffset):
        (WebCore::FEConvolveMatrix::edgeMode):
        (WebCore::FEConvolveMatrix::setEdgeMode):
        (WebCore::FEConvolveMatrix::kernelUnitLength):
        (WebCore::FEConvolveMatrix::setKernelUnitLength):
        (WebCore::FEConvolveMatrix::preserveAlpha):
        (WebCore::FEConvolveMatrix::setPreserveAlpha):
        (WebCore::FEConvolveMatrix::apply):
        (WebCore::FEConvolveMatrix::dump):
        (WebCore::operator<<):
        (WebCore::FEConvolveMatrix::externalRepresentation):
        * svg/graphics/filters/SVGFEConvolveMatrix.h:
        (WebCore::):
        * svg/graphics/filters/SVGFEDiffuseLighting.cpp:
        (WebCore::FEDiffuseLighting::FEDiffuseLighting):
        (WebCore::FEDiffuseLighting::create):
        (WebCore::FEDiffuseLighting::~FEDiffuseLighting):
        (WebCore::FEDiffuseLighting::lightingColor):
        (WebCore::FEDiffuseLighting::setLightingColor):
        (WebCore::FEDiffuseLighting::surfaceScale):
        (WebCore::FEDiffuseLighting::setSurfaceScale):
        (WebCore::FEDiffuseLighting::diffuseConstant):
        (WebCore::FEDiffuseLighting::setDiffuseConstant):
        (WebCore::FEDiffuseLighting::kernelUnitLengthX):
        (WebCore::FEDiffuseLighting::setKernelUnitLengthX):
        (WebCore::FEDiffuseLighting::kernelUnitLengthY):
        (WebCore::FEDiffuseLighting::setKernelUnitLengthY):
        (WebCore::FEDiffuseLighting::lightSource):
        (WebCore::FEDiffuseLighting::setLightSource):
        (WebCore::FEDiffuseLighting::apply):
        (WebCore::FEDiffuseLighting::dump):
        (WebCore::FEDiffuseLighting::externalRepresentation):
        * svg/graphics/filters/SVGFEDiffuseLighting.h:
        * svg/graphics/filters/SVGFEDisplacementMap.cpp:
        (WebCore::FEDisplacementMap::FEDisplacementMap):
        (WebCore::FEDisplacementMap::create):
        (WebCore::FEDisplacementMap::xChannelSelector):
        (WebCore::FEDisplacementMap::setXChannelSelector):
        (WebCore::FEDisplacementMap::yChannelSelector):
        (WebCore::FEDisplacementMap::setYChannelSelector):
        (WebCore::FEDisplacementMap::scale):
        (WebCore::FEDisplacementMap::setScale):
        (WebCore::FEDisplacementMap::apply):
        (WebCore::FEDisplacementMap::dump):
        (WebCore::operator<<):
        (WebCore::FEDisplacementMap::externalRepresentation):
        * svg/graphics/filters/SVGFEDisplacementMap.h:
        (WebCore::):
        * svg/graphics/filters/SVGFEFlood.cpp:
        (WebCore::FEFlood::FEFlood):
        (WebCore::FEFlood::create):
        (WebCore::FEFlood::floodColor):
        (WebCore::FEFlood::setFloodColor):
        (WebCore::FEFlood::floodOpacity):
        (WebCore::FEFlood::setFloodOpacity):
        (WebCore::FEFlood::apply):
        (WebCore::FEFlood::dump):
        (WebCore::FEFlood::externalRepresentation):
        * svg/graphics/filters/SVGFEFlood.h:
        * svg/graphics/filters/SVGFEGaussianBlur.cpp:
        (WebCore::FEGaussianBlur::FEGaussianBlur):
        (WebCore::FEGaussianBlur::create):
        (WebCore::FEGaussianBlur::stdDeviationX):
        (WebCore::FEGaussianBlur::setStdDeviationX):
        (WebCore::FEGaussianBlur::stdDeviationY):
        (WebCore::FEGaussianBlur::setStdDeviationY):
        (WebCore::FEGaussianBlur::apply):
        (WebCore::FEGaussianBlur::dump):
        (WebCore::FEGaussianBlur::externalRepresentation):
        * svg/graphics/filters/SVGFEGaussianBlur.h:
        * svg/graphics/filters/SVGFEImage.cpp:
        (WebCore::FEImage::FEImage):
        (WebCore::FEImage::create):
        (WebCore::FEImage::~FEImage):
        (WebCore::FEImage::cachedImage):
        (WebCore::FEImage::apply):
        (WebCore::FEImage::dump):
        (WebCore::FEImage::externalRepresentation):
        * svg/graphics/filters/SVGFEImage.h:
        * svg/graphics/filters/SVGFEMerge.cpp:
        (WebCore::FEMerge::FEMerge):
        (WebCore::FEMerge::create):
        (WebCore::FEMerge::mergeInputs):
        (WebCore::FEMerge::setMergeInputs):
        (WebCore::FEMerge::apply):
        (WebCore::FEMerge::dump):
        (WebCore::FEMerge::externalRepresentation):
        * svg/graphics/filters/SVGFEMerge.h:
        * svg/graphics/filters/SVGFEMorphology.cpp:
        (WebCore::FEMorphology::FEMorphology):
        (WebCore::FEMorphology::create):
        (WebCore::FEMorphology::morphologyOperator):
        (WebCore::FEMorphology::setMorphologyOperator):
        (WebCore::FEMorphology::radiusX):
        (WebCore::FEMorphology::setRadiusX):
        (WebCore::FEMorphology::radiusY):
        (WebCore::FEMorphology::setRadiusY):
        (WebCore::FEMorphology::apply):
        (WebCore::FEMorphology::dump):
        (WebCore::operator<<):
        (WebCore::FEMorphology::externalRepresentation):
        * svg/graphics/filters/SVGFEMorphology.h:
        (WebCore::):
        * svg/graphics/filters/SVGFEOffset.cpp:
        (WebCore::FEOffset::FEOffset):
        (WebCore::FEOffset::create):
        (WebCore::FEOffset::dx):
        (WebCore::FEOffset::setDx):
        (WebCore::FEOffset::dy):
        (WebCore::FEOffset::setDy):
        (WebCore::FEOffset::apply):
        (WebCore::FEOffset::dump):
        (WebCore::FEOffset::externalRepresentation):
        * svg/graphics/filters/SVGFEOffset.h:
        * svg/graphics/filters/SVGFESpecularLighting.cpp:
        (WebCore::FESpecularLighting::FESpecularLighting):
        (WebCore::FESpecularLighting::create):
        (WebCore::FESpecularLighting::~FESpecularLighting):
        (WebCore::FESpecularLighting::lightingColor):
        (WebCore::FESpecularLighting::setLightingColor):
        (WebCore::FESpecularLighting::surfaceScale):
        (WebCore::FESpecularLighting::setSurfaceScale):
        (WebCore::FESpecularLighting::specularConstant):
        (WebCore::FESpecularLighting::setSpecularConstant):
        (WebCore::FESpecularLighting::specularExponent):
        (WebCore::FESpecularLighting::setSpecularExponent):
        (WebCore::FESpecularLighting::kernelUnitLengthX):
        (WebCore::FESpecularLighting::setKernelUnitLengthX):
        (WebCore::FESpecularLighting::kernelUnitLengthY):
        (WebCore::FESpecularLighting::setKernelUnitLengthY):
        (WebCore::FESpecularLighting::lightSource):
        (WebCore::FESpecularLighting::setLightSource):
        (WebCore::FESpecularLighting::apply):
        (WebCore::FESpecularLighting::dump):
        (WebCore::FESpecularLighting::externalRepresentation):
        * svg/graphics/filters/SVGFESpecularLighting.h:
        * svg/graphics/filters/SVGFETile.cpp:
        (WebCore::FETile::FETile):
        (WebCore::FETile::create):
        (WebCore::FETile::apply):
        (WebCore::FETile::dump):
        (WebCore::FETile::externalRepresentation):
        * svg/graphics/filters/SVGFETile.h:
        * svg/graphics/filters/SVGFETurbulence.cpp:
        (WebCore::FETurbulence::FETurbulence):
        (WebCore::FETurbulence::create):
        (WebCore::FETurbulence::type):
        (WebCore::FETurbulence::setType):
        (WebCore::FETurbulence::baseFrequencyY):
        (WebCore::FETurbulence::setBaseFrequencyY):
        (WebCore::FETurbulence::baseFrequencyX):
        (WebCore::FETurbulence::setBaseFrequencyX):
        (WebCore::FETurbulence::seed):
        (WebCore::FETurbulence::setSeed):
        (WebCore::FETurbulence::numOctaves):
        (WebCore::FETurbulence::setNumOctaves):
        (WebCore::FETurbulence::stitchTiles):
        (WebCore::FETurbulence::setStitchTiles):
        (WebCore::FETurbulence::apply):
        (WebCore::FETurbulence::dump):
        (WebCore::operator<<):
        (WebCore::FETurbulence::externalRepresentation):
        * svg/graphics/filters/SVGFETurbulence.h:
        (WebCore::):
        * svg/graphics/filters/cg/SVGFEDiffuseLightingCg.mm:
        * svg/graphics/filters/cg/SVGFEDisplacementMapCg.mm:
        * svg/graphics/filters/cg/SVGFEFloodCg.mm:
        * svg/graphics/filters/cg/SVGFEGaussianBlurCg.mm:
        * svg/graphics/filters/cg/SVGFEHelpersCg.h:
        * svg/graphics/filters/cg/SVGFEHelpersCg.mm:
        (WebCore::getVectorForChannel):
        * svg/graphics/filters/cg/SVGFEImageCg.mm:
        * svg/graphics/filters/cg/SVGFEMergeCg.mm:
        * svg/graphics/filters/cg/SVGFEOffsetCg.mm:
        * svg/graphics/filters/cg/SVGFESpecularLightingCg.mm:
        * svg/graphics/filters/cg/SVGFETileCg.mm:

2008-07-09  Mark Rowe  <mrowe@apple.com>

        Reviewed by Geoff Garen.

        Don't warn about deprecated functions in production builds.

        * Configurations/Base.xcconfig:
        * Configurations/DebugRelease.xcconfig:

2008-07-09  Brady Eidson  <beidson@apple.com>

        Reviewed by Darin

        <rdar://problem/5823684> - Crash manipulating frame tree of a new frame before the new frame
        has been installed in a frame tree.

        The root of this problem was that calling init() on a new frame could end up calling arbitrary
        javascript that might end up removing the frame from the tree.  This opened up a small can of worms
        such as the frame not having yet been installed in its frame tree, and other assumed behavior while
        destroying the frame.

        Test: fast/loader/frame-creation-removal.html

        * loader/FrameLoader.cpp:
        (WebCore::FrameLoader::endIfNotLoadingMainResource):  If the frame doesn't have a page, don't close up
          the document and parser because they don't exist, and this frame is on its way out.
        (WebCore::FrameLoader::finishedParsing):  We can't rely on the refCount check to discover "am I being deleted?"
          because we no longer store refCounts of 0.  The new check is "do I have a FrameView?" while will always be
          false if the Frame is being destroyed.

2008-07-09  Dean Jackson  <dino@apple.com>

        Changed to use the correct license in header comment (via Darin)

        * css/WebKitCSSTransformValue.idl:

2008-07-09  Dean Jackson  <dino@apple.com>

        Add DOM interface for WebKitCSSTransformValue.
        https://bugs.webkit.org/show_bug.cgi?id=19863

        Reviewed by Hyatt.

        * bindings/objc/DOMInternal.h:
        * css/WebKitCSSTransformValue.idl: Added.

        * bindings/scripts/CodeGeneratorObjC.pm:
            make sure new class inherits from CSSValue not Node

        * DerivedSources.make:
        * GNUmakefile.am:
        * WebCore.pro:
        * WebCore.vcproj/WebCore.vcproj:
        * WebCore.xcodeproj/project.pbxproj:
        * WebCoreSources.bkl:
            Adding new generated files

2008-07-09  Maxime Britto  <britto@apple.com>

        Reviewed by Adele.

        http://bugs.webkit.org/show_bug.cgi?id=14227
        Add the middle click panning feature to the windows release.
        Details on almost each method below.
        Manual test is included in the patch.

        * ChangeLog:
        * WebCore.vcproj/WebCore.vcproj:
        * manual-tests/panScroll.html: Added.
        * manual-tests/resources/big-page.html: Added.
        * page/EventHandler.cpp: Added the panScroll start/stop handlers and adapted the autoscroll for both to share some functions.
        (WebCore::EventHandler::EventHandler): Initialize the new class members for the panScroll
        (WebCore::EventHandler::handleMouseDraggedEvent): Prevent the autoscroll to trigger if the panScroll is in progress
        (WebCore::EventHandler::handleMouseReleaseEvent): Prevent the autoscroll to stop the panScroll on mouse release
        (WebCore::EventHandler::handleAutoscroll): Added the specific calls for the panScroll (save mouse position, draw the panScroll icon) to the shared code
        (WebCore::EventHandler::autoscrollTimerFired): Specify the calls to perform for each function (autoscroll and panScroll)
        (WebCore::EventHandler::stopAutoscrollTimer): Specify the calls to perform for each function (autoscroll and panScroll)
        (WebCore::EventHandler::handleMousePressEvent): Trigger for the panScroll. Test is the button is the middle button and try to find a renderer where the panScroll is possible. If it finds one, it calls the handleAutoscroll method.
        * page/EventHandler.h:
        (WebCore::EventHandler::panScrollInProgress): Getter used by the sub frames's EventHandler to notice the main frame EventHandler
        (WebCore::EventHandler::setPanScrollInProgress): Setter used by the sub frames's EventHandler to notice the main frame EventHandler
        * platform/ScrollView.h: Added a method used by the RenderObject to test if the view can be scrolled. Added the print/remove panScroll icon methods between the windows platform flags
        * platform/gtk/ScrollViewGtk.cpp:
        (WebCore::ScrollView::isScrollable): Not implemented : returns true
        * platform/mac/ScrollViewMac.mm: Implemented because it was useful for the autoscroll feature.
        (WebCore::ScrollView::isScrollable):
        * platform/qt/ScrollViewQt.cpp:
        (WebCore::ScrollView::isScrollable): Not implemented : returns true
        * platform/win/ScrollViewWin.cpp:
        (WebCore::ScrollView::ScrollViewPrivate::ScrollViewPrivate): Added a boolean and an IntPoint to draw the icon.
        (WebCore::ScrollView::ScrollViewPrivate::scrollBackingStore): If the icon must be drawn, define the rect to invalidate to erase the previous icon and to display the new one.
        (WebCore::ScrollView::updateContents): I split this method to be able to invalidate a rect with window coordinates instead of contents coordinates. This function now converts the contents coord in window coord and calls the new updateWindowRect() method  
        (WebCore::ScrollView::updateWindowRect): New method which performs the work that was doing the end of the old updateContents : invalidate a rect with window coordinates
        (WebCore::ScrollView::isScrollable): checks is the view has scrollbars
        (WebCore::ScrollView::printPanScrollIcon): sets the boolean and the IntPoint for the icon. Invalidate his rect and ask for repaint.
        (WebCore::ScrollView::removePanScrollIcon): sets the boolean to false. Invalidate his rect and ask for repaint.
        (WebCore::ScrollView::paint): Modified to draw the icon if needed.
        * platform/wx/ScrollViewWx.cpp:
        (WebCore::ScrollView::isScrollable): Not implemented : returns true
        * rendering/RenderLayer.cpp:
        (WebCore::RenderLayer::panScrollFromPoint): Receives the Middle click location and retrieves the currentMouse position from the EventHandler. With these informations it computes the direction to scroll to and the speed then calls for the final scroll.
        * rendering/RenderLayer.h:
        * rendering/RenderListBox.cpp: Adapt the panScroll to the ListBox object to scroll by lines instead of pixels
        (WebCore::RenderListBox::panScroll):
        (WebCore::RenderListBox::scrollToward):
        (WebCore::RenderListBox::autoscroll):
        * rendering/RenderListBox.h:
        (WebCore::RenderListBox::shouldPanScroll):
        * rendering/RenderObject.cpp: 
        (WebCore::RenderObject::shouldAutoscroll): Improved the verification to avoid triggering the autoscroll/panScroll when the root object can't scroll
        (WebCore::RenderObject::panScroll): Calls the RenderLayer's panScrollFromPoint() method
        * rendering/RenderObject.h:
        (WebCore::RenderObject::stopPanScroll): 

2008-07-09  Dean Jackson  <dino@apple.com>

        Rename CSSTransformValue to WebKitCSSTransformValue as it is non-standard for
        the moment. Also, WebKitCSSTransformValue is a CSSValueList (comma sep)
        https://bugs.webkit.org/show_bug.cgi?id=19861

        Reviewed by Hyatt

        * css/CSSParser.cpp:
        * css/CSSStyleSelector.cpp:
        * css/CSSTransformValue.cpp: Removed.
        * css/CSSTransformValue.h: Removed.
        * css/CSSValueList.h:
        * css/WebKitCSSTransformValue.cpp: Added.
        * css/WebKitCSSTransformValue.h: Added.

        * GNUmakefile.am:
        * WebCore.order:
        * WebCore.pro:
        * WebCore.vcproj/WebCore.vcproj:
        * WebCore.xcodeproj/project.pbxproj:
        * WebCoreSources.bkl:
            updated for new file names
        

2008-07-09  David Hyatt  <hyatt@apple.com>

        Switch transitions back to a "destination" model as far as choosing which transitions should apply on a style
        change.  Preserve the behavior of allowing stale transitions (in the absence of property changes) to run to
        completion.

        Reviewed by Dean

        * manual-tests/transitions.html:
        * manual-tests/transitions2.html:
        * page/AnimationController.cpp:
        (WebCore::ImplicitAnimation::reset):
        (WebCore::CompositeImplicitAnimation::animate):
        (WebCore::AnimationControllerPrivate::get):
        (WebCore::AnimationController::updateImplicitAnimations):

2008-07-09  Michelangelo De Simone  <m.des@mac.com>

        Reviewed by Adele.

        Added the virtual function Node::isTextControl() in order to simplify text field and textarea checks.

        * css/CSSStyleSelector.cpp: (WebCore::CSSStyleSelector::SelectorChecker::checkOneSelector):
        Clean up in PseudoReadOnly and PseudoReadWrite cases removing unnecessary checks and casts in favor of the sole isTextControl() check.
        * dom/Node.h: Added base isTextControl().
        * html/HTMLInputElement.h: Added isTextControl() which wraps HTMLInputElement::isTextField().
        * html/HTMLTextAreaElement.h: Added isTextControl().

2008-07-09  Rob Buis  <buis@kde.org>

        Reviewed by Eric.

        https://bugs.webkit.org/show_bug.cgi?id=15431
        SVGRenderStyle should store pre-modified resource URIs

        Store pre-modified resource URIs to decrease string
        operations during layout/rendering.

        * css/SVGCSSStyleSelector.cpp:
        (WebCore::CSSStyleSelector::applySVGProperty):
        * rendering/RenderPath.cpp:
        (WebCore::RenderPath::absoluteClippedOverflowRect):
        (WebCore::RenderPath::drawMarkersIfNeeded):
        * rendering/RenderSVGContainer.cpp:
        (WebCore::RenderSVGContainer::selfWillPaint):
        (WebCore::RenderSVGContainer::absoluteClippedOverflowRect):
        * rendering/RenderSVGImage.cpp:
        (WebCore::RenderSVGImage::calculateAbsoluteBounds):
        * rendering/RenderSVGRoot.cpp:
        (WebCore::RenderSVGRoot::paint):
        (WebCore::RenderSVGRoot::absoluteClippedOverflowRect):
        * rendering/RenderSVGText.cpp:
        (WebCore::RenderSVGText::absoluteClippedOverflowRect):
        * rendering/SVGRenderSupport.cpp:
        (WebCore::prepareToRenderSVGContent):

2008-07-09  Anders Carlsson  <andersca@apple.com>

        Reviewed by Mitz.

        Remove an unused instance variable.

        * loader/DocumentLoader.h:

2008-07-09  Dan Bernstein  <mitz@apple.com>

        Reviewed by Anders Carlsson.

        - remove unused #includes

        * dom/XMLTokenizer.cpp:
        * html/PreloadScanner.cpp:
        * loader/CachedCSSStyleSheet.cpp:
        * loader/CachedScript.cpp:
        * loader/CachedXBLDocument.cpp:
        * loader/CachedXSLStyleSheet.cpp:
        * page/mac/FrameMac.mm:
        * xml/XSLTProcessor.cpp:

2008-07-08  Geoffrey Garen  <ggaren@apple.com>

        Reviewed by Oliver Hunt.
        
        Only artificially mark JS DOM wrappers if they have custom properties.
        
        21X speedup on http://nerget.com/jstests/dom-mandelbrot.html.
        
        No, that is not a typo.

        * bindings/js/JSDOMBinding.cpp:
        (WebCore::ScriptInterpreter::markDOMNodesForDocument):

2008-07-08  Kevin Watters  <kevinwatters@gmail.com>

        Reviewed by Kevin Ollivier.

        Fix to previous patch for handling mouse up events.
        
        https://bugs.webkit.org/show_bug.cgi?id=18464

        * platform/wx/MouseEventWx.cpp:
        (WebCore::PlatformMouseEvent::PlatformMouseEvent):

2008-07-08  Dan Bernstein  <mitz@apple.com>

        Reviewed by Brady Eidson.

        - initialize the Archives log channel's state

        * platform/mac/LoggingMac.mm:
        (WebCore::InitializeLoggingChannelsIfNecessary):

2008-07-08  Kevin McCullough  <kmccullough@apple.com>

        Added manual test for the new heavy view.

        * manual-tests/inspector/profiler-test-heavy-view.html: Added.

2008-07-08  Darin Adler  <darin@apple.com>

        Reviewed by Mitz.

        - fix <rdar://problem/6043731> REGRESSION (3-4): RedEnvelope.com
          looks wrong due to OpenCube QuickMenu appVersion check

        * page/Navigator.cpp:
        (WebCore::shouldHideFourDot): Add dqm_loader.js as another filename.

2008-07-08  Dan Bernstein  <mitz@apple.com>

        Reviewed by John Sullivan.

        - WebCore part of <rdar://problem/6008409> Need a way to disable updates in offscreen views

        Added a setting, updatesWhenOffscreen(), which controls whether an
        offscreen web view gets marked as needing update when its contents
        change (the existing behavior) or not (a new behavior), in which case it
        will be marked as needing update just before it goes on screen. The
        existing behavior (updating while offscreen) remains the default.

        * WebCore.base.exp: Added Settings::setUpdatesWhenOffscreen().
        * page/FrameView.cpp:
        (WebCore::FrameView::shouldUpdateWhenOffscreen): Added. Returns the
        value from settings.
        * page/FrameView.h:
        * page/Settings.cpp:
        (WebCore::Settings::setUpdatesWhenOffscreen): Added.
        * page/Settings.h:
        (WebCore::Settings::updatesWhenOffscreen): Added.
        * platform/ScrollView.h:
        * platform/mac/ScrollViewMac.mm:
        (WebCore::ScrollView::updateContents): Added code to return early and
        not call -setNeedsDisplayInRect: if the view is not in a visible window
        and the setting is not to update when offscreen.

2008-07-08  Simon Hausmann  <hausmann@webkit.org>

        Fix the build with enabled SVG filters.

        * svg/SVGFESpecularLightingElement.cpp: The last argument to
        ANIMATED_PROPERTY_DEFINITIONS has to be full class name, including
        the attr suffix.

2008-07-07  Sam Weinig  <sam@webkit.org>

        Reviewed by Anders Carlsson.

        Remove extraneous null check.

        * dom/Node.cpp:
        (WebCore::Node::querySelector):
        (WebCore::Node::querySelectorAll):

2008-07-07  Sam Weinig  <sam@webkit.org>

        Reviewed by Anders Carlsson.

        Fix for https://bugs.webkit.org/show_bug.cgi?id=19928
        Use of CSS3 Namespaces syntax in Selectors API should throw an exception

        - Throw an NAMESPACE_ERR exception if a non-null or "*" namespace is
          used in a selector passed to querySelector or querySelectorAll.

        Test: fast/dom/SelectorAPI/not-supported-namespace-in-selector.html

        * dom/Node.cpp:
        (WebCore::selectorNeedsNamespaceResolution):
        (WebCore::Node::querySelector):
        (WebCore::Node::querySelectorAll):

2008-07-07  Simon Fraser  <simon.fraser@apple.com>

        Reviewed by Darin.

        Fix for https://bugs.webkit.org/show_bug.cgi?id=19933
        nodeIterator with filter fails on documents not in a frame

        Tests: traversal/node-iterator-009.html
               traversal/tree-walker-006.html

        * bindings/js/JSNodeFilterCondition.cpp:
        * bindings/js/JSNodeFilterCondition.h:
        * bindings/js/JSNodeFilterCustom.cpp:
        * bindings/js/JSNodeIteratorCustom.cpp:
        * bindings/js/JSTreeWalkerCustom.cpp:
        * bindings/objc/DOM.mm:
        * dom/NodeFilter.cpp:
        * dom/NodeFilter.h:
        * dom/NodeFilterCondition.cpp:
        * dom/NodeFilterCondition.h:
        * dom/NodeIterator.cpp:
        * dom/NodeIterator.h:
        * dom/Traversal.cpp:
        * dom/Traversal.h:
        * dom/TreeWalker.cpp:
        * dom/TreeWalker.h:

2008-07-07  Adele Peterson  <adele@apple.com>

        Reviewed by Dan Bernstein.

        Fix for https://bugs.webkit.org/show_bug.cgi?id=19924
        <rdar://problem/6057160> Disabled file input element updates its displayed file info when a file is dropped from the Finder.

        * page/DragController.cpp: (WebCore::DragController::concludeDrag):
        Check that the file control is enabled before taking dropped files.

2008-07-07  Adele Peterson  <adele@apple.com>

        Reviewed by Beth.

        Fix for <rdar://problem/5860507> <AUDIO> playback noticeably more quiet than QuickTime

        Change default volume setting to 1.0.

        * html/HTMLMediaElement.cpp: (WebCore::HTMLMediaElement::HTMLMediaElement):
        * platform/graphics/MediaPlayer.cpp: (WebCore::MediaPlayer::MediaPlayer):

2008-07-07  Darin Adler  <darin@apple.com>

        Reviewed by Mark Rowe.

        - fix <rdar://problem/6020441> REGRESSION: Layers on NWA.com render ugly

        The old version of the OpenCube QuickMenu library used on this site still has code
        that detects Netscape 4 by checking appVersion to see if it has the substring "4."
        in it. We decided to special-case the filename of the script and tweak the appVersion
        for files with that name.

        * bindings/js/ScriptController.cpp:
        (WebCore::ScriptController::ScriptController): Replace m_processingInlineCode with
        m_sourceURL. Use false instead of 0 to initialize a boolean.
        (WebCore::ScriptController::evaluate): Call argument sourceURL, not filename.
        Store current sourceURL in m_sourceURL. This fixes a mistake in the code that
        maintained the value of m_processingInlineCode, since the old code set it to
        false rather than restoring it. Renamed a local variable named sourceURL to
        exceptionSourceURL for clarity.
        (WebCore::ScriptController::processingUserGesture): Code that formerly used
        m_processingInlineCode to detect that it was evaluating code with no URL now
        uses m_sourceURL to do the same check.

        * bindings/js/ScriptController.h: Renamed filename argument to sourceURL; it has always
        been a URL, not a file path. Added a public sourceURL function and m_sourceURL and
        removed m_processingInlineCode.

        * page/Navigator.cpp:
        (WebCore::shouldHideFourDot): Added. Returns true if the currently running script has
        a source URL ending in "/dqm_script.js" and if the settings say we should do
        site-specific quirks (really JavaScript-library-specific in this case).
        (WebCore::Navigator::appVersion): Replace "4." with "4_" if shouldHideFourDot is true.

2008-07-07  Cameron Zwarich  <cwzwarich@uwaterloo.ca>

        Reviewed by Geoff.

        Bug 19907: REGRESSION(r34824-r34941): Reproducible crash trying to log in to MediaTemple.net Account Center
        <https://bugs.webkit.org/show_bug.cgi?id=19907>

        Clear exceptions set on ExecStates before returning from NPAPI
        callbacks, in order to avoid causing problems for the next script that
        executes.

        While fixing this bug, the question was raised of whether we are
        correctly propagating exception information back to the caller:

        Bug 19936: Correctly propagate exception information from NPAPI callbacks
        <https://bugs.webkit.org/show_bug.cgi?id=19936>

        * bridge/NP_jsobject.cpp:
        (_NPN_InvokeDefault):
        (_NPN_Invoke):
        (_NPN_Evaluate):
        (_NPN_GetProperty):
        (_NPN_SetProperty):
        (_NPN_RemoveProperty):
        (_NPN_HasProperty):
        (_NPN_HasMethod):
        (_NPN_Enumerate):

2008-07-07  Dan Bernstein  <mitz@apple.com>

        Reviewed by Darin Adler.

        - fix <rdar://problem/6057650> REGRESSION (r35025): Crash beneath FontCache::invalidate() when activating Safari with no windows open

        * css/CSSFontFaceSource.cpp:
        (WebCore::CSSFontFaceSource::getFontData): Added a null check because
        docLoader() can return 0 now.
        * css/CSSFontSelector.cpp:
        (WebCore::CSSFontSelector::docLoader): Added a null check of m_document.
        (WebCore::CSSFontSelector::addFontFaceRule): Ditto.
        (WebCore::CSSFontSelector::fontLoaded): Ditto.
        (WebCore::CSSFontSelector::fontCacheInvalidated): Ditto.
        (WebCore::fontDataForGenericFamily): Added a null check of document.
        * css/CSSFontSelector.h:
        (WebCore::CSSFontSelector::clearDocument): Added.
        * css/CSSStyleSelector.cpp:
        (WebCore::CSSStyleSelector::~CSSStyleSelector): Added a call to
        CSSFontSelector::clearDocument(). When the style selector is destroyed,
        there is no guarantee that the document will continue to exist.

2008-07-07  Julien Chaffraix  <jchaffraix@webkit.org>

        Not reviewed.

        No svg build fix.

        * DerivedSources.make: Add JSSVGElementWrapperFactory.cpp target.
        * svg/animation/SMILTimeContainer.cpp: Add ENABLE(SVG) guard.

2008-07-07  Michelangelo De Simone  <m.des@mac.com>

        Reviewed by Adele.

        Support for CSS3 :read-only and :read-write pseudoclasses for readonly text controls.

        URL: http://www.w3.org/TR/web-forms-2/#relation

        Tests: fast/css/readonly-pseudoclass-opera-001.html
               fast/css/readonly-pseudoclass-opera-002.html
               fast/css/readonly-pseudoclass-opera-003.html
               fast/css/readonly-pseudoclass-opera-004.html
               fast/css/readonly-pseudoclass-opera-005.html

        * css/CSSSelector.cpp: (WebCore::CSSSelector::extractPseudoType):
        Added "read-only" and "read-write" values for PseudoType extraction.
        * css/CSSSelector.h: (WebCore::CSSSelector::):
        Added PseudoReadOnly and PseudoReadWrite entries in PseudoType enum.
        * css/CSSStyleSelector.cpp: (WebCore::CSSStyleSelector::SelectorChecker::checkOneSelector):
        Checks to determine whether to match :read-only and :read-write pseudoclasses on
        text controls.

2008-07-07  Sam Weinig  <sam@webkit.org>

        Reviewed by Geoffrey Garen.

        Fix for https://bugs.webkit.org/show_bug.cgi?id=19928
        querySelectorAll should throw an exception if a NSResolver is passed in.

        - Throw an NOT_SUPPORTED_ERR if a non-null or undefined parameter is passed
          as the second argument to querySelector or querySelectorAll.

        Test: fast/dom/SelectorAPI/not-supported-NSResolver.html

        * bindings/js/JSDocumentCustom.cpp:
        (WebCore::JSDocument::querySelector):
        (WebCore::JSDocument::querySelectorAll):
        * bindings/js/JSElementCustom.cpp:
        (WebCore::JSElement::querySelector):
        (WebCore::JSElement::querySelectorAll):
        * dom/Document.idl:
        * dom/Element.idl:

2008-07-07  Brady Eidson  <beidson@apple.com>

        Reviewed by Mitz and Geoff

        Test: fast/loader/empty-ref-versus-no-ref.html

        Fix for https://bugs.webkit.org/show_bug.cgi?id=18951 and <rdar://problem/5921760>
        "all DOM operations stop working when location.hash set to '#'"

        The underlying problem is that KURL didn't really know the difference between "empty ref"
        and "no ref at all" when changing the ref.  So changing to the empty ref in JS ended up 
        affecting removal of the ref, which ended up causing an infinite load load, also killing
        javascript.

        * platform/KURL.cpp:
        (WebCore::KURL::setRef):  Changed "isEmpty()" to "isNull()", since NULL has the special 
          meaning of "no ref at all" while empty means "empty ref"

2008-07-07  Kevin McCullough  <kmccullough@apple.com>

        Reviewed by Darin.

        Because profiler.h no longer #includes profile.h we need to explicitly
        include it in console.cpp.

        * page/Console.cpp:

2008-07-07  Nikolas Zimmermann  <zimmermann@kde.org>

        Not reviewed. Build fix.

        Fix --svg-filters build (affects Qt build, mac/win don't have it on by default)

        * svg/SVGFEColorMatrixElement.cpp:
        * svg/SVGFEDiffuseLightingElement.cpp:
        * svg/SVGFEImageElement.cpp:
        * svg/SVGFELightElement.cpp:
        * svg/SVGFESpecularLightingElement.cpp:

2008-07-07  Nikolas Zimmermann  <zimmermann@kde.org>

        Reviewed by Antti.

        Fixes: http://bugs.webkit.org/show_bug.cgi?id=17779 (SVG 1.1 Errata demands "SVG JavaScript Liveness" support)

        Revised version of the patch, not using pointer-to-member function callbacks anymore - after discussion with Adam Roben.
        Remove unneccessary parameters of all macros.

        SVG Errata states: "All SVG DOM objects that directly correspond to an
        attribute, e.g. the SVGAnimatedLength 'ry' in an SVGRectElement, are live. This
        means that any changes made to the attribute are immediately reflected in the
        corresponding SVG DOM object." (see linked URL on bug report)

        Until now only XML -> SVG DOM changes took affect, aka. changing the 'rx' attribute of a <rect>
        element resuted in changes when accessing 'rx' through SVG DOM (rx.baseVal.value).

        Add a new synchronization layer to handle SVG DOM -> XML changes.

        Added test: svg/custom/svg-xml-dom-sync.html
        Fixed test: svg/hixie/dynamic/005-broken.xml (renamed to 005.xml)

        * dom/Element.cpp:
        (WebCore::Element::Element): Initialize the two new bits.
        (WebCore::Element::attributes): Add hooks to call into SVG attribute synchronization code, wrapped in ENABLE(SVG) blocks.
        (WebCore::Element::getAttribute): Ditto.
        (WebCore::Element::hasAttributes): Ditto.
        * dom/Element.h: Add two bits: m_areSVGAttributesValid/m_synchronizingSVGAttributes, to track synchronization status.
        (WebCore::Element::updateAnimatedSVGAttribute): New virtual function, handling the synronication, similar to updateStyleAttribute.
        * dom/NamedAttrMap.h: Make addAttribute/removeAttribute protected, from use within the ANIMATED_* macros.
        * svg/SVGAElement.cpp:
        * svg/SVGAElement.h:
        * svg/SVGAnimatedTemplate.h:
        (WebCore::lookupOrCreateWrapper): Take new AnimatedPropertySynchronizer callback as parameter, and associate it with the wrappers.
        * svg/SVGCircleElement.cpp:
        (WebCore::SVGCircleElement::SVGCircleElement):
        * svg/SVGCircleElement.h:
        * svg/SVGClipPathElement.cpp:
        * svg/SVGClipPathElement.h:
        * svg/SVGComponentTransferFunctionElement.cpp:
        * svg/SVGComponentTransferFunctionElement.h:
        * svg/SVGCursorElement.cpp:
        (WebCore::SVGCursorElement::SVGCursorElement):
        * svg/SVGCursorElement.h:
        * svg/SVGElement.cpp:
        (WebCore::SVGElement::updateAnimatedSVGAttribute): Override virtual function from Element, to handle SVG<->XML DOM synchronization.
        (WebCore::SVGElement::setSynchronizedSVGAttributes):
        * svg/SVGElement.h:
        (WebCore::SVGElement::invokeSVGPropertySynchronizer):
        (WebCore::SVGElement::invokeAllSVGPropertySynchronizers):
        (WebCore::SVGElement::addSVGPropertySynchronizer):
        * svg/SVGEllipseElement.cpp:
        * svg/SVGEllipseElement.h:
        * svg/SVGExternalResourcesRequired.cpp:
        * svg/SVGExternalResourcesRequired.h:
        * svg/SVGFEBlendElement.cpp:
        * svg/SVGFEBlendElement.h:
        * svg/SVGFEColorMatrixElement.cpp:
        * svg/SVGFEColorMatrixElement.h:
        * svg/SVGFEComponentTransferElement.cpp:
        * svg/SVGFEComponentTransferElement.h:
        * svg/SVGFECompositeElement.cpp:
        * svg/SVGFECompositeElement.h:
        * svg/SVGFEDiffuseLightingElement.cpp:
        * svg/SVGFEDiffuseLightingElement.h:
        * svg/SVGFEDisplacementMapElement.cpp:
        * svg/SVGFEDisplacementMapElement.h:
        * svg/SVGFEGaussianBlurElement.cpp:
        * svg/SVGFEGaussianBlurElement.h:
        * svg/SVGFEImageElement.cpp:
        * svg/SVGFEImageElement.h:
        * svg/SVGFELightElement.cpp:
        * svg/SVGFELightElement.h:
        * svg/SVGFEMergeNodeElement.cpp:
        * svg/SVGFEMergeNodeElement.h:
        * svg/SVGFEOffsetElement.cpp:
        * svg/SVGFEOffsetElement.h:
        * svg/SVGFESpecularLightingElement.cpp:
        * svg/SVGFESpecularLightingElement.h:
        * svg/SVGFETileElement.cpp:
        * svg/SVGFETileElement.h:
        * svg/SVGFETurbulenceElement.cpp:
        * svg/SVGFETurbulenceElement.h:
        * svg/SVGFilterElement.cpp:
        * svg/SVGFilterElement.h:
        * svg/SVGFilterPrimitiveStandardAttributes.cpp:
        * svg/SVGFilterPrimitiveStandardAttributes.h:
        * svg/SVGFitToViewBox.cpp:
        * svg/SVGFitToViewBox.h:
        * svg/SVGForeignObjectElement.cpp:
        * svg/SVGForeignObjectElement.h:
        * svg/SVGGradientElement.cpp:
        * svg/SVGGradientElement.h:
        * svg/SVGImageElement.cpp:
        * svg/SVGImageElement.h:
        * svg/SVGLineElement.cpp:
        * svg/SVGLineElement.h:
        * svg/SVGLinearGradientElement.cpp:
        * svg/SVGLinearGradientElement.h:
        * svg/SVGMarkerElement.cpp:
        * svg/SVGMarkerElement.h:
        * svg/SVGMaskElement.cpp:
        * svg/SVGMaskElement.h:
        * svg/SVGPathElement.cpp:
        * svg/SVGPathElement.h:
        * svg/SVGPatternElement.cpp:
        * svg/SVGPatternElement.h:
        * svg/SVGRadialGradientElement.cpp:
        * svg/SVGRadialGradientElement.h:
        * svg/SVGRectElement.cpp:
        * svg/SVGRectElement.h:
        * svg/SVGSVGElement.cpp:
        * svg/SVGSVGElement.h:
        * svg/SVGScriptElement.h:
        * svg/SVGStopElement.cpp:
        * svg/SVGStopElement.h:
        * svg/SVGStyledElement.cpp:
        * svg/SVGStyledElement.h:
        * svg/SVGStyledTransformableElement.cpp:
        * svg/SVGStyledTransformableElement.h:
        * svg/SVGSymbolElement.h:
        * svg/SVGTextContentElement.cpp:
        * svg/SVGTextContentElement.h:
        * svg/SVGTextElement.cpp:
        * svg/SVGTextElement.h:
        * svg/SVGTextPathElement.cpp:
        * svg/SVGTextPathElement.h:
        * svg/SVGTextPositioningElement.cpp:
        * svg/SVGTextPositioningElement.h:
        * svg/SVGURIReference.cpp:
        * svg/SVGURIReference.h:
        * svg/SVGUseElement.cpp:
        * svg/SVGUseElement.h:
        * svg/SVGViewElement.h:
        * svg/SynchronizableTypeWrapper.h: Added.

2008-07-07  Nikolas Zimmermann  <zimmermann@kde.org>

        Reviewed by Oliver.

        Working on: http://bugs.webkit.org/show_bug.cgi?id=17779 (SVG 1.1 Errata demands "SVG JavaScript Liveness" support)

        Splitting up large patch in small chunk: Land valueAsString() implementation on it's own.

        Added valueAsString() conversion for all SVG primitive types, needed by the SVG<->XML synchronization layer.
        Unify "null value for a SVG animated type" concept, which was implemented in SVGDocumentExtensions before,
        in SVGAnimatedTemplate.

        * svg/SVGAnimatedTemplate.h:
        (WebCore::SVGAnimatedTemplate::associatedAttributeName):
        (WebCore::lookupOrCreateWrapper):
        (WebCore::SVGAnimatedTypeValue::null):
        (WebCore::SVGAnimatedTypeValue::toString):
        (WebCore::):
        * svg/SVGDocumentExtensions.h:
        (WebCore::SVGDocumentExtensions::baseValue):
        * svg/SVGLengthList.cpp:
        (WebCore::SVGLengthList::valueAsString):
        * svg/SVGLengthList.h:
        * svg/SVGNumberList.cpp:
        (WebCore::SVGNumberList::valueAsString):
        * svg/SVGNumberList.h:
        * svg/SVGPreserveAspectRatio.cpp:
        (WebCore::SVGPreserveAspectRatio::valueAsString):
        * svg/SVGPreserveAspectRatio.h:
        * svg/SVGTransformList.cpp:
        (SVGTransformList::valueAsString):
        * svg/SVGTransformList.h:

2008-07-06  Sam Weinig  <sam@webkit.org>

        Reviewed by Dan Bernstein.

        Rename "Access-Contol-Origin" to "Origin" to match the latest
        Access Control for Cross-Site Request draft. (Editor's Draft 25 May 2008)

        * xml/XMLHttpRequest.cpp:
        (WebCore::XMLHttpRequest::makeSimpleCrossSiteAccessRequest):
        (WebCore::XMLHttpRequest::makeCrossSiteAccessRequestWithPreflight):
        (WebCore::XMLHttpRequest::handleAsynchronousPreflightResult):

2008-07-06  Dan Bernstein  <mitz@apple.com>

        - try to fix the Windows build

        * WebCore.vcproj/WebCore.vcproj:

2008-07-06  Dan Bernstein  <mitz@apple.com>

        - add missing brace

        * platform/graphics/qt/FontCacheQt.cpp:

2008-07-06  Dan Bernstein  <mitz@apple.com>

        - try to fix the Qt build

        * platform/graphics/qt/FontCacheQt.cpp:
        (WebCore::FontCache::addClient):
        (WebCore::FontCache::removeClient):

2008-07-06  Sam Weinig  <sam@webkit.org>

        Reviewed by Cameron Zwarich.

        Add #include for kjs/protect.h.

        * xml/XMLHttpRequest.cpp:
        (WebCore::XMLHttpRequest::loadRequestAsynchronously):

2008-07-06  David Kilzer  <ddkilzer@apple.com>

        Save a few more bits in RenderStyle

        Reviewed by Darin.

        No test cases added since there is no change in behavior.

        This changes WebCore::StyleMarqueeData from using 6 bits to 5 bits,
        WebCore::RenderStyle::inherited_flags from using 36 bits to 35 bits,
        and WebCore::RenderStyle::noninherited_flags from using 49 bits to
        47 bits.

        * rendering/style/RenderStyle.h:
        (WebCore::StyleMarqueeData::behavior): Reduce from 3 bits to 2 bits
        since EMarqueeBehavior has 4 items.
        (WebCore::RenderStyle::inherited_flags._text_align): Reduce from
        4 bits to 3 bits since ETextAlign has 8 items.
        (WebCore::RenderStyle::noninherited_flags._overflowX): Reduce from
        4 bits to 3 bits since EOverflow has 6 items.
        (WebCore::RenderStyle::noninherited_flags._overflowY): Ditto.

2008-07-06  Dan Bernstein  <mitz@apple.com>

        Reviewed by Darin Adler.

        - fix <rdar://problem/5735163> WebCore caching makes text look wrong after font changes; need to respond appropriately instead

        * css/CSSFontSelector.cpp:
        (WebCore::CSSFontSelector::CSSFontSelector): Added a call to
        FontCache::addClient().
        (WebCore::CSSFontSelector::~CSSFontSelector): Added a call to
        FontCache::removeClient().
        (WebCore::CSSFontSelector::fontCacheInvalidated): Added. Called by the
        font cache when it is invalidated, and ensures that the document is
        updated.

        * css/CSSFontSelector.h:

        * platform/graphics/Font.cpp:
        (WebCore::Font::operator==): Added code to compare the font fallback
        lists' font cache generations.

        * platform/graphics/FontCache.cpp:
        (WebCore::FontCache::addClient): Added.
        (WebCore::FontCache::removeClient): Added.
        (WebCore::FontCache::generation): Added.
        (WebCore::FontCache::invalidate): Added. Deletes the platform data
        cache, increments the generation counter, and notifies all clients.

        * platform/graphics/FontCache.h:

        * platform/graphics/FontFallbackList.cpp:
        (WebCore::FontFallbackList::FontFallbackList): Added initialization of
        m_generation.
        (WebCore::FontFallbackList::invalidate): Added code to reset
        m_generation.
        (WebCore::FontFallbackList::fontDataAt): Added an assertion.
        (WebCore::FontFallbackList::fontDataForCharacters): Ditto.
        (WebCore::FontFallbackList::setPlatformFont): Ditto.

        * platform/graphics/FontFallbackList.h:
        (WebCore::FontFallbackList::generation): Added. Returns the font cache
        generation used to populate the list.

        * platform/graphics/FontSelector.h:
        (WebCore::FontSelector::fontCacheInvalidated): Added.

        * platform/graphics/mac/FontCacheMac.mm:
        (WebCore::fontCacheATSNotificationCallback): Added. Calls
        FontCache::invalidate().
        (WebCore::FontCache::platformInit): Added code to register for ATS
        notifications.

        * svg/SVGFontFaceElement.cpp: Removed unneeded #inlcudes.

2008-07-05  Sam Weinig  <sam@webkit.org>

        Rubber-stamped by Cameron Zwarich.

        Rename list.h/cpp to ArgList.h/cpp.

        * ForwardingHeaders/kjs/ArgList.h: Copied from WebCore/ForwardingHeaders/kjs/list.h.
        * ForwardingHeaders/kjs/list.h: Removed.
        * WebCore.vcproj/WebCore.vcproj:
        * bridge/qt/qt_instance.cpp:
        * page/Console.cpp:

2008-07-05  Sam Weinig  <sam@webkit.org>

        Rubber-stamped by Cameron Zwarich.

        Split Arguments, IndexToNameMap, PrototypeFunction, GlobalEvalFunction and 
        the functions on the global object out of JSFunction.h/cpp.

        * ForwardingHeaders/kjs/PrototypeFunction.h: Added.
        * bindings/js/JSDOMBinding.cpp:

2008-07-05  Dan Bernstein  <mitz@apple.com>

        Rubber-stamped by Sam Weinig.

        - rename BidiIterator and BidiState

        Renamed BidiIterator to InlineIterator and BidiState
        to InlineBidiResolver. Renamed variables of type InlineBidiResolver{*,&}
        to "resolver".

        * rendering/RenderBlock.h:
        * rendering/RootInlineBox.h:
        * rendering/bidi.cpp:
        (WebCore::InlineIterator::InlineIterator):
        (WebCore::operator==):
        (WebCore::operator!=):
        (WebCore::bidiNext):
        (WebCore::bidiFirst):
        (WebCore::InlineIterator::increment):
        (WebCore::InlineBidiResolver::increment):
        (WebCore::InlineIterator::atEnd):
        (WebCore::InlineIterator::current):
        (WebCore::InlineIterator::direction):
        (WebCore::chopMidpointsAt):
        (WebCore::checkMidpoints):
        (WebCore::addMidpoint):
        (WebCore::appendRunsForObject):
        (WebCore::InlineBidiResolver::appendRun):
        (WebCore::RenderBlock::bidiReorderLine):
        (WebCore::buildCompactRuns):
        (WebCore::RenderBlock::layoutInlineChildren):
        (WebCore::RenderBlock::determineStartPosition):
        (WebCore::RenderBlock::determineEndPosition):
        (WebCore::RenderBlock::matchedEndLine):
        (WebCore::skipNonBreakingSpace):
        (WebCore::requiresLineBox):
        (WebCore::RenderBlock::generatesLineBoxesForInlineChild):
        (WebCore::RenderBlock::skipWhitespace):
        (WebCore::shouldSkipWhitespaceAfterStartObject):
        (WebCore::RenderBlock::findNextLineBreak):

2008-07-05  Jan Michael Alonzo  <jmalonzo@webkit.org>

        Rubber-stamped by Oliver Hunt

        Coding style fix

        * html/CanvasRenderingContext2D.cpp: Indentation fix

2008-07-04  Oliver Hunt  <oliver@apple.com>

        Fix windows build

        * WebCore.vcproj/WebCore.vcproj:

2008-07-04  Sam Weinig  <sam@webkit.org>

        Fix Qt build.

        * bridge/qt/qt_instance.cpp:

2008-07-04  Sam Weinig  <sam@webkit.org>

        Rubber-stamped by Dan Bernstein.

        Split Error and GetterSetter out of JSObject.h.

        * ForwardingHeaders/kjs/Error.h: Added.
        * bindings/js/JSCanvasRenderingContext2DCustom.cpp:
        * bindings/js/JSClipboardCustom.cpp:
        * bindings/js/JSDOMWindowBase.cpp:
        * bindings/js/JSEventTargetBase.cpp:
        * bindings/js/JSHTMLDocumentCustom.cpp:
        * bindings/js/JSXMLHttpRequestCustom.cpp:
        * bindings/scripts/CodeGeneratorJS.pm:
        * bridge/NP_jsobject.cpp:
        * bridge/jni/jni_instance.cpp:
        * bridge/jni/jni_runtime.cpp:
        * bridge/objc/objc_instance.mm:
        * bridge/objc/objc_runtime.mm:
        * bridge/objc/objc_utility.h:
        * bridge/runtime_array.cpp:
        * bridge/runtime_method.cpp:
        * bridge/runtime_object.cpp:

2008-07-04  David D. Kilzer  <ddkilzer@webkit.org>

        Bug 15290: REGRESSION (r14184-r14216): Duplicate DOCTYPE definitions when saving files as webarchives

        <https://bugs.webkit.org/show_bug.cgi?id=15290>
        <rdar://problem/5509173>

        Reviewed by Dan Bernstein.

        Tests: webarchive/archive-empty-frame-dom.html
               webarchive/doctype.html

        * editing/markup.cpp:
        (WebCore::createFullMarkup): If the Node is a Document or a
        DocumentType, don't prepend the <!DOCTYPE> tag since that will
        cause it to be duplicated.
        * loader/archive/cf/LegacyWebArchive.cpp:
        (WebCore::LegacyWebArchive::create): Ditto.

2008-07-04  Jan Michael Alonzo  <jmalonzo@webkit.org>

        Gtk build fix

        * GNUmakefile.am:

2008-07-04  Cameron Zwarich  <cwzwarich@uwaterloo.ca>

        Reviewed by Eric Seidel.

        Bring our implementation of the Netscape plugin API closer to current
        code style guidelines.

        * bridge/NP_jsobject.cpp:
        (getListFromVariantArgs):
        (jsAllocate):
        (jsDeallocate):
        (_NPN_CreateScriptObject):
        (_NPN_CreateNoScriptObject):
        (_NPN_InvokeDefault):
        (_NPN_Invoke):
        (_NPN_Evaluate):
        (_NPN_GetProperty):
        (_NPN_SetProperty):
        (_NPN_RemoveProperty):
        (_NPN_HasProperty):
        (_NPN_HasMethod):
        (_NPN_Enumerate):
        * bridge/npruntime_impl.h:

2008-07-04  Simon Hausmann  <hausmann@webkit.org>

        Fix the Qt/Windows build.

        * WebCore.pro: Moved PluginMainThreadScheduler.cpp to the main
        sources, so that it is always compiled.
        * platform/qt/CursorQt.cpp: #undef CopyCursor, as it's defined by some
        Windows header.
        * platform/qt/KeyboardCodes.h: Don't re-define some of the keycodes
        that are defined by Windows already.
        * platform/qt/TemporaryLinkStubs.cpp: Removed the PluginDatabase stubs
        that are now platform-independent in plugin/PluginDatabase.cpp.

2008-07-04  Simon Hausmann  <hausmann@webkit.org>

        Fix the Mac build for real, don't define listDirectory() twice.

        * platform/mac/FileSystemMac.mm:

2008-07-04  Simon Hausmann  <hausmann@webkit.org>

        Prospective Mac build fix.

        * platform/mac/FileSystemMac.mm: Include NotImplemented.h.
        * platform/posix/FileSystemPOSIX.cpp: Ditto.

2008-07-04  Tor Arne Vestbø  <tavestbo@trolltech.com>

        Reviewed by Simon.

        Move duplicated code from each PluginDatabaseXX-implementation
        to PluginDabase.cpp -- ifdefed based on the XP_PLATFORM we are
        compiling plugins for.

        This make the code cleaner and we can share common patterns.
        The only implementation left which is specific is the Win
        implementation (also used by QtWebKit/Win), but we might
        want to move that too.

        * GNUmakefile.am: Removed PluginDatabaseGtk.cpp from the build.
        * WebCore.pro: Removed PluginDatabaseQt.cpp from the build.
        * plugins/PluginDatabase.cpp:
        (WebCore::PluginDatabase::defaultPluginDirectories):
        (WebCore::PluginDatabase::isPreferredPluginDirectory):
        (WebCore::PluginDatabase::getPluginPathsInDirectories):
        * plugins/gtk/PluginDatabaseGtk.cpp: Removed.
        * plugins/qt/PluginDatabaseQt.cpp: Removed.
        * plugins/wx/PluginDatabaseWx.cpp: Removed.
        * webcore-wx.bkl: Removed PluginDatabaseWx.cpp from the build.

2008-07-04  Simon Hausmann  <hausmann@webkit.org>

        Fix the Wx build.

        * WebCoreSources.bkl: Add plugins/PluginMainThreadScheduler.cpp to the
        build.
        * page/FocusController.cpp:
        (WebCore::FocusController::setActive): Extend MAC #ifdef to WX as
        layoutIfNeededRecursive does not exist for the Wx port.

2008-07-04  Simon Hausmann  <hausmann@webkit.org>

        Fix the Gtk build, adapt to renamed files.

        * GNUmakefile.am:

2008-07-04  Simon Hausmann  <hausmann@webkit.org>

        Fix the Qt build, adapt to renamed files.

        * WebCore.pro:

2008-07-03  Oliver Hunt  <oliver@apple.com>

        Reviewed by Eric Seidel.

        Move filter implementations to platform directory.

        * WebCore.vcproj/WebCore.vcproj
        * WebCore.xcodeproj/project.pbxproj:
        * svg/SVGComponentTransferFunctionElement.h:
        * svg/SVGFEBlendElement.h:
        * svg/SVGFEColorMatrixElement.h:
        * svg/SVGFEComponentTransferElement.h:
        * svg/SVGFECompositeElement.h:
        * platform/graphics/filters/FEBlend.cpp: Renamed from WebCore/svg/graphics/filters/SVGFEBlend.cpp.
        * platform/graphics/filters/FEBlend.h: Renamed from WebCore/svg/graphics/filters/SVGFEBlend.h.
        * platform/graphics/filters/FEColorMatrix.cpp: Renamed from WebCore/svg/graphics/filters/SVGFEColorMatrix.cpp.
        * platform/graphics/filters/FEColorMatrix.h: Renamed from WebCore/svg/graphics/filters/SVGFEColorMatrix.h.
        * platform/graphics/filters/FEComponentTransfer.cpp: Renamed from WebCore/svg/graphics/filters/SVGFEComponentTransfer.cpp.
        * platform/graphics/filters/FEComponentTransfer.h: Renamed from WebCore/svg/graphics/filters/SVGFEComponentTransfer.h.
        * platform/graphics/filters/FEComposite.cpp: Renamed from WebCore/svg/graphics/filters/SVGFEComposite.cpp.
        * platform/graphics/filters/FEComposite.h: Renamed from WebCore/svg/graphics/filters/SVGFEComposite.h.

2008-07-03  Alex Mathews  <possessedpenguinbob@gmail.com>

        Reviewed by Oliver Hunt.

        Bug 19835: WebKit needs cross-platform filter system
        <https://bugs.webkit.org/show_bug.cgi?id=19835>

        More class refactoring in preparation for cross-platform filter
        implementation.

        * WebCore.xcodeproj/project.pbxproj:
        * svg/FilterEffect.h:
        * svg/SVGComponentTransferFunctionElement.cpp:
        (WebCore::SVGComponentTransferFunctionElement::SVGComponentTransferFunctionElement):
        (WebCore::SVGComponentTransferFunctionElement::parseMappedAttribute):
        (WebCore::SVGComponentTransferFunctionElement::transferFunction):
        * svg/SVGComponentTransferFunctionElement.h:
        * svg/SVGFEColorMatrixElement.cpp:
        (WebCore::SVGFEColorMatrixElement::SVGFEColorMatrixElement):
        (WebCore::SVGFEColorMatrixElement::parseMappedAttribute):
        (WebCore::SVGFEColorMatrixElement::filterEffect):
        (WebCore::SVGFEColorMatrixElement::build):
        * svg/SVGFEColorMatrixElement.h:
        * svg/SVGFEComponentTransferElement.cpp:
        (WebCore::SVGFEComponentTransferElement::filterEffect):
        (WebCore::SVGFEComponentTransferElement::build):
        * svg/SVGFEComponentTransferElement.h:
        * svg/SVGFECompositeElement.cpp:
        (WebCore::SVGFECompositeElement::SVGFECompositeElement):
        (WebCore::SVGFECompositeElement::parseMappedAttribute):
        (WebCore::SVGFECompositeElement::filterEffect):
        (WebCore::SVGFECompositeElement::build):
        * svg/SVGFECompositeElement.h:
        * svg/graphics/filters/SVGFEBlend.cpp:
        * svg/graphics/filters/SVGFEBlend.h:
        * svg/graphics/filters/SVGFEColorMatrix.cpp:
        (WebCore::FEColorMatrix::FEColorMatrix):
        (WebCore::FEColorMatrix::create):
        (WebCore::FEColorMatrix::type):
        (WebCore::FEColorMatrix::setType):
        (WebCore::FEColorMatrix::values):
        (WebCore::FEColorMatrix::setValues):
        (WebCore::FEColorMatrix::apply):
        (WebCore::FEColorMatrix::dump):
        * svg/graphics/filters/SVGFEColorMatrix.h:
        (WebCore::):
        * svg/graphics/filters/SVGFEComponentTransfer.cpp:
        (WebCore::FEComponentTransfer::FEComponentTransfer):
        (WebCore::FEComponentTransfer::create):
        (WebCore::FEComponentTransfer::redFunction):
        (WebCore::FEComponentTransfer::setRedFunction):
        (WebCore::FEComponentTransfer::greenFunction):
        (WebCore::FEComponentTransfer::setGreenFunction):
        (WebCore::FEComponentTransfer::blueFunction):
        (WebCore::FEComponentTransfer::setBlueFunction):
        (WebCore::FEComponentTransfer::alphaFunction):
        (WebCore::FEComponentTransfer::setAlphaFunction):
        (WebCore::FEComponentTransfer::apply):
        (WebCore::FEComponentTransfer::dump):
        * svg/graphics/filters/SVGFEComponentTransfer.h:
        (WebCore::):
        (WebCore::ComponentTransferFunction::ComponentTransferFunction):
        * svg/graphics/filters/SVGFEComposite.cpp:
        (WebCore::FEComposite::FEComposite):
        (WebCore::FEComposite::create):
        (WebCore::FEComposite::operation):
        (WebCore::FEComposite::setOperation):
        (WebCore::FEComposite::k1):
        (WebCore::FEComposite::setK1):
        (WebCore::FEComposite::k2):
        (WebCore::FEComposite::setK2):
        (WebCore::FEComposite::k3):
        (WebCore::FEComposite::setK3):
        (WebCore::FEComposite::k4):
        (WebCore::FEComposite::setK4):
        (WebCore::FEComposite::apply):
        (WebCore::FEComposite::dump):
        * svg/graphics/filters/SVGFEComposite.h:
        (WebCore::):
        * svg/graphics/filters/cg/SVGFEColorMatrixCg.mm: Removed.
        * svg/graphics/filters/cg/SVGFEComponentTransferCg.mm: Removed.
        * svg/graphics/filters/cg/SVGFECompositeCg.mm: Removed.

2008-07-03  Dan Bernstein  <mitz@apple.com>

        Reviewed by John Sullivan.

        - fix <rdar://problem/6020930> Bidi Problem When Resizing Window

        Test: fast/text/international/bidi-AN-after-empty-run.html

        * platform/text/BidiResolver.h:
        (WebCore::::appendRun): Changed to reset the current direction and
        "end of run" direction even in the empty run case.
        * rendering/bidi.cpp:
        (WebCore::BidiState::appendRun): Ditto.

2008-07-02  Jon Honeycutt  <jhoneycutt@apple.com>

        <rdar://5983747> Safari crashes trying to load the SilverLight plugin

        If a plug-in returned an error code from NPP_NewStream, we would call
        NPP_DestroyStream while cleaning up the request. We now only call
        NPP_DestroyStream if NPP_NewStream was successful, matching Firefox.

        Reviewed by Anders.

        * plugins/PluginStream.cpp:
        (WebCore::PluginStream::startStream): If NPP_NewStream returns an error,
        don't set m_streamState to StreamStarted, and return after calling
        cancelAndDestroyStream.
        (WebCore::PluginStream::destroyStream): Don't call NPP_DestroyStream if
        the stream didn't start successfully.

2008-07-03  David Hyatt  <hyatt@apple.com>

        Revise Dan's fix for an assert on Windows, since layoutIfNeededRecursive doesn't exist on the
        Mac.  Revert updateControlTints and add the layout call outside of it in the already-existing
        !PLATFORM(MAC) ifdef in FocusController's setActive method.

        Reviewed by ggaren, weinig

        * page/FocusController.cpp:
        (WebCore::FocusController::setActive):
        * page/FrameView.cpp:
        (WebCore::FrameView::updateControlTints):

2008-07-03  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Darin.

        https://bugs.webkit.org/show_bug.cgi?id=19884
        Locating a store at www.366.ru doesn't work

        Test: fast/forms/submit-with-base.html

        * html/HTMLFormElement.cpp: (WebCore::HTMLFormElement::submit): Treat empty action the same
        as missing one - ignore base URL.

2008-07-03  Dan Bernstein  <mitz@apple.com>

        Reviewed by John Sullivan.

        - fix <rdar://problem/6048904> Assert in WebCore::Frame::paint in Windows

        * page/FrameView.cpp:
        (WebCore::FrameView::updateControlTints): Changed to update layout
        recursively and not just for the top-level frame.

2008-07-03  Cameron Zwarich  <cwzwarich@uwaterloo.ca>

        Reviewed by Geoff.

        Bug 19853: REGRESSION (r34838): Crash when visiting http://www.thewebsiteisdown.com/salesguy.html
        https://bugs.webkit.org/show_bug.cgi?id=19853

        Remove the body of _NPN_SetException(), because it was simply calling
        throwError(), which sets an exception on an ExecState but does not
        actually handle it. The presence of an exception on the global ExecState
        causes assertions that there is no exception set on that ExecState to
        fail, as well as causing Machine::execute() to mistakingly return 0 in
        some cases, as it assumes the presence of an exception implies that it
        has run out of memory.

        * bridge/NP_jsobject.cpp:
        (_NPN_SetException):

2008-07-03  Maciej Katafiasz  <mathrick@gmail.com>

        Gtk build fix with SVG filters enabled

        * GNUmakefile.am: Include missing SVG filter sources

2008-07-03  Simon Hausmann  <hausmann@webkit.org>

        Fix the Qt build, added FilterEffect to the build.

        * WebCore.pro:

2008-07-02  Brady Eidson  <beidson@apple.com>

        Reviewed by Mitz Pettel and John Sullivan

        Fix for <rdar://problem/5549871> - Crash when calling [WebView stopLoading:] or [WebFrame stopLoading] 
        inside of the frame load delegate method -webView:didStartProvisionalLoadForFrame:.

        Test: fast/loader/stop-provisional-loads.html

        * loader/FrameLoader.cpp:
        (WebCore::FrameLoader::continueLoadAfterWillSubmitForm): Since the provisionalDocumentLoader may have been cleared
          by the prepareForLoadStart() call, null check it again.

2008-07-01  Alex Mathews  <possessedpenguinbob@gmail.com>

        Reviewed by Oliver Hunt.

        Renaming of class SVGFEBlend to FEBlend as well as removing
        a little bit of antiquated code. This includes the removal of
        SVGFEBlendCg.mm; the feBlend element will now no longer
        render. 

        * WebCore.xcodeproj/project.pbxproj:
        * svg/FilterBuilder.h:
        (WebCore::FilterBuilder::add):
        (WebCore::FilterBuilder::getEffectById):
        * svg/SVGFEBlendElement.cpp:
        (WebCore::SVGFEBlendElement::SVGFEBlendElement):
        (WebCore::SVGFEBlendElement::parseMappedAttribute):
        (WebCore::SVGFEBlendElement::filterEffect):
        (WebCore::SVGFEBlendElement::build):
        * svg/SVGFEBlendElement.h:
        * svg/SVGFilterPrimitiveStandardAttributes.h:
        * svg/graphics/filters/SVGFEBlend.cpp:
        (WebCore::FEBlend::FEBlend):
        (WebCore::FEBlend::create):
        (WebCore::FEBlend::in2):
        (WebCore::FEBlend::setIn2):
        (WebCore::FEBlend::blendMode):
        (WebCore::FEBlend::setBlendMode):
        (WebCore::FEBlend::apply):
        (WebCore::FEBlend::dump):
        * svg/graphics/filters/SVGFEBlend.h:
        (WebCore::):
        * svg/graphics/filters/cg/SVGFEBlendCg.mm: Removed.

2008-07-02  Beth Dakin  <bdakin@apple.com>

        Reviewed by Darin.

        Fix for <rdar://problem/6015523> Implement ARIA ranges/sliders
        and
        <rdar://problem/5934355> Need to implement ARIA role="spinbutton"

        * page/AccessibilityObject.h:
        (WebCore::AccessibilityObject::isSlider):
        * page/AccessibilityRenderObject.cpp:
        (WebCore::AccessibilityRenderObject::isSlider):
        (WebCore::AccessibilityRenderObject::valueForRange):
        (WebCore::AccessibilityRenderObject::maxValueForRange):
        (WebCore::AccessibilityRenderObject::minValueForRange):
        (WebCore::AccessibilityRenderObject::accessibilityIsIgnored): We 
        were addressing the generic has-an-ARIA-role case too early here.
        (WebCore::AccessibilityRenderObject::focusedUIElement): This is a 
        bug I ran into while testing role='spinbutton', spinbutton is a 
        role that can have an active descendant. But we were always trying 
        to forward focus to the active descendant, even if one was not 
        specified. 
        (WebCore::AccessibilityRenderObject::shouldFocusActiveDescendant): 
        'spinbutton' maps to ProgressIndicatorRole.
        (WebCore::RoleEntry::):
        (WebCore::AccessibilityRenderObject::canSetValueAttribute):
        * page/AccessibilityRenderObject.h:
        * page/mac/AccessibilityObjectWrapper.mm:
        (-[AccessibilityObjectWrapper accessibilityAttributeNames]):
        (-[AccessibilityObjectWrapper accessibilityAttributeValue:]):

2008-07-02  Dan Bernstein  <mitz@apple.com>

        Reviewed by Adam Roben.

        - Windows build fix

        Renamed the ERROR token in the XPath grammar to XPATH_ERROR, because
        the ERROR macro is defined in <wingdi.h>.

        * xml/XPathGrammar.y:
        * xml/XPathParser.cpp:
        (WebCore::XPath::Parser::lexString):
        (WebCore::XPath::Parser::nextTokenInternal):

2008-07-02  Alexey Proskuryakov  <ap@webkit.org>

        Inspired and reviewed by Mark Rowe.

        Change non-API includes from JavaScriptCore/ to kjs/ and wtf/ to match prevalent style.

        * bindings/objc/ExceptionHandlers.h:
        * bindings/objc/WebScriptObject.mm:
        * dom/Document.cpp:
        * dom/Node.cpp:
        * page/Frame.cpp:
        * page/InspectorController.cpp:
        * page/JavaScriptProfileNode.cpp:
        * page/mac/FrameMac.mm:
        * platform/mac/ThreadCheck.mm:
        * xml/XMLHttpRequest.cpp:

2008-07-02  Simon Hausmann  <hausmann@webkit.org>

        Fix the Gtk build.

        * plugins/gtk/PluginViewGtk.cpp: Adapt to JSLock API changes.
        (WebCore::PluginView::paint):
        (WebCore::PluginView::handleKeyboardEvent):
        (WebCore::PluginView::handleMouseEvent):
        (WebCore::PluginView::setNPWindowRect):
        (WebCore::PluginView::stop):
        (WebCore::PluginView::init):

2008-07-02  Simon Hausmann  <hausmann@webkit.org>

        Build fixes.

        * WebCore.pro: Added plugins/PluginMainThreadScheduler.cpp to the
        build.
        * bridge/qt/qt_instance.cpp: Adjust to JSLock API change.
        * bridge/qt/qt_runtime.cpp: Ditto.
        (KJS::Bindings::convertValueToQVariant):
        (KJS::Bindings::convertQVariantToValue):
        (KJS::Bindings::QtRuntimeMetaMethod::call):
        (KJS::Bindings::QtRuntimeConnectionMethod::call):
        (KJS::Bindings::QtConnectionObject::execute):
        * page/JavaScriptProfileNode.cpp: Inlude kjs/JSValue.h instead of
        JavaScriptCore/JSValue.h.
        * plugins/qt/PluginViewQt.cpp: Adjust to JSLock API changes.
        (WebCore::PluginView::setNPWindowRect): Ditto.
        (WebCore::PluginView::stop): Ditto.
        (WebCore::PluginView::init): Ditto.

2008-07-02  Alexey Proskuryakov  <ap@webkit.org>

        Build fix.

        * plugins/PluginView.cpp:
        (WebCore::PluginView::start):
        (WebCore::getString):
        (WebCore::PluginView::performRequest):
        (WebCore::PluginView::bindingInstance):
        * plugins/win/PluginViewWin.cpp:
        (WebCore::PluginView::dispatchNPEvent):
        (WebCore::PluginView::setNPWindowRect):
        (WebCore::PluginView::stop):
        Pass false to JSLock and JSLock::DropAllLocks constructors.

2008-07-01  Oliver Hunt  <oliver@apple.com>

        Reviewed by Geoff Garen.

        <rdar://problem/5974306> CanvasRenderingContext2D becomes invalid when source canvas element is collected

        In order to fix this we now make the rendering context and the canvas element
        share the same reference count, ensuring that references to the rendering
        context will force the canvas element to remain live as well.

        Test: fast/canvas/canvas-longlived-context.html

        * html/CanvasRenderingContext2D.cpp:
        (WebCore::CanvasRenderingContext2D::clearPathForDashboardBackwardCompatibilityMode):
        (WebCore::CanvasRenderingContext2D::createImageData):
        (WebCore::CanvasRenderingContext2D::getImageData):
        (WebCore::CanvasRenderingContext2D::putImageData):
        * html/CanvasRenderingContext2D.h:
        (WebCore::CanvasRenderingContext2D::create):
        * html/HTMLCanvasElement.cpp:
        (WebCore::HTMLCanvasElement::getContext):
        * html/HTMLCanvasElement.h:

2008-07-01  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Darin.

        Disable JSLock for per-thread contexts.

        * bridge/runtime_root.cpp:
        (KJS::Bindings::RootObject::invalidate):
        (KJS::Bindings::RootObject::gcProtect):
        (KJS::Bindings::RootObject::gcUnprotect):
        Don't lock while calling gcProtect/gcUnprotect, which now has its own implicit lock.

        * storage/Database.cpp: (WebCore::Database::Database): Call Heap::setGCProtectNeedsLocking
        to indicate that protected value list can be concurrently accessed from multiple threads now.

        * xml/XMLHttpRequest.cpp:
        (WebCore::XMLHttpRequest::loadRequestSynchronously): There is no need to drop the locks here,
        as fake locks cannot deadlock, and there is no danger that someone will try to take a real
        JSLock on the main thread while we are waiting for response.
        (WebCore::XMLHttpRequest::loadRequestAsynchronously): There is no need to explicitly lock
        around gcProtect/gcUnprotect now.
        (WebCore::XMLHttpRequest::dropProtection): Access heap directly, rather than via
        JSGlobalData::threadInstance().

        * bindings/js/GCController.cpp:
        (WebCore::collect):
        (WebCore::GCController::gcTimerFired):
        (WebCore::GCController::garbageCollectNow):
        (WebCore::GCController::garbageCollectOnAlternateThreadForDebugging):
        * bindings/js/JSCustomSQLStatementCallback.cpp:
        (WebCore::JSCustomSQLStatementCallback::handleEvent):
        * bindings/js/JSCustomSQLStatementErrorCallback.cpp:
        (WebCore::JSCustomSQLStatementErrorCallback::handleEvent):
        * bindings/js/JSCustomSQLTransactionCallback.cpp:
        (WebCore::JSCustomSQLTransactionCallback::handleEvent):
        * bindings/js/JSCustomSQLTransactionErrorCallback.cpp:
        (WebCore::JSCustomSQLTransactionErrorCallback::handleEvent):
        * bindings/js/JSCustomVoidCallback.cpp:
        (WebCore::JSCustomVoidCallback::handleEvent):
        * bindings/js/JSCustomXPathNSResolver.cpp:
        (WebCore::JSCustomXPathNSResolver::lookupNamespaceURI):
        * bindings/js/JSDOMWindowBase.cpp:
        (WebCore::DOMWindowTimer::~DOMWindowTimer):
        (WebCore::JSDOMWindowBase::clear):
        (WebCore::JSDOMWindowBase::timerFired):
        * bindings/js/JSEventCustom.cpp:
        (WebCore::toJS):
        * bindings/js/JSEventListener.cpp:
        (WebCore::JSAbstractEventListener::handleEvent):
        (WebCore::JSLazyEventListener::parseCode):
        * bindings/js/JSNodeFilterCondition.cpp:
        (WebCore::JSNodeFilterCondition::acceptNode):
        * bindings/js/ScheduledAction.cpp:
        (WebCore::ScheduledAction::execute):
        * bindings/js/ScriptController.cpp:
        (WebCore::ScriptController::evaluate):
        (WebCore::ScriptController::clear):
        (WebCore::ScriptController::createHTMLEventHandler):
        (WebCore::ScriptController::createSVGEventHandler):
        (WebCore::ScriptController::initScript):
        (WebCore::ScriptController::updateDocument):
        * bindings/objc/WebScriptObject.mm:
        (-[WebScriptObject callWebScriptMethod:withArguments:]):
        (-[WebScriptObject evaluateWebScript:]):
        (-[WebScriptObject setValue:forKey:]):
        (-[WebScriptObject valueForKey:]):
        (-[WebScriptObject removeWebScriptKey:]):
        (-[WebScriptObject stringRepresentation]):
        (-[WebScriptObject webScriptValueAtIndex:]):
        (-[WebScriptObject setWebScriptValueAtIndex:value:]):
        (+[WebScriptObject _convertValueToObjcValue:originRootObject:rootObject:]):
        * bridge/NP_jsobject.cpp:
        (_NPN_InvokeDefault):
        (_NPN_Invoke):
        (_NPN_Evaluate):
        (_NPN_GetProperty):
        (_NPN_SetProperty):
        (_NPN_RemoveProperty):
        (_NPN_HasProperty):
        (_NPN_HasMethod):
        (_NPN_SetException):
        (_NPN_Enumerate):
        * bridge/c/c_class.cpp:
        (KJS::Bindings::CClass::~CClass):
        (KJS::Bindings::CClass::methodsNamed):
        (KJS::Bindings::CClass::fieldNamed):
        * bridge/c/c_instance.cpp:
        (KJS::Bindings::CInstance::invokeMethod):
        (KJS::Bindings::CInstance::invokeDefaultMethod):
        (KJS::Bindings::CInstance::getPropertyNames):
        * bridge/c/c_runtime.cpp:
        (KJS::Bindings::CField::valueFromInstance):
        (KJS::Bindings::CField::setValueToInstance):
        * bridge/c/c_utility.cpp:
        (KJS::Bindings::convertValueToNPVariant):
        (KJS::Bindings::convertNPVariantToValue):
        * bridge/jni/jni_class.cpp:
        (JavaClass::JavaClass):
        (JavaClass::~JavaClass):
        * bridge/jni/jni_instance.cpp:
        (JavaInstance::stringValue):
        * bridge/jni/jni_jsobject.mm:
        (JavaJSObject::call):
        (JavaJSObject::eval):
        (JavaJSObject::getMember):
        (JavaJSObject::setMember):
        (JavaJSObject::removeMember):
        (JavaJSObject::getSlot):
        (JavaJSObject::setSlot):
        (JavaJSObject::toString):
        (JavaJSObject::convertValueToJObject):
        (JavaJSObject::convertJObjectToValue):
        * bridge/jni/jni_objc.mm:
        (KJS::Bindings::dispatchJNICall):
        * bridge/jni/jni_runtime.cpp:
        (JavaMethod::signature):
        * bridge/jni/jni_runtime.h:
        (KJS::Bindings::JavaString::JavaString):
        (KJS::Bindings::JavaString::_commonInit):
        (KJS::Bindings::JavaString::~JavaString):
        (KJS::Bindings::JavaString::UTF8String):
        * bridge/jni/jni_utility.cpp:
        (KJS::Bindings::convertArrayInstanceToJavaArray):
        (KJS::Bindings::convertValueToJValue):
        * bridge/npruntime.cpp:
        (_NPN_GetStringIdentifier):
        * bridge/objc/objc_instance.mm:
        (ObjcInstance::moveGlobalExceptionToExecState):
        (ObjcInstance::invokeMethod):
        (ObjcInstance::invokeDefaultMethod):
        (ObjcInstance::setValueOfUndefinedField):
        (ObjcInstance::getValueOfUndefinedField):
        * bridge/objc/objc_runtime.mm:
        (ObjcField::valueFromInstance):
        (ObjcField::setValueToInstance):
        * bridge/objc/objc_utility.mm:
        (KJS::Bindings::convertValueToObjcValue):
        (KJS::Bindings::convertNSStringToString):
        (KJS::Bindings::convertObjcValueToValue):
        * bridge/runtime.cpp:
        (KJS::Bindings::Instance::createRuntimeObject):
        * dom/Document.cpp:
        (WebCore::Document::~Document):
        * dom/Node.cpp:
        (WebCore::Node::setDocument):
        * history/CachedPage.cpp:
        (WebCore::CachedPage::CachedPage):
        (WebCore::CachedPage::restore):
        (WebCore::CachedPage::clear):
        * html/HTMLPlugInElement.cpp:
        (WebCore::HTMLPlugInElement::createNPObject):
        * loader/FrameLoader.cpp:
        (WebCore::getString):
        * page/Frame.cpp:
        (WebCore::Frame::bindingRootObject):
        (WebCore::Frame::windowScriptNPObject):
        (WebCore::Frame::clearScriptObjects):
        * page/InspectorController.cpp:
        (WebCore::jsStringRef):
        (WebCore::ConsoleMessage::ConsoleMessage):
        (WebCore::XMLHttpRequestResource::XMLHttpRequestResource):
        (WebCore::XMLHttpRequestResource::~XMLHttpRequestResource):
        (WebCore::getResourceDocumentNode):
        (WebCore::search):
        (WebCore::inspectedWindow):
        (WebCore::wrapCallback):
        (WebCore::currentCallFrame):
        (WebCore::profiles):
        (WebCore::InspectorController::focusNode):
        (WebCore::InspectorController::addDatabaseScriptResource):
        (WebCore::InspectorController::addScriptProfile):
        * page/JavaScriptCallFrame.cpp:
        (WebCore::JavaScriptCallFrame::evaluate):
        * page/JavaScriptProfileNode.cpp:
        (WebCore::getTotalTime):
        (WebCore::getSelfTime):
        (WebCore::getTotalPercent):
        (WebCore::getSelfPercent):
        (WebCore::getNumberOfCalls):
        (WebCore::getChildren):
        (WebCore::getVisible):
        * page/mac/FrameMac.mm:
        (WebCore::Frame::windowScriptObject):
        Pass a parameter (always false) to JSLock and JSLock::DropAllLocks to indicate that WebCore
        doesn't need locking. In the future, it may be possible to remove some of these if we
        establish that this won't make JSC assertions fail (and that we don't want to add such
        assertions either).
        Added includes that are now needed.

2008-07-01  Dan Bernstein  <mitz@apple.com>

        Reviewed by Oliver Hunt.

        - fix a CSSParserValueList leak seen on the build bot

        * css/CSSParser.cpp:
        (WebCore::BorderImageParseContext::commitBorderImage):

2008-07-01  Alex Mathews  <possessedpenguinbob@gmail.com>

        Reviewed by Oliver Hunt.

        Prep for more Filter class name changes. Added the first few files for
        the new Filter architecture to come.

        * WebCore.xcodeproj/project.pbxproj:
        * svg/Filter.cpp: Added.
        (WebCore::Filter::Filter):
        (WebCore::Filter::create):
        * svg/Filter.h: Added.
        * svg/FilterBuilder.h: Added.
        (WebCore::FilterBuilder::add):
        (WebCore::FilterBuilder::getEffectById):
        (WebCore::FilterBuilder::filter):
        * svg/FilterEffect.cpp: Added.
        (WebCore::FilterEffect::FilterEffect):
        (WebCore::FilterEffect::~FilterEffect):
        * svg/FilterEffect.h: Added.

2008-07-01  Christian Dywan  <christian@twotoasts.de>

        Gtk+ build fix.

        * GNUmakefile.am: add WebCore/plugins/PluginMainThreadScheduler.cpp

2008-07-01  Anders Carlsson  <andersca@apple.com>

        Reviewed by Darin.

        Add PluginMainThreadScheduler.{cpp|h} to build.
        
        * WebCore.base.exp:
        * WebCore.xcodeproj/project.pbxproj:
        * plugins/PluginMainThreadScheduler.cpp:

2008-07-01  Dan Bernstein  <mitz@apple.com>

        Reviewed by Darin Adler.

        - move the method to set the base writing direction from Frame to Editor

        * WebCore.base.exp: Updated.
        * editing/Editor.cpp:
        (WebCore::Editor::setBaseWritingDirection): Changed the parameter to a
        WritingDirection enum value and added the special behavior when the
        focused node is a text field or a text area.
        * editing/Editor.h:
        * page/ContextMenuController.cpp:
        (WebCore::ContextMenuController::contextMenuItemSelected): Changed back
        to call the Editor method.
        * page/Frame.cpp: Removed setSelectionBaseWritingDirection().
        * page/Frame.h:

2008-07-01  Darin Adler  <darin@apple.com>

        Reviewed by Oliver.

        - slight tweak of the setHash fix

        * bindings/js/JSLocationCustom.cpp:
        (WebCore::JSLocation::setHash): Use oldRef instead of recomputing url.ref().

2008-07-01  Dan Bernstein  <mitz@apple.com>

        Reviewed by Anders Carlsson.

        - Mac release build fix

        * page/Console.cpp:

2008-07-01  Dan Bernstein  <mitz@apple.com>

        Reviewed by Anders Carlsson.

        - fix <rdar://problem/6045896> REGRESSION: Leak in WebCore::StringImpl::create

        * css/CSSPrimitiveValue.cpp:
        (WebCore::CSSPrimitiveValue::cleanup):

2008-07-01  Anders Carlsson  <andersca@apple.com>

        Reviewed by Jon.

        Don't add the Mozilla user agent quirk for Flash 10.
        
        * plugins/win/PluginPackageWin.cpp:
        (WebCore::PluginPackage::isPluginBlacklisted):
        (WebCore::PluginPackage::determineQuirks):

2008-07-01  David Kilzer  <ddkilzer@apple.com>

        Move data: URL parsing code in HTMLObjectElement to KURL

        Reviewed by Ada and Darin.

        No test cases added since there is no change in behavior.

        * html/HTMLObjectElement.cpp:
        (WebCore::HTMLObjectElement::isImageType): Extracted data: URL
        parsing code into WebCore::mimeTypeFromDataURL() in KURL.cpp.
        * platform/KURL.cpp:
        (WebCore::mimeTypeFromDataURL): Added.
        * platform/KURL.h:
        (WebCore::mimeTypeFromDataURL): Added.

2008-07-01  Dan Bernstein  <mitz@apple.com>

        Reviewed by Dave Hyatt.

        - fix <rdar://problem/6045890> REGRESSION: Leak in WebCore::CSSParser::createFloatingValueList()

        * css/CSSParser.cpp:
        (WebCore::CSSParser::addUnresolvedProperty):

2008-07-01  Cameron Zwarich  <cwzwarich@uwaterloo.ca>

        Reviewed by Brady Eidson.

        Bug 19822: REGRESSION (r30243): setting location.hash to "#" causes a reload
        <https://bugs.webkit.org/show_bug.cgi?id=19822>

        Change JSLocation::setHash() to not schedule navigation in the case
        where the old fragment is the null String and the new fragment is an
        empty String.

        * bindings/js/JSLocationCustom.cpp:
        (WebCore::JSLocation::setHash):

2008-06-30  Anders Carlsson  <andersca@apple.com>

        Reviewed by Adam.

        Add PluginMainThreadScheduler, a singleton which is responsible for scheduling plug-in 
        callbacks on the main thread. Use this to implement NPN_PluginThreadAsyncCall on Windows.
        
        * WebCore.vcproj/WebCore.vcproj:
        Add PluginMainThreadScheduler.{cpp|h}
        
        * plugins/PluginMainThreadScheduler.cpp: Added.
        * plugins/PluginMainThreadScheduler.h: Added.

        * plugins/PluginView.cpp:
        (WebCore::PluginView::start):
        Register with the thread scheduler.
        
        * plugins/npapi.cpp:
        (NPN_PluginThreadAsyncCall):
        Call the thread scheduler.
        
        * plugins/win/PluginPackageWin.cpp:
        (WebCore::PluginPackage::load):
        Initialize the NPN_PluginThreadAsyncCall callback.
        
        * plugins/win/PluginViewWin.cpp:
        (WebCore::PluginView::stop):
        Unregister with the scheduler. This makes sure that we won't try to deliver callbacks
        after the plug-in has been destroyed.

2008-07-01  Adam Roben  <aroben@apple.com>

        Roll out r34913, as it broke the Windows build due to bad casting

        r34913 introduced code that assigned pointers-to-member from a derived
        class into a base class pointer-to-member type (e.g., assigned a void
        (SVGUseElement::*)() into a void (SVGElement::*)()). This is bad
        because it could allow us to call SVGUseElement member functions on a
        different SVGElement-derived class. MSVC rightly flagged this as an
        error.

        Rubberstamped by Anders Carlsson.

2008-07-01  Darin Adler  <darin@apple.com>

        - fix build

        * bindings/scripts/CodeGeneratorJS.pm: Fix warnings that indicate this was
        not working propertly.

2008-07-01  Dan Bernstein  <mitz@apple.com>

        Reviewed by Darin Adler.

        - fix <rdar://problem/6045893> REGRESSION: Leak in WebCore::HTMLCanvasElement::createPlatformImage() const

        * html/CanvasRenderingContext2D.cpp:
        (WebCore::CanvasRenderingContext2D::createPattern):

2008-07-01  Sam Weinig  <sam@webkit.org>

        Reviewed by Darin Adler.

        Split JSCell and JSNumberCell class declarations out of JSValue.h

        * ForwardingHeaders/kjs/JSNumberCell.h: Added.
        * bindings/scripts/CodeGeneratorJS.pm:
        * bridge/c/c_instance.cpp:

2008-07-01  chris fleizach  <cfleizach@apple.com>

        Reviewed by Beth Dakin

        <rdar://problem/6041580> REGRESSION: AX: AXSize of radio buttons is 0,0

        Test: accessibility/radio-button-checkbox-size.html

        * page/AccessibilityRenderObject.cpp:
        (WebCore::AccessibilityRenderObject::checkboxOrRadioRect):

2008-07-01  Dan Bernstein  <mitz@apple.com>

        Reviewed by Antti Koivisto.

        - fix SVG pointer-events layout test failures

        * css/SVGCSSParser.cpp:
        (WebCore::CSSParser::parseSVGValue):

2008-07-01  Nikolas Zimmermann  <zimmermann@kde.org>

        Reviewed by Antti.

        Fixes: https://bugs.webkit.org/show_bug.cgi?id=19841
        Fix two small problems in the gradient & pattern code.

        Added 12 new layout tests: svg/dynamic-updates/SVGLinearGradientElement*.html

        * svg/SVGLinearGradientElement.cpp:
        (WebCore::SVGLinearGradientElement::collectGradientProperties): Compare against already computed bounding box information, instead of querying attributes.
        * svg/SVGPatternElement.cpp:
        (WebCore::SVGPatternElement::collectPatternProperties): Ditto.
        * svg/SVGRadialGradientElement.cpp:
        (WebCore::SVGRadialGradientElement::collectGradientProperties): Ditto.
        (WebCore::SVGRadialGradientElement::svgAttributeChanged): 'fxAttr' updating wasn't handled. Copy'n'paste error.

2008-07-01  Simon Hausmann  <hausmann@webkit.org>

        Fix the build, include SVGTransformList.h instead of
        SVGTransformlist.h

        * svg/SVGGradientElement.h:

2008-07-01  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Antti.

        <rdar://problem/6033080> REGRESSION: Some CH characters display as garbage on webpage for
        the first time.

        Test: fast/encoding/preload-encoding.html

        * html/PreloadScanner.cpp:
        (WebCore::PreloadScanner::tokenize): Reset charset when entering a tag, not just when
        starting a load.

2008-07-01  Nikolas Zimmermann  <zimmermann@kde.org>

        Reviewed by Antti & Eric.

        Fixes: http://bugs.webkit.org/show_bug.cgi?id=17779 (SVG 1.1 Errata demands "SVG JavaScript Liveness" support)

        SVG Errata states: "All SVG DOM objects that directly correspond to an
        attribute, e.g. the SVGAnimatedLength 'ry' in an SVGRectElement, are live. This
        means that any changes made to the attribute are immediately reflected in the
        corresponding SVG DOM object." (see linked URL on bug report)

        Until now only XML -> SVG DOM changes took affect, aka. changing the 'rx' attribute of a <rect>
        element resuted in changes when accessing 'rx' through SVG DOM (rx.baseVal.value).

        Add a new synchronization layer to handle SVG DOM -> XML changes.

        Global macro change #1: ANIMATED_PROPERTY_FORWARD_DECLARATIONS contains the class name where it's defined as first parameter.
        Global macro change #2: Add ANIMATED_PROPERTY_START_DECLARATIONS to all direct base-classes.
        Global macro change #3: Rename ANIMATED_PROPERTY_DEFINITIONS to ANIMATED_PROPERTY_DEFINITIONS_REFCOUNTED for refcounted types (ie. SVGTransformList*).

        Added test: svg/custom/svg-xml-dom-sync.html
        Fixed test: svg/hixie/dynamic/005-broken.xml (renamed to 005.xml)

        * dom/Element.cpp:
        (WebCore::Element::Element): Initialize the two new bits.
        (WebCore::Element::attributes): Add hooks to call into SVG attribute synchronization code, wrapped in ENABLE(SVG) blocks.
        (WebCore::Element::getAttribute): Ditto.
        (WebCore::Element::hasAttributes): Ditto.
        * dom/Element.h: Add two bits: m_synchronizedSVGAttributes/m_synchronizingSVGAttribute, to track synchronization status.
        (WebCore::Element::updateAnimatedSVGAttribute): New virtual function, handling the synronication, similar to updateStyleAttribute.
        * dom/NamedAttrMap.h: Make addAttribute/removeAttribute protected, from use within the ANIMATED_* macros.
        * svg/SVGAElement.h: Apply global macro change for ANIMATED_PROPERTY_FORWARD_DECLARATIONS.
        (WebCore::SVGAElement::contextElement): Return non-const value.
        * svg/SVGAltGlyphElement.h:
        (WebCore::SVGAltGlyphElement::contextElement): Ditto.
        * svg/SVGAnimateElement.h:
        (WebCore::SVGAnimateElement::contextElement): Ditto.
        * svg/SVGAnimateMotionElement.h:
        (WebCore::SVGAnimateMotionElement::contextElement): Ditto.
        * svg/SVGAnimateTransformElement.h:
        (WebCore::SVGAnimateTransformElement::contextElement): Ditto.
        * svg/SVGAnimatedTemplate.h: Add toString() conversion to all SVGAnimated* classes
        (WebCore::SVGAnimatedTemplate::toString):
        (WebCore::SVGAnimatedTemplate::associatedAttributeName):
        (WebCore::lookupOrCreateWrapper):
        (WebCore::SVGAnimatedAngle::SVGAnimatedAngle): 
        (WebCore::SVGAnimatedAngle::toString):
        (WebCore::SVGAnimatedBoolean::SVGAnimatedBoolean):
        (WebCore::SVGAnimatedBoolean::toString):
        (WebCore::SVGAnimatedEnumeration::SVGAnimatedEnumeration):
        (WebCore::SVGAnimatedEnumeration::toString):
        (WebCore::SVGAnimatedInteger::SVGAnimatedInteger):
        (WebCore::SVGAnimatedInteger::toString):
        (WebCore::SVGAnimatedLength::SVGAnimatedLength):
        (WebCore::SVGAnimatedLength::toString):
        (WebCore::SVGAnimatedLengthList::SVGAnimatedLengthList):
        (WebCore::SVGAnimatedLengthList::toString):
        (WebCore::SVGAnimatedNumber::SVGAnimatedNumber):
        (WebCore::SVGAnimatedNumber::toString):
        (WebCore::SVGAnimatedNumberList::SVGAnimatedNumberList):
        (WebCore::SVGAnimatedNumberList::toString):
        (WebCore::SVGAnimatedPreserveAspectRatio::SVGAnimatedPreserveAspectRatio):
        (WebCore::SVGAnimatedPreserveAspectRatio::toString):
        (WebCore::SVGAnimatedRect::SVGAnimatedRect):
        (WebCore::SVGAnimatedRect::toString):
        (WebCore::SVGAnimatedString::SVGAnimatedString):
        (WebCore::SVGAnimatedString::toString):
        (WebCore::SVGAnimatedTransformList::SVGAnimatedTransformList):
        (WebCore::SVGAnimatedTransformList::toString):
        (WebCore::SVGAnimatedType::SVGAnimatedType):
        * svg/SVGAnimationElement.h: Apply global macro change for ANIMATED_PROPERTY_FORWARD_DECLARATIONS.
        * svg/SVGCircleElement.h: Apply global macro change for ANIMATED_PROPERTY_FORWARD_DECLARATIONS.
        (WebCore::SVGCircleElement::contextElement): Return non-const value.
        * svg/SVGClipPathElement.h: Apply global macro change for ANIMATED_PROPERTY_FORWARD_DECLARATIONS.
        (WebCore::SVGClipPathElement::contextElement): Return non-const value.
        * svg/SVGComponentTransferFunctionElement.cpp: Apply ANIMATED_PROPERTY_DEFINITIONS_REFCOUNTED change.
        * svg/SVGComponentTransferFunctionElement.h: Add ANIMATED_PROPERTY_START_DECLARATIONS, as this class is a base class.
        * svg/SVGCursorElement.cpp: Wrap SVGLength objects in SVGLength() statements.
        (WebCore::SVGCursorElement::SVGCursorElement):
        * svg/SVGCursorElement.h: Apply global macro change for ANIMATED_PROPERTY_FORWARD_DECLARATIONS. Add ANIMATED_PROPERTY_START_DECLARATIONS.
        (WebCore::SVGCursorElement::contextElement): Return non-const value.
        * svg/SVGDefsElement.h: Apply global macro change for ANIMATED_PROPERTY_FORWARD_DECLARATIONS.
        (WebCore::SVGDefsElement::contextElement): Return non-const value.
        * svg/SVGElement.cpp:
        (WebCore::SVGElement::updateAnimatedSVGAttribute): Override virtual function from Element, to handle SVG<->XML DOM synchronization.
        (WebCore::SVGElement::setSynchronizedSVGAttributes):
        * svg/SVGElement.h: Add helper class "StoredTypeWithDirtyFlag".
        (StoredTypeWithDirtyFlag::StoredTypeWithDirtyFlag): Tracks a type and a flag indicating that SVG<->XML DOM synchronization has to be done.
        (StoredTypeWithDirtyFlag::operator=):
        (StoredTypeWithDirtyFlag::operator==):
        (StoredTypeWithDirtyFlag::operator!=):
        (StoredTypeWithDirtyFlag::operator StoredType):
        (WebCore::SVGElement::invokeSVGPropertySynchronizer): New set of functions taking care of invoking the update handlers.
        (WebCore::SVGElement::invokeAllSVGPropertySynchronizers): Ditto.
        (WebCore::SVGElement::addSVGPropertySynchronizer): Ditto.
        * svg/SVGEllipseElement.cpp: Wrap SVGLength objects in SVGLength() statements.
        (WebCore::SVGEllipseElement::SVGEllipseElement):
        * svg/SVGEllipseElement.h: Apply global macro change for ANIMATED_PROPERTY_FORWARD_DECLARATIONS.
        (WebCore::SVGEllipseElement::contextElement): Return non-const value.
        * svg/SVGExternalResourcesRequired.h: Change contextElement() to return a non-const value.
        * svg/SVGFEBlendElement.h:
        (WebCore::SVGFEBlendElement::contextElement): Return non-const value.
        * svg/SVGFEColorMatrixElement.cpp: Apply ANIMATED_PROPERTY_DEFINITIONS_REFCOUNTED change.
        * svg/SVGFEColorMatrixElement.h:
        (WebCore::SVGFEColorMatrixElement::contextElement): Return non-const value.
        * svg/SVGFEComponentTransferElement.h:
        (WebCore::SVGFEComponentTransferElement::contextElement): Return non-const value.
        * svg/SVGFECompositeElement.h:
        (WebCore::SVGFECompositeElement::contextElement): Return non-const value.
        * svg/SVGFEDiffuseLightingElement.h:
        (WebCore::SVGFEDiffuseLightingElement::contextElement): Return non-const value.
        * svg/SVGFEDisplacementMapElement.h:
        (WebCore::SVGFEDisplacementMapElement::contextElement): Return non-const value.
        * svg/SVGFEFloodElement.h:
        (WebCore::SVGFEFloodElement::contextElement): Return non-const value.
        * svg/SVGFEGaussianBlurElement.h:
        (WebCore::SVGFEGaussianBlurElement::contextElement): Return non-const value.
        * svg/SVGFEImageElement.cpp: Apply ANIMATED_PROPERTY_DEFINITIONS_REFCOUNTED change.
        * svg/SVGFEImageElement.h: Apply global macro change for ANIMATED_PROPERTY_FORWARD_DECLARATIONS.
        (WebCore::SVGFEImageElement::contextElement): Return non-const value.
        * svg/SVGFELightElement.h: Add ANIMATED_PROPERTY_START_DECLARATIONS, as this is a base class.
        * svg/SVGFEMergeElement.h:
        (WebCore::SVGFEMergeElement::contextElement): Return non-const value.
        * svg/SVGFEMergeNodeElement.h: Add ANIMATED_PROPERTY_START_DECLARATIONS, as this is a base class.
        (WebCore::SVGFEMergeNodeElement::contextElement): Return non-const value.
        * svg/SVGFEOffsetElement.h:
        (WebCore::SVGFEOffsetElement::contextElement): Return non-const value.
        * svg/SVGFESpecularLightingElement.h:
        (WebCore::SVGFESpecularLightingElement::contextElement): Return non-const value.
        * svg/SVGFETileElement.h:
        (WebCore::SVGFETileElement::contextElement): Return non-const value.
        * svg/SVGFETurbulenceElement.h:
        (WebCore::SVGFETurbulenceElement::contextElement): Return non-const value.
        * svg/SVGFilterElement.cpp: Wrap SVGLength objects in SVGLength() statements.
        (WebCore::SVGFilterElement::SVGFilterElement):
        * svg/SVGFilterElement.h: Apply global macro change for ANIMATED_PROPERTY_FORWARD_DECLARATIONS.
        (WebCore::SVGFilterElement::contextElement): Return non-const value.
        * svg/SVGFilterPrimitiveStandardAttributes.cpp: Wrap SVGLength objects in SVGLength() statements.
        (WebCore::SVGFilterPrimitiveStandardAttributes::SVGFilterPrimitiveStandardAttributes):
        * svg/SVGFilterPrimitiveStandardAttributes.h: Apply global macro change for ANIMATED_PROPERTY_FORWARD_DECLARATIONS.
        (WebCore::SVGFilterPrimitiveStandardAttributes::contextElement): Return non-const value.
        * svg/SVGFitToViewBox.cpp: Apply ANIMATED_PROPERTY_DEFINITIONS_REFCOUNTED change.
        * svg/SVGFitToViewBox.h: Change contextElement() to return a non-const value.
        * svg/SVGFontElement.h:
        (WebCore::SVGFontElement::contextElement): Return non-const value.
        * svg/SVGForeignObjectElement.cpp: Wrap SVGLength objects in SVGLength() statements.
        (WebCore::SVGForeignObjectElement::SVGForeignObjectElement):
        * svg/SVGForeignObjectElement.h: Apply global macro change for ANIMATED_PROPERTY_FORWARD_DECLARATIONS.
        (WebCore::SVGForeignObjectElement::contextElement): Return non-const value.
        * svg/SVGGElement.h: Apply global macro change for ANIMATED_PROPERTY_FORWARD_DECLARATIONS.
        (WebCore::SVGGElement::contextElement): Return non-const value.
        * svg/SVGGradientElement.cpp: Apply ANIMATED_PROPERTY_DEFINITIONS_REFCOUNTED change.
        * svg/SVGGradientElement.h: Apply global macro change for ANIMATED_PROPERTY_FORWARD_DECLARATIONS.
        * svg/SVGImageElement.cpp: Apply ANIMATED_PROPERTY_DEFINITIONS_REFCOUNTED change. Wrap SVGLength objects in SVGLength() statements.
        (WebCore::SVGImageElement::SVGImageElement):
        * svg/SVGImageElement.h: Apply global macro change for ANIMATED_PROPERTY_FORWARD_DECLARATIONS.
        (WebCore::SVGImageElement::contextElement): Return non-const value.
        * svg/SVGLengthList.cpp:
        (WebCore::SVGLengthList::valueAsString): Add new function converting SVG values to strings.
        * svg/SVGLengthList.h:
        * svg/SVGLineElement.cpp: Wrap SVGLength objects in SVGLength() statements.
        (WebCore::SVGLineElement::SVGLineElement):
        * svg/SVGLineElement.h: Apply global macro change for ANIMATED_PROPERTY_FORWARD_DECLARATIONS.
        (WebCore::SVGLineElement::contextElement): Return non-const value.
        * svg/SVGLinearGradientElement.cpp:
        (WebCore::SVGLinearGradientElement::SVGLinearGradientElement): Wrap SVGLength objects in SVGLength() statements.
        (WebCore::SVGLinearGradientElement::collectGradientProperties):
        * svg/SVGLinearGradientElement.h:
        (WebCore::SVGLinearGradientElement::contextElement): Return non-const value.
        * svg/SVGMPathElement.h:
        (WebCore::SVGMPathElement::contextElement): Return non-const value.
        * svg/SVGMarkerElement.cpp: Apply ANIMATED_PROPERTY_DEFINITIONS_REFCOUNTED change. Wrap SVGLength objects in SVGLength() statements.
        (WebCore::SVGMarkerElement::SVGMarkerElement):
        * svg/SVGMarkerElement.h: Apply global macro change for ANIMATED_PROPERTY_FORWARD_DECLARATIONS.
        (WebCore::SVGMarkerElement::contextElement): Return non-const value.
        * svg/SVGMaskElement.cpp: Wrap SVGLength objects in SVGLength() statements.
        (WebCore::SVGMaskElement::SVGMaskElement):
        * svg/SVGMaskElement.h: Apply global macro change for ANIMATED_PROPERTY_FORWARD_DECLARATIONS.
        (WebCore::SVGMaskElement::contextElement): Return non-const value.
        * svg/SVGNumberList.cpp:
        (WebCore::SVGNumberList::valueAsString): Add new function converting SVG values to strings.
        * svg/SVGNumberList.h:
        * svg/SVGPathElement.h: Apply global macro change for ANIMATED_PROPERTY_FORWARD_DECLARATIONS.
        (WebCore::SVGPathElement::contextElement): Return non-const value.
        * svg/SVGPatternElement.cpp: Apply ANIMATED_PROPERTY_DEFINITIONS_REFCOUNTED change. Wrap SVGLength objects in SVGLength() statements.
        (WebCore::SVGPatternElement::SVGPatternElement):
        (WebCore::SVGPatternElement::collectPatternProperties):
        * svg/SVGPatternElement.h: Apply global macro change for ANIMATED_PROPERTY_FORWARD_DECLARATIONS.
        (WebCore::SVGPatternElement::contextElement): Return non-const value.
        * svg/SVGPolyElement.h: Apply global macro change for ANIMATED_PROPERTY_FORWARD_DECLARATIONS.
        (WebCore::SVGPolyElement::contextElement): Return non-const value.
        * svg/SVGPreserveAspectRatio.cpp:
        (WebCore::SVGPreserveAspectRatio::valueAsString): Add new function converting SVG values to strings.
        * svg/SVGPreserveAspectRatio.h:
        * svg/SVGRadialGradientElement.cpp: Wrap SVGLength objects in SVGLength() statements.
        (WebCore::SVGRadialGradientElement::SVGRadialGradientElement):
        (WebCore::SVGRadialGradientElement::svgAttributeChanged):
        (WebCore::SVGRadialGradientElement::collectGradientProperties):
        * svg/SVGRadialGradientElement.h:
        (WebCore::SVGRadialGradientElement::contextElement): Return non-const value.
        * svg/SVGRectElement.cpp: Wrap SVGLength objects in SVGLength() statements.
        (WebCore::SVGRectElement::SVGRectElement):
        * svg/SVGRectElement.h: Apply global macro change for ANIMATED_PROPERTY_FORWARD_DECLARATIONS.
        (WebCore::SVGRectElement::contextElement): Return non-const value.
        * svg/SVGSVGElement.cpp: Wrap SVGLength objects in SVGLength() statements.
        (WebCore::SVGSVGElement::SVGSVGElement):
        (WebCore::SVGSVGElement::currentView): Pass non-const SVGSVGElement* object to SVGViewSpec.
        * svg/SVGSVGElement.h: Apply global macro change for ANIMATED_PROPERTY_FORWARD_DECLARATIONS.
        (WebCore::SVGSVGElement::contextElement): Return non-const value.
        * svg/SVGScriptElement.h: Apply global macro change for ANIMATED_PROPERTY_FORWARD_DECLARATIONS.
        (WebCore::SVGScriptElement::contextElement): Return non-const value.
        * svg/SVGStyledElement.h: Add ANIMATED_PROPERTY_START_DECLARATIONS, as this is a base class.
        * svg/SVGStyledTransformableElement.cpp: Apply ANIMATED_PROPERTY_DEFINITIONS_REFCOUNTED change.
        * svg/SVGStyledTransformableElement.h:
        * svg/SVGSwitchElement.h: Apply global macro change for ANIMATED_PROPERTY_FORWARD_DECLARATIONS.
        (WebCore::SVGSwitchElement::contextElement): Return non-const value.
        * svg/SVGSymbolElement.h: Apply global macro change for ANIMATED_PROPERTY_FORWARD_DECLARATIONS.
        (WebCore::SVGSymbolElement::contextElement): Return non-const value.
        * svg/SVGTRefElement.h: Apply global macro change for ANIMATED_PROPERTY_FORWARD_DECLARATIONS.
        (WebCore::SVGTRefElement::contextElement): Return non-const value.
        * svg/SVGTSpanElement.h:
        (WebCore::SVGTSpanElement::contextElement): Return non-const value.
        * svg/SVGTextContentElement.cpp: Wrap SVGLength objects in SVGLength() statements.
        (WebCore::SVGTextContentElement::SVGTextContentElement):
        * svg/SVGTextContentElement.h: Apply global macro change for ANIMATED_PROPERTY_FORWARD_DECLARATIONS.
        * svg/SVGTextElement.cpp: Apply ANIMATED_PROPERTY_DEFINITIONS_REFCOUNTED change.
        * svg/SVGTextElement.h:
        (WebCore::SVGTextElement::contextElement): Return non-const value.
        * svg/SVGTextPathElement.cpp: Wrap SVGLength objects in SVGLength() statements.
        (WebCore::SVGTextPathElement::SVGTextPathElement):
        * svg/SVGTextPathElement.h: Apply global macro change for ANIMATED_PROPERTY_FORWARD_DECLARATIONS.
        (WebCore::SVGTextPathElement::contextElement): Return non-const value.
        * svg/SVGTextPositioningElement.cpp: Apply ANIMATED_PROPERTY_DEFINITIONS_REFCOUNTED change.
        * svg/SVGTextPositioningElement.h:
        * svg/SVGTransformList.cpp:
        (SVGTransformList::valueAsString): Add new function converting SVG values to strings.
        * svg/SVGTransformList.h:
        * svg/SVGURIReference.h: Change contextElement() to return a non-const value.
        * svg/SVGUseElement.cpp: Wrap SVGLength objects in SVGLength() statements.
        (WebCore::SVGUseElement::SVGUseElement):
        * svg/SVGUseElement.h: Apply global macro change for ANIMATED_PROPERTY_FORWARD_DECLARATIONS.
        (WebCore::SVGUseElement::contextElement): Return non-const value.
        * svg/SVGViewElement.h: Apply global macro change for ANIMATED_PROPERTY_FORWARD_DECLARATIONS.
        (WebCore::SVGViewElement::contextElement): Return non-const value.
        * svg/SVGViewSpec.cpp:
        (WebCore::SVGViewSpec::SVGViewSpec): Pass non-const context element in constructor.
        (WebCore::SVGViewSpec::contextElement): Return non-const value.
        * svg/SVGViewSpec.h:

2008-07-01  Alex Mathews  <possessedpenguinbob@gmail.com>

        Reviewed by Nikolas Zimmermann.

        Class name changes for SVG Light Effect files. The class names that changed :

        SVGLightSource -> LightSource
        SVGDistantLightSource -> DistantLightSource
        SVGPointLightSource -> PointLightSource
        SVGSpotLightSource -> SpotLightSource

        Every other file that is changed is just propagating the class name changes to
        dependent files.

        * svg/SVGFEDiffuseLightingElement.cpp:
        (WebCore::SVGFEDiffuseLightingElement::updateLights):
        * svg/SVGFEDistantLightElement.cpp:
        (WebCore::SVGFEDistantLightElement::lightSource):
        * svg/SVGFEDistantLightElement.h:
        * svg/SVGFELightElement.h:
        * svg/SVGFEPointLightElement.cpp:
        (WebCore::SVGFEPointLightElement::lightSource):
        * svg/SVGFEPointLightElement.h:
        * svg/SVGFESpecularLightingElement.cpp:
        (WebCore::SVGFESpecularLightingElement::updateLights):
        * svg/SVGFESpotLightElement.cpp:
        (WebCore::SVGFESpotLightElement::lightSource):
        * svg/SVGFESpotLightElement.h:
        * svg/graphics/filters/SVGDistantLightSource.h:
        (WebCore::DistantLightSource::DistantLightSource):
        (WebCore::DistantLightSource::azimuth):
        (WebCore::DistantLightSource::elevation):
        * svg/graphics/filters/SVGFEDiffuseLighting.cpp:
        (WebCore::SVGFEDiffuseLighting::lightSource):
        (WebCore::SVGFEDiffuseLighting::setLightSource):
        * svg/graphics/filters/SVGFEDiffuseLighting.h:
        * svg/graphics/filters/SVGFESpecularLighting.cpp:
        (WebCore::SVGFESpecularLighting::lightSource):
        (WebCore::SVGFESpecularLighting::setLightSource):
        * svg/graphics/filters/SVGFESpecularLighting.h:
        * svg/graphics/filters/SVGLightSource.cpp:
        (WebCore::PointLightSource::externalRepresentation):
        (WebCore::SpotLightSource::externalRepresentation):
        (WebCore::DistantLightSource::externalRepresentation):
        * svg/graphics/filters/SVGLightSource.h:
        (WebCore::):
        (WebCore::LightSource::LightSource):
        (WebCore::LightSource::~LightSource):
        (WebCore::LightSource::type):
        * svg/graphics/filters/SVGPointLightSource.h:
        (WebCore::PointLightSource::PointLightSource):
        (WebCore::PointLightSource::position):
        * svg/graphics/filters/SVGSpotLightSource.h:
        (WebCore::SpotLightSource::SpotLightSource):
        (WebCore::SpotLightSource::position):
        (WebCore::SpotLightSource::direction):
        (WebCore::SpotLightSource::specularExponent):
        (WebCore::SpotLightSource::limitingConeAngle):
        * svg/graphics/filters/cg/SVGFEDiffuseLightingCg.mm:
        (WebCore::SVGFEDiffuseLighting::getCIFilter):
        * svg/graphics/filters/cg/SVGFEHelpersCg.h:
        * svg/graphics/filters/cg/SVGFEHelpersCg.mm:
        (WebCore::getLightVectors):
        * svg/graphics/filters/cg/SVGFESpecularLightingCg.mm:
        (WebCore::SVGFESpecularLighting::getCIFilter):

2008-07-01  Alp Toker  <alp@nuanti.com>

        Rubber-stamped by Holger.

        autotools cleanup: move some GTK+-specific sources from libwebcore to
        libwebcoregtk.

        * GNUmakefile.am:

2008-07-01  Dan Bernstein  <mitz@apple.com>

        Reviewed by Oliver Hunt.

        - fix the non-SVG build

        * css/CSSValueKeywords.in: Added 'all'.
        * css/SVGCSSValueKeywords.in: Removed 'all'.

